//this file is part of eMule
//Copyright (C)2002-2005 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include <io.h>
#include <share.h>
#include <iphlpapi.h>
#include "emule.h"
#include "Preferences.h"
#include "Opcodes.h"
#include "OtherFunctions.h"
#include "Ini2.h"
#include "DownloadQueue.h"
#include "UploadQueue.h"
#include "Statistics.h"
#include "MD5Sum.h"
#include "PartFile.h"
#include "Sockets.h"
#include "ListenSocket.h"
#include "ServerList.h"
#include "SharedFileList.h"
#include "UpDownClient.h"
#include "SafeFile.h"
#include "emuledlg.h"
#include "StatisticsDlg.h"
#include "Log.h"
#include "VistaDefines.h"
#include "LastCommonRouteFinder.h" //==> dlarge SUC/USS
#include "EMF/ModFunctionsFiles/defaults.h" 
#include "EMF/Argos/Argos.h" //==> dlarge Argos System (Xanatos)
#include "EMF/ModName/Modname.h" //==> dlarge Modname
#include "./EMF/ModIcon/ModIconMapping.h" //>>> shadow2004::ModIconDLL Update
#include "ClientCredits.h" //==> dlarge CreditSystem

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CPreferences thePrefs;

CString CPreferences::m_astrDefaultDirs[13];
bool	CPreferences::m_abDefaultDirsCreated[13] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int		CPreferences::m_nCurrentUserDirMode = -1;
int		CPreferences::m_iDbgHeap;
CString	CPreferences::strNick;
uint16	CPreferences::minupload;
uint16	CPreferences::maxupload;
uint16	CPreferences::maxdownload;
LPCSTR	CPreferences::m_pszBindAddrA;
CStringA CPreferences::m_strBindAddrA;
LPCWSTR	CPreferences::m_pszBindAddrW;
CStringW CPreferences::m_strBindAddrW;
uint16	CPreferences::port;
uint16	CPreferences::udpport;
uint16	CPreferences::nServerUDPPort;
UINT	CPreferences::maxconnections;
UINT	CPreferences::maxhalfconnections;
bool	CPreferences::m_bConditionalTCPAccept;
bool	CPreferences::reconnect;
bool	CPreferences::m_bUseServerPriorities;
bool	CPreferences::m_bUseUserSortedServerList;
CString	CPreferences::m_strIncomingDir;
CStringArray CPreferences::tempdir;
bool	CPreferences::ICH;
bool	CPreferences::m_bAutoUpdateServerList;
bool	CPreferences::updatenotify;
bool	CPreferences::mintotray;
bool	CPreferences::autoconnect;
bool	CPreferences::m_bAutoConnectToStaticServersOnly;
bool	CPreferences::autotakeed2klinks;
bool	CPreferences::addnewfilespaused;
UINT	CPreferences::depth3D;
bool	CPreferences::m_bEnableMiniMule;
bool	CPreferences::m_bMiniMuleAutoClose; //==> dlarge Hidden Prefs
int		CPreferences::m_iStraightWindowStyles;
bool	CPreferences::m_bUseSystemFontForMainControls;
bool	CPreferences::m_bRTLWindowsLayout;
bool	CPreferences::m_bAddServersFromServer;
bool	CPreferences::m_bAddServersFromClients;
UINT	CPreferences::maxsourceperfile;
UINT	CPreferences::trafficOMeterInterval;
UINT	CPreferences::statsInterval;
bool	CPreferences::m_bFillGraphs;
uchar	CPreferences::userhash[16];
WINDOWPLACEMENT CPreferences::EmuleWindowPlacement;
int		CPreferences::maxGraphDownloadRate;
int		CPreferences::maxGraphUploadRate;
uint32	CPreferences::maxGraphUploadRateEstimated = 0;
bool	CPreferences::beepOnError;
bool	CPreferences::m_bIconflashOnNewMessage;
bool	CPreferences::confirmExit;
//==> dlarge Source Graph 
/*
DWORD	CPreferences::m_adwStatsColors[15];
*/
DWORD	CPreferences::m_adwStatsColors[16];
//<== dlarge Source Graph
bool	CPreferences::splashscreen;
bool	CPreferences::filterLANIPs;
bool	CPreferences::m_bAllocLocalHostIP;
bool	CPreferences::onlineSig;
uint64	CPreferences::cumDownOverheadTotal;
uint64	CPreferences::cumDownOverheadFileReq;
uint64	CPreferences::cumDownOverheadSrcEx;
uint64	CPreferences::cumDownOverheadServer;
uint64	CPreferences::cumDownOverheadKad;
uint64	CPreferences::cumDownOverheadTotalPackets;
uint64	CPreferences::cumDownOverheadFileReqPackets;
uint64	CPreferences::cumDownOverheadSrcExPackets;
uint64	CPreferences::cumDownOverheadServerPackets;
uint64	CPreferences::cumDownOverheadKadPackets;
uint64	CPreferences::cumUpOverheadTotal;
uint64	CPreferences::cumUpOverheadFileReq;
uint64	CPreferences::cumUpOverheadSrcEx;
uint64	CPreferences::cumUpOverheadServer;
uint64	CPreferences::cumUpOverheadKad;
uint64	CPreferences::cumUpOverheadTotalPackets;
uint64	CPreferences::cumUpOverheadFileReqPackets;
uint64	CPreferences::cumUpOverheadSrcExPackets;
uint64	CPreferences::cumUpOverheadServerPackets;
uint64	CPreferences::cumUpOverheadKadPackets;
uint32	CPreferences::cumUpSuccessfulSessions;
uint32	CPreferences::cumUpFailedSessions;
uint32	CPreferences::cumUpAvgTime;
uint64	CPreferences::cumUpData_EDONKEY;
uint64	CPreferences::cumUpData_EDONKEYHYBRID;
uint64	CPreferences::cumUpData_EMULE;
uint64	CPreferences::cumUpData_MLDONKEY;
uint64	CPreferences::cumUpData_AMULE;
uint64	CPreferences::cumUpData_EMULECOMPAT;
uint64	CPreferences::cumUpData_SHAREAZA;
uint64	CPreferences::sesUpData_EDONKEY;
uint64	CPreferences::sesUpData_EDONKEYHYBRID;
uint64	CPreferences::sesUpData_EMULE;
uint64	CPreferences::sesUpData_MLDONKEY;
uint64	CPreferences::sesUpData_AMULE;
uint64	CPreferences::sesUpData_EMULECOMPAT;
uint64	CPreferences::sesUpData_SHAREAZA;
uint64	CPreferences::cumUpDataPort_4662;
uint64	CPreferences::cumUpDataPort_OTHER;
uint64	CPreferences::cumUpDataPort_PeerCache;
uint64	CPreferences::sesUpDataPort_4662;
uint64	CPreferences::sesUpDataPort_OTHER;
uint64	CPreferences::sesUpDataPort_PeerCache;
uint64	CPreferences::cumUpData_File;
uint64	CPreferences::cumUpData_Partfile;
uint64	CPreferences::sesUpData_File;
uint64	CPreferences::sesUpData_Partfile;
uint32	CPreferences::cumDownCompletedFiles;
uint32	CPreferences::cumDownSuccessfulSessions;
uint32	CPreferences::cumDownFailedSessions;
uint32	CPreferences::cumDownAvgTime;
uint64	CPreferences::cumLostFromCorruption;
uint64	CPreferences::cumSavedFromCompression;
uint32	CPreferences::cumPartsSavedByICH;
uint32	CPreferences::sesDownSuccessfulSessions;
uint32	CPreferences::sesDownFailedSessions;
uint32	CPreferences::sesDownAvgTime;
uint32	CPreferences::sesDownCompletedFiles;
uint64	CPreferences::sesLostFromCorruption;
uint64	CPreferences::sesSavedFromCompression;
uint32	CPreferences::sesPartsSavedByICH;
uint64	CPreferences::cumDownData_EDONKEY;
uint64	CPreferences::cumDownData_EDONKEYHYBRID;
uint64	CPreferences::cumDownData_EMULE;
uint64	CPreferences::cumDownData_MLDONKEY;
uint64	CPreferences::cumDownData_AMULE;
uint64	CPreferences::cumDownData_EMULECOMPAT;
uint64	CPreferences::cumDownData_SHAREAZA;
uint64	CPreferences::cumDownData_URL;
uint64	CPreferences::sesDownData_EDONKEY;
uint64	CPreferences::sesDownData_EDONKEYHYBRID;
uint64	CPreferences::sesDownData_EMULE;
uint64	CPreferences::sesDownData_MLDONKEY;
uint64	CPreferences::sesDownData_AMULE;
uint64	CPreferences::sesDownData_EMULECOMPAT;
uint64	CPreferences::sesDownData_SHAREAZA;
uint64	CPreferences::sesDownData_URL;
uint64	CPreferences::cumDownDataPort_4662;
uint64	CPreferences::cumDownDataPort_OTHER;
uint64	CPreferences::cumDownDataPort_PeerCache;
uint64	CPreferences::sesDownDataPort_4662;
uint64	CPreferences::sesDownDataPort_OTHER;
uint64	CPreferences::sesDownDataPort_PeerCache;
float	CPreferences::cumConnAvgDownRate;
float	CPreferences::cumConnMaxAvgDownRate;
float	CPreferences::cumConnMaxDownRate;
float	CPreferences::cumConnAvgUpRate;
float	CPreferences::cumConnMaxAvgUpRate;
float	CPreferences::cumConnMaxUpRate;
time_t	CPreferences::cumConnRunTime;
uint32	CPreferences::cumConnNumReconnects;
uint32	CPreferences::cumConnAvgConnections;
uint32	CPreferences::cumConnMaxConnLimitReached;
uint32	CPreferences::cumConnPeakConnections;
uint32	CPreferences::cumConnTransferTime;
uint32	CPreferences::cumConnDownloadTime;
uint32	CPreferences::cumConnUploadTime;
uint32	CPreferences::cumConnServerDuration;
uint32	CPreferences::cumSrvrsMostWorkingServers;
uint32	CPreferences::cumSrvrsMostUsersOnline;
uint32	CPreferences::cumSrvrsMostFilesAvail;
uint32	CPreferences::cumSharedMostFilesShared;
uint64	CPreferences::cumSharedLargestShareSize;
uint64	CPreferences::cumSharedLargestAvgFileSize;
uint64	CPreferences::cumSharedLargestFileSize;
time_t	CPreferences::stat_datetimeLastReset;
UINT	CPreferences::statsConnectionsGraphRatio;
UINT	CPreferences::statsSaveInterval;
CString	CPreferences::m_strStatsExpandedTreeItems;
bool	CPreferences::m_bShowVerticalHourMarkers;
uint64	CPreferences::totalDownloadedBytes;
uint64	CPreferences::totalUploadedBytes;
WORD	CPreferences::m_wLanguageID;
bool	CPreferences::transferDoubleclick;
EViewSharedFilesAccess CPreferences::m_iSeeShares;
UINT	CPreferences::m_iToolDelayTime;
bool	CPreferences::bringtoforeground;
UINT	CPreferences::splitterbarPosition;
UINT	CPreferences::splitterbarPositionSvr;
UINT	CPreferences::splitterbarPositionStat;
UINT	CPreferences::splitterbarPositionStat_HL;
UINT	CPreferences::splitterbarPositionStat_HR;
UINT	CPreferences::splitterbarPositionFriend;
UINT	CPreferences::splitterbarPositionShared;
UINT	CPreferences::m_uTransferWnd1;
UINT	CPreferences::m_uTransferWnd2;
UINT	CPreferences::m_uDeadServerRetries;
DWORD	CPreferences::m_dwServerKeepAliveTimeout;
UINT	CPreferences::statsMax;
UINT	CPreferences::statsAverageMinutes;
CString	CPreferences::notifierConfiguration;
bool	CPreferences::notifierOnDownloadFinished;
bool	CPreferences::notifierOnNewDownload;
bool	CPreferences::notifierOnChat;
bool	CPreferences::notifierOnLog;
bool	CPreferences::notifierOnImportantError;
bool	CPreferences::notifierOnEveryChatMsg;
bool	CPreferences::notifierOnNewVersion;
ENotifierSoundType CPreferences::notifierSoundType = ntfstNoSound;
CString	CPreferences::notifierSoundFile;
bool	CPreferences::m_bRemove2bin;
bool	CPreferences::m_bShowCopyEd2kLinkCmd;
bool	CPreferences::m_bpreviewprio;
bool	CPreferences::m_bSmartServerIdCheck;
uint8	CPreferences::smartidstate;
bool	CPreferences::m_bSafeServerConnect;
bool	CPreferences::startMinimized;
bool	CPreferences::m_bAutoStart;
bool	CPreferences::m_bRestoreLastMainWndDlg;
int		CPreferences::m_iLastMainWndDlgID;
bool	CPreferences::m_bRestoreLastLogPane;
int		CPreferences::m_iLastLogPaneID;
UINT	CPreferences::MaxConperFive;
bool	CPreferences::checkDiskspace;
UINT	CPreferences::m_uMinFreeDiskSpace;
bool	CPreferences::m_bSparsePartFiles;
CString	CPreferences::m_strYourHostname;
bool	CPreferences::m_bEnableVerboseOptions;
bool	CPreferences::m_bVerbose;
bool	CPreferences::m_bFullVerbose;
bool	CPreferences::m_bDebugSourceExchange;
bool	CPreferences::m_bLogBannedClients;
bool	CPreferences::m_bLogRatingDescReceived;
bool	CPreferences::m_bLogSecureIdent;
bool	CPreferences::m_bLogFilteredIPs;
bool	CPreferences::m_bLogFileSaving;
bool	CPreferences::m_bLogA4AF; // ZZ:DownloadManager
bool	CPreferences::m_bLogUlDlEvents;
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
bool	CPreferences::m_bUseDebugDevice = true;
#else
bool	CPreferences::m_bUseDebugDevice = false;
#endif
int		CPreferences::m_iDebugServerTCPLevel;
int		CPreferences::m_iDebugServerUDPLevel;
int		CPreferences::m_iDebugServerSourcesLevel;
int		CPreferences::m_iDebugServerSearchesLevel;
int		CPreferences::m_iDebugClientTCPLevel;
int		CPreferences::m_iDebugClientUDPLevel;
int		CPreferences::m_iDebugClientKadUDPLevel;
int		CPreferences::m_iDebugSearchResultDetailLevel;
bool	CPreferences::m_bupdatequeuelist;
bool	CPreferences::m_bManualAddedServersHighPriority;
//bool	CPreferences::m_btransferfullchunks; // VQB: fullChunk
uint8	CPreferences::m_uiFUChunks;
//>>> WiZaRd::AutoHL
uint16	CPreferences::m_iAutoHLUpdateTimer;
uint16	CPreferences::m_iMinAutoHL;
uint16	CPreferences::m_iMaxAutoHL;
sint8	CPreferences::m_iUseAutoHL;
uint16  CPreferences::m_iMaxSourcesHL;
//<<< WiZaRd::AutoHL
//>>> shadow2004::FDC [BlueSonicBoy]
bool	CPreferences::m_bFDCEnabled;
bool	CPreferences::m_bFDCDouble;
uint8   CPreferences::m_uiFDCSensitivity;
//<<< shadow2004::FDC [BlueSonicBoy]
//>>> Spike2::Emulate other
bool	CPreferences::m_bEmueDonkey;
bool	CPreferences::m_bEmueDonkeyHybrid;
bool	CPreferences::m_bEmuMLDonkey;
bool	CPreferences::m_bEmuShareaza;
bool	CPreferences::m_bEmuLphant;
//<<< Spike2::Emulate other
//>>> WiZaRd::ServerMessageFilter
bool	CPreferences::m_bBlockServerMessagesCompletely;
CString	CPreferences::m_strServerMessageFilter;
//<<< WiZaRd::ServerMessageFilter
//>>> shadow2004::Toolbar
uint8	CPreferences::m_uiToolbarLabelStyle;
//<<< shadow2004::Toolbar
int		CPreferences::m_istartnextfile;
bool	CPreferences::m_bshowoverhead;
bool	CPreferences::m_bDAP;
bool	CPreferences::m_bUAP;
bool	CPreferences::m_bDisableKnownClientList;
bool	CPreferences::m_bDisableQueueList;
bool	CPreferences::m_bExtControls;
bool	CPreferences::m_bTransflstRemain;
UINT	CPreferences::versioncheckdays;
bool	CPreferences::showRatesInTitle;
CString	CPreferences::m_strTxtEditor;
CString	CPreferences::m_strVideoPlayer;
CString CPreferences::m_strVideoPlayerArgs;
bool	CPreferences::moviePreviewBackup;
int		CPreferences::m_iPreviewSmallBlocks;
bool	CPreferences::m_bPreviewCopiedArchives;
int		CPreferences::m_iInspectAllFileTypes;
bool	CPreferences::m_bPreviewOnIconDblClk;
bool	CPreferences::indicateratings;
bool	CPreferences::watchclipboard;
bool	CPreferences::filterserverbyip;
bool	CPreferences::m_bFirstStart;
bool	CPreferences::m_bCreditSystem;
bool	CPreferences::log2disk;
bool	CPreferences::debug2disk;
int		CPreferences::iMaxLogBuff;
UINT	CPreferences::uMaxLogFileSize;
ELogFileFormat CPreferences::m_iLogFileFormat = Unicode;
bool	CPreferences::scheduler;
bool	CPreferences::dontcompressavi;
bool	CPreferences::msgonlyfriends;
bool	CPreferences::msgsecure;
bool	CPreferences::m_bUseChatCaptchas;
UINT	CPreferences::filterlevel;
UINT	CPreferences::m_iFileBufferSize;
//>>> WiZaRd::IntelliFlush
bool	CPreferences::m_bUseIntelliFlush;
UINT	CPreferences::m_uiFileBufferFlushTime;
//<<< WiZaRd::IntelliFlush
UINT	CPreferences::m_iQueueSize;
int		CPreferences::m_iCommitFiles;
UINT	CPreferences::maxmsgsessions;
uint32	CPreferences::versioncheckLastAutomatic;
CString	CPreferences::messageFilter;
CString	CPreferences::commentFilter;
CString	CPreferences::filenameCleanups;
CString	CPreferences::m_strDateTimeFormat;
CString	CPreferences::m_strDateTimeFormat4Log;
LOGFONT CPreferences::m_lfHyperText;
LOGFONT CPreferences::m_lfLogText;
COLORREF CPreferences::m_crLogError = RGB(255, 0, 0);
COLORREF CPreferences::m_crLogWarning = RGB(128, 0, 128);
COLORREF CPreferences::m_crLogSuccess = RGB(0, 0, 255);
int		CPreferences::m_iExtractMetaData;
bool	CPreferences::m_bAdjustNTFSDaylightFileTime = true;
CString	CPreferences::m_strWebPassword;
CString	CPreferences::m_strWebLowPassword;
CUIntArray CPreferences::m_aAllowedRemoteAccessIPs;
uint16	CPreferences::m_nWebPort;
bool	CPreferences::m_bWebEnabled;
bool	CPreferences::m_bWebUseGzip;
int		CPreferences::m_nWebPageRefresh;
bool	CPreferences::m_bWebLowEnabled;
int		CPreferences::m_iWebTimeoutMins;
int		CPreferences::m_iWebFileUploadSizeLimitMB;
bool	CPreferences::m_bAllowAdminHiLevFunc;
CString	CPreferences::m_strTemplateFile;
ProxySettings CPreferences::proxy;
bool	CPreferences::showCatTabInfos;
bool	CPreferences::resumeSameCat;
bool	CPreferences::dontRecreateGraphs;
bool	CPreferences::autofilenamecleanup;
bool	CPreferences::m_bUseAutocompl;
bool	CPreferences::m_bShowDwlPercentage;
bool	CPreferences::m_bRemoveFinishedDownloads;
UINT	CPreferences::m_iMaxChatHistory;
//bool	CPreferences::m_bShowActiveDownloadsBold; //==> dlarge Design Settings 
int		CPreferences::m_iSearchMethod;
bool	CPreferences::m_bAdvancedSpamfilter;
bool	CPreferences::m_bUseSecureIdent;
CString	CPreferences::m_strMMPassword;
bool	CPreferences::m_bMMEnabled;
uint16	CPreferences::m_nMMPort;
bool	CPreferences::networkkademlia;
bool	CPreferences::networked2k;
bool	CPreferences::m_bPreviewEnabled;
bool	CPreferences::m_bAutomaticArcPreviewStart;
bool	CPreferences::m_bDynUpEnabled;
int		CPreferences::m_iDynUpPingTolerance;
int		CPreferences::m_iDynUpGoingUpDivider;
int		CPreferences::m_iDynUpGoingDownDivider;
int		CPreferences::m_iDynUpNumberOfPings;
int		CPreferences::m_iDynUpPingToleranceMilliseconds;
bool	CPreferences::m_bDynUpUseMillisecondPingTolerance;
bool    CPreferences::m_bAllocFull;
// ZZ:DownloadManager -->
bool    CPreferences::m_bA4AFSaveCpu;
// ZZ:DownloadManager <--
bool    CPreferences::m_bHighresTimer;
CStringList CPreferences::shareddir_list;
CStringList CPreferences::addresses_list;
CString CPreferences::m_strFileCommentsFilePath;
Preferences_Ext_Struct* CPreferences::prefsExt;
WORD	CPreferences::m_wWinVer;
CArray<Category_Struct*,Category_Struct*> CPreferences::catMap;
UINT	CPreferences::m_nWebMirrorAlertLevel;
bool	CPreferences::m_bRunAsUser;
bool	CPreferences::m_bPreferRestrictedOverUser;
bool	CPreferences::m_bUseOldTimeRemaining;
uint32	CPreferences::m_uPeerCacheLastSearch;
bool	CPreferences::m_bPeerCacheWasFound;
bool	CPreferences::m_bPeerCacheEnabled;
uint16	CPreferences::m_nPeerCachePort;
bool	CPreferences::m_bPeerCacheShow;

bool	CPreferences::m_bOpenPortsOnStartUp;
int		CPreferences::m_byLogLevel;
bool	CPreferences::m_bTrustEveryHash;
bool	CPreferences::m_bRememberCancelledFiles;
bool	CPreferences::m_bRememberDownloadedFiles;

bool	CPreferences::m_bNotifierSendMail;
CString	CPreferences::m_strNotifierMailServer;
CString	CPreferences::m_strNotifierMailSender;
CString	CPreferences::m_strNotifierMailReceiver;

bool	CPreferences::m_bWinaTransToolbar;

bool	CPreferences::m_bCryptLayerRequested;
bool	CPreferences::m_bCryptLayerSupported;
bool	CPreferences::m_bCryptLayerRequired;
uint32	CPreferences::m_dwKadUDPKey;
uint8	CPreferences::m_byCryptTCPPaddingLength;

bool	CPreferences::m_bSkipWANIPSetup;
bool	CPreferences::m_bSkipWANPPPSetup;
bool	CPreferences::m_bEnableUPnP;
bool	CPreferences::m_bCloseUPnPOnExit;

bool	CPreferences::m_bEnableSearchResultFilter;

bool	CPreferences::m_bMessageEnableSmileys;

BOOL	CPreferences::m_bIsRunningAeroGlass;
bool	CPreferences::m_bPreventStandby;
bool	CPreferences::m_bStoreSearches;

bool    CPreferences::m_bCryptLayerRequiredStrictServer; //==> dlarge lh require obfuscated server connection (MorphXT)

//>>> shadow2004::IP2Country [EastShare]
bool	CPreferences::m_bIP2CountryShowFlag;
uint8	CPreferences::m_uiIP2CountryNameMode;
UINT	CPreferences::m_uiIP2CountryVersion;
bool	CPreferences::m_bIP2CountryAutoUpdate;
CString	CPreferences::m_strIP2CountryUpdateURL;
CString	CPreferences::m_strIP2CountryUpdateVerURL;
//<<< shadow2004::IP2Country [EastShare]
//>>> shadow2004::ModIconDLL Update
bool	CPreferences::m_bModIconDllAutoUpdate;
CString	CPreferences::m_strModIconDllUpdateURL;
//<<< shadow2004::ModIconDLL Update
//>>> Spike2::ConChecker [eWombat]
bool	CPreferences::m_bICMP; 
uint8   CPreferences::m_uiPingTimeOut; 
uint8   CPreferences::m_uiPingTTL; 
bool    CPreferences::m_bCheckCon;
//<<< Spike2::ConChecker [eWombat]
uint8	CPreferences::m_uiPaybackFirst; //>>> WiZaRd::Payback First
//>>> shadow2004::IPFilter-Update [Morph]
CString	CPreferences::strUpdateURLIPFilter;
bool	CPreferences::m_bAutoUpdateIPFilter;
UINT	CPreferences::m_uiIPfilterVersion; 
//<<< shadow2004::IPFilter-Update [Morph]
//>>> shadow2004::ed2k updates [WiZaRd]
uint32	CPreferences::m_dwDLingIpFilterVersion;
CString	CPreferences::m_strDLingIpFilterLink;
bool	CPreferences::m_bAutoResumePausedIPFilter;
bool	CPreferences::m_bIPFilterUploadPrioManuell;
uint8	CPreferences::m_uiIPFilterUploadPrio;
//<<< shadow2004::ed2k updates [WiZaRd]
//>>> JvA::SLS [enkeyDEV]
bool	CPreferences::m_bUseSaveLoadSources;
uint8	CPreferences::m_iActivationLimitSLS;
uint8	CPreferences::m_iSourcesToSaveSLS;
//<<< JvA::SLS [enkeyDEV]
//>>> WiZaRd::minRQR [WiZaRd]
bool	CPreferences::m_bShowMinRQR;
//<<< WiZaRd::minRQR [WiZaRd]
//>>> shadow2004::InfiniteQueue [SLUGFILLER]
bool	CPreferences::m_bInfiniteQueue;
//<<< shadow2004::InfiniteQueue [SLUGFILLER]

///////////////////////////////////////////////////////////////////////////
// dlarge Silversurfer Tweaks:
//

//==> dlarge TrayPasswordProtection (Xanatos)
bool	CPreferences::m_bTrayPasswordProtection;
CString	CPreferences::m_sTrayPassword;
//<== dlarge TrayPasswordProtection (Xanatos)

//==> dlarge Static server handling
bool	CPreferences::m_bDontRemoveStaticServers;
//<== dlarge Static server handling

//==> dlarge remove unused AICH-hashes (Xman)
bool CPreferences::m_rememberAICH;
//<== dlarge remove unused AICH-hashes (Xman)

//==> dlarge disable compression (Xman)
bool CPreferences::m_bUseCompression;
//<== dlarge disable compression (Xman)

//==> dlarge Drop
bool	CPreferences::m_bDropSourcesNNS;
bool	CPreferences::m_bDropSourcesFQ;
bool	CPreferences::m_bDropSourcesHQR;
uint32	CPreferences::m_iDropSourcesTimerNNS;
uint32	CPreferences::m_iDropSourcesTimerFQ;
uint32	CPreferences::m_iDropSourcesTimerHQR;
uint16	CPreferences::MaxRemoveQRS;
//<== dlarge Drop

//==> dlarge lowIdRetry
uint8	CPreferences::LowIdRetries;
uint8	CPreferences::LowIdRetried;
//<== dlarge lowIdRetry

//==> dlarge high process priority
uint8	CPreferences::m_iProcessPrio;
//<== dlarge high process priority

//==> dlarge InvisibleMode
bool    CPreferences::m_bInvisibleMode;         
bool    CPreferences::m_bStartInvisible; 
UINT    CPreferences::m_iInvisibleModeHotKeyModifier; 
char    CPreferences::m_cInvisibleModeHotKey; 
//<== dlarge InvisibleMode

//==> dlarge Mass Rename
int      CPreferences::m_SimpleCleanupOptions;
CString  CPreferences::m_SimpleCleanupSearch;
CString  CPreferences::m_SimpleCleanupReplace;
CString  CPreferences::m_SimpleCleanupSearchChars;
CString  CPreferences::m_SimpleCleanupReplaceChars;
//<== dlarge Mass Rename

//==> dlarge QuickStart (Xanatos)
bool	CPreferences::m_bQuickStart;
int		CPreferences::m_iQuickStartTime;
int	CPreferences::m_iQuickMaxConperFive;
int	CPreferences::m_iQuickMaxHalfOpen;
int	CPreferences::m_iQuickMaxConnections;
bool	CPreferences::m_bOnQuickStart;
//<== dlarge QuickStart (Xanatos)

//==> dlarge SUC/USS
bool	CPreferences::isautodynupswitching;
bool	CPreferences::m_bDynUpLog;
bool	CPreferences::m_bUSSUDP; 
short   CPreferences::m_sPingDataSize;  
uint8	CPreferences::m_iUSSinitialTTL;
int	CPreferences::maxconnectionsswitchborder;

bool	CPreferences::m_bSUCEnabled;
int		CPreferences::m_iSUCHigh;
int		CPreferences::m_iSUCLow;
int		CPreferences::m_iSUCPitch;
int		CPreferences::m_iSUCDrift;
bool	CPreferences::m_bSUCLog;
//<== dlarge SUC/USS

//==> dlarge MTU Configuration
uint16	CPreferences::MTU;                          
bool	CPreferences::usedoublesendsize;           
//<== dlarge MTU Configuration

//==> dlarge don't overwrite bak files if last sessions crashed (Xman)
bool	CPreferences::m_this_session_aborted_in_an_unnormal_way;
bool	CPreferences::m_last_session_aborted_in_an_unnormal_way;
//<== dlarge don't overwrite bak files if last sessions crashed (Xman)

//==> dlarge Backup
bool	CPreferences::autobackup;
bool	CPreferences::autobackup2;
//<== dlarge Backup

//==> dlarge queue progress bar - Client Percentage - chunk dots
bool    CPreferences::m_bClientQueueProgressBar; 
bool	CPreferences::m_bShowClientPercentage;
bool	CPreferences::m_bEnableChunkDots;
bool	CPreferences::m_bShowSessionDownload;
bool    CPreferences::m_bStaticIcon; //==> dlarge Static Tray Icon
bool    CPreferences::m_bTrayComplete; //=> dlarge Completed in Tray 
bool	CPreferences::m_bSideBanner; //==> dlarge switch Banner
bool	CPreferences::m_bUseRelativeChunkDisplay; //==> dlarge relative chunk display
//<== dlarge queue progress bar - Client Percentage - chunk dots

//==>  dlarge Source Graph
bool	CPreferences::m_bSrcGraph;
uint16  CPreferences::m_iStatsHLMin;
uint16  CPreferences::m_iStatsHLMax;
uint16  CPreferences::m_iStatsHLDif;
//<== dlarge Source Graph

//==> dlarge NiceHash
uint8	CPreferences::m_iNiceHashWeight; 
//<== dlarge NiceHash

//==> dlarge ReleaseBonus 
uint8	CPreferences::m_uReleaseBonus;
bool	CPreferences::m_bReleaseBonus;
//<== dlarge ReleaseBonus

//==> dlarge Virus Scan (TK4)
bool    CPreferences::virusscannerenabled;
CString	CPreferences::virusscanner;       
CString	CPreferences::virusscanprefilesw; 
CString	CPreferences::virusscanswitches;  
int 	CPreferences::virusscannertype;  
int	CPreferences::virusscanradio;     
//<== dlarge Virus Scan (TK4)

//==> dlarge auto priority
bool  CPreferences::pp_bFirstStart;
bool  CPreferences::pp_bUseAutoPrio;
bool  CPreferences::pp_bAutoPrioKeepLow;
uint8 CPreferences::pp_uAutoPrioNormal;
uint8 CPreferences::pp_uAutoPrioHigh;
bool  CPreferences::pp_bAutoPrioChanged;
//<== dlarge auto priority

//==> dlarge Smart Category Control 
bool	CPreferences::m_bValidSrcsOnly;
bool	CPreferences::m_bShowCatNames;
bool	CPreferences::m_bActiveCatDefault;
bool	CPreferences::m_bSelCatOnAdd;
bool	CPreferences::m_bAutoSetResumeOrder;
bool	CPreferences::m_bSmallFileDLPush;
uint8	CPreferences::m_iStartDLInEmptyCats;
bool	CPreferences::m_bRespectMaxSources;
bool	CPreferences::m_bUseAutoCat;
uint8	CPreferences::dlMode;
//<== dlarge Smart Category Control 

//==> dlarge Design Settings 
// client styles
DWORD		CPreferences::nClientStyleFlags[style_c_count]; 
COLORREF	CPreferences::nClientStyleFontColor[style_c_count];
COLORREF	CPreferences::nClientStyleBackColor[style_c_count];
short		CPreferences::nClientStyleOnOff[style_c_count];

// download styles
DWORD		CPreferences::nDownloadStyleFlags[style_d_count]; 
COLORREF	CPreferences::nDownloadStyleFontColor[style_d_count];
COLORREF	CPreferences::nDownloadStyleBackColor[style_d_count];
short		CPreferences::nDownloadStyleOnOff[style_d_count];

// share styles
DWORD		CPreferences::nShareStyleFlags[style_s_count]; 
COLORREF	CPreferences::nShareStyleFontColor[style_s_count];
COLORREF	CPreferences::nShareStyleBackColor[style_s_count];
short		CPreferences::nShareStyleOnOff[style_s_count];

// server styles
DWORD		CPreferences::nServerStyleFlags[style_se_count]; 
COLORREF	CPreferences::nServerStyleFontColor[style_se_count];
COLORREF	CPreferences::nServerStyleBackColor[style_se_count];
short		CPreferences::nServerStyleOnOff[style_se_count];

// background styles
DWORD		CPreferences::nBackgroundStyleFlags[style_b_count]; 
COLORREF	CPreferences::nBackgroundStyleFontColor[style_b_count];
COLORREF	CPreferences::nBackgroundStyleBackColor[style_b_count];
short		CPreferences::nBackgroundStyleOnOff[style_b_count];

// window styles
DWORD		CPreferences::nWindowStyleFlags[style_w_count]; 
COLORREF	CPreferences::nWindowStyleFontColor[style_w_count];
COLORREF	CPreferences::nWindowStyleBackColor[style_w_count];
short		CPreferences::nWindowStyleOnOff[style_w_count];
//<== dlarge Design Settings 

bool	CPreferences::m_bDirectoryWatcher; //==> dlarge Automatic shared files updater 
int	CPreferences::m_iKnownMetDays; //==> dlarge .met file control

//==> dlarge MenuXP
bool	CPreferences::m_bShowXPSideBar;
bool	CPreferences::m_bShowXPBitmap;
int 	CPreferences::m_iXPMenuStyle;
bool	CPreferences::m_bGrayMenuIcon;
//<== dlarge MenuXP

//==> dlarge minimule 
int	    CPreferences::speedmetermin;
int	    CPreferences::speedmetermax;
bool    CPreferences::m_bMiniMule;
uint32  CPreferences::m_iMiniMuleUpdate;
bool    CPreferences::m_bMiniMuleLives;
uint8   CPreferences::m_iMiniMuleTransparency;
bool	CPreferences::m_bShowSpeedMeter;
bool	CPreferences::m_bMMCompl;
bool	CPreferences::m_bMMOpen;
//<== dlarge minimule 

//==> dlarge CPU/MEM 
bool	CPreferences::m_bSysInfo;
bool	CPreferences::m_bSysInfoGlobal;
//<== dlarge CPU/MEM 

bool	CPreferences::m_bSaveUploadQueueWaitTime; //==> dlarge SUQWT

//==> dlarge SlotControl
UINT	CPreferences::m_iUploadSlotCount;
bool	CPreferences::m_bSlotFocus;
uint16	CPreferences::maxclientdatarate;
//<== dlarge SlotControl

int	CPreferences::creditSystemMode; //==> dlarge CreditSystem

//==> dlarge Argos System (Xanatos)
bool	CPreferences::m_bUseArgosSystem;
int		CPreferences::m_iCreditCompensation;
bool	CPreferences::m_bTrustUnArgosHashThief;
bool	CPreferences::m_bTrustUnArgosHashChanged;
bool	CPreferences::m_bTrustUnArgosGhostMode;
bool	CPreferences::m_bTrustUnArgosAgressiv;
int		CPreferences::m_iArgosTrustTime;
UINT	CPreferences::m_uCloseMaellaBackdoor;
UINT	CPreferences::m_uDontBanFriends;
int		CPreferences::m_iArgosProcessTime;
int		CPreferences::m_iArgosTrackTime;
int		CPreferences::m_iArgosGenericBanTime;
int		CPreferences::m_iArgosCorruptedSenderTime;
int		CPreferences::m_iArgosFileScannerTime;
int		CPreferences::m_iArgosFileFakerTime;
int		CPreferences::m_iArgosAgressionBanTime;
int		CPreferences::m_iArgosOpCodeTime;
int		CPreferences::m_iArgosHashChangedTime;
int		CPreferences::m_iArgosRankFlooderTime;
int		CPreferences::m_iArgosGhostModeTime;	
int		CPreferences::m_iArgosFailedTime;
int		CPreferences::m_iArgosXSExploitTime;
int		CPreferences::m_iArgosNickChangerTime;
int		CPreferences::m_iArgosModChangerTime;
int		CPreferences::m_iArgosNullNickTime;
int		CPreferences::m_iArgosSpamTime;
int		CPreferences::m_iArgosBadHelloTime;
int		CPreferences::m_iArgosBadProtTime;
int		CPreferences::m_iArgosGPLBreakerPunishment;
int		CPreferences::m_iArgosHardLeecherPunishment;
int		CPreferences::m_iArgosNormalLeecherPunishment;
int		CPreferences::m_iArgosSoftLeecherPunishment;
int		CPreferences::m_iArgosBadModPunishment;
int		CPreferences::m_iArgosNickThiefPunishment;
int		CPreferences::m_iArgosModThiefPunishment;
int		CPreferences::m_iArgosHashThiefPunishment;
int		CPreferences::m_iArgosCreditHackPunishment;
int		CPreferences::m_iArgosHashChangedPunishment;
int		CPreferences::m_iArgosGhostModePunishment;
int		CPreferences::m_iArgosFakeClientPunishment;
int		CPreferences::m_iArgosAgressonPunishment;
int		CPreferences::m_iArgosFileScannerPunishment;
int		CPreferences::m_iArgosFileFakerPunishment;
int		CPreferences::m_iArgosCorruptedSenderPunishment;
int		CPreferences::m_iArgosRankFlooderPunishment;
int		CPreferences::m_iArgosFailedPunishment;
int		CPreferences::m_iArgosXSExploitPunishment;
int		CPreferences::m_iArgosNickChangerPunishment;
int		CPreferences::m_iArgosModChangerPunishment;
int		CPreferences::m_iArgosNullNickPunishment;
int		CPreferences::m_iArgosSpamPunishment;
int		CPreferences::m_iArgosBadHelloPunishment;
int		CPreferences::m_iArgosBadProtPunishment;
bool	CPreferences::m_bArgosLeecherModDetection;
UINT	CPreferences::m_uArgosLeecherNickDetection;
int		CPreferences::m_iArgosDetectionLevel;
bool	CPreferences::m_bArgosOpcodeDetection;
bool	CPreferences::m_bArgosLeecherHashDetection;
bool	CPreferences::m_bArgosNickThiefDetection;
bool	CPreferences::m_bPlainAntiNickThief;
bool	CPreferences::m_bArgosModThiefDetection;
bool	CPreferences::m_bArgosHashThiefDetection;
bool	CPreferences::m_bArgosCreditHackDetection;
bool	CPreferences::m_bHashChangeDetection;
bool	CPreferences::m_bArgosGhostModDetection;
UINT	CPreferences::m_uArgosFakeClientDetection;
UINT	CPreferences::m_uAgressionDetection;
int		CPreferences::m_iAgressionIntervals;
int		CPreferences::m_iAgressionThreshold;
bool	CPreferences::m_bFileScannerDetection;
bool	CPreferences::m_bFileFakerDetection;
bool	CPreferences::m_bBadSenderDetection;
bool	CPreferences::m_bRankFloodDetection;
bool	CPreferences::m_bFailedDetection;
int		CPreferences::m_iFailedTries;
int		CPreferences::m_iFailedThreshold;
bool	CPreferences::m_bXSExploitDetection;
int		CPreferences::m_iXSExploitIntervals;
int		CPreferences::m_iXSExploitThreshold;
bool	CPreferences::m_bNickChangerDetection;
int		CPreferences::m_iNickChangeIntervals;
int		CPreferences::m_iNickChangeThreshold;
bool	CPreferences::m_bModChangerDetection;
int		CPreferences::m_iModChangeIntervals;
int		CPreferences::m_iModChangeThreshold;
bool	CPreferences::m_bNullNickDetection;
bool	CPreferences::m_bSpamDetection;
bool	CPreferences::m_bBadHelloDetection;
UINT	CPreferences::m_ueMCryptDetection;
bool	CPreferences::m_bBadProtDetection;
UINT	CPreferences::m_uDLPDetection;
bool	CPreferences::m_bArgosLogLeechers;
//<== dlarge Argos System (Xanatos)

CPreferences::CPreferences()
{
#ifdef _DEBUG
	m_iDbgHeap = 1;
#endif
	m_bOnQuickStart = false; //==> dlarge QuickStart (Xanatos)	
}

CPreferences::~CPreferences()
{
	delete prefsExt;
}

LPCTSTR CPreferences::GetConfigFile()
{
	return theApp.m_pszProfileName;
}

void CPreferences::Init()
{
	srand((uint32)time(0)); // we need random numbers sometimes

	prefsExt = new Preferences_Ext_Struct;
	memset(prefsExt, 0, sizeof *prefsExt);

	m_strFileCommentsFilePath = GetMuleDirectory(EMULE_CONFIGDIR) + L"fileinfo.ini";
	///////////////////////////////////////////////////////////////////////////
	// Create 'logs' directory (and optionally move files from application directory)
	//
	CFileFind ff;
	BOOL bFoundFile = ff.FindFile(GetMuleDirectory(EMULE_EXECUTEABLEDIR) + L"eMule*.log", 0);
	while (bFoundFile)
	{
		bFoundFile = ff.FindNextFile();
		if (ff.IsDots() || ff.IsSystem() || ff.IsDirectory() || ff.IsHidden())
			continue;
		MoveFile(ff.GetFilePath(), GetMuleDirectory(EMULE_LOGDIR) + ff.GetFileName());
	}
	ff.Close();

	CreateUserHash();

	// load preferences.dat or set standart values
	CString strFullPath;
	strFullPath = GetMuleDirectory(EMULE_CONFIGDIR) + L"preferences.dat";
	FILE* preffile = _tfsopen(strFullPath, L"rb", _SH_DENYWR);

	InitStyles(); //==> dlarge Design Settings 

//>>> Encrypt/Decrypt
	//we need the hash prior to startup
	//can this cause bugs?
	//LoadPreferences();
//<<< Encrypt/Decrypt

	if (!preffile){
		SetStandartValues();
	}
	else{
		if (fread(prefsExt,sizeof(Preferences_Ext_Struct),1,preffile) != 1 || ferror(preffile))
			SetStandartValues();

		md4cpy(userhash, prefsExt->userhash);
		EmuleWindowPlacement = prefsExt->EmuleWindowPlacement;

		fclose(preffile);
		smartidstate = 0;
	}

//>>> Encrypt/Decrypt
	LoadPreferences();
//<<< Encrypt/Decrypt

	// shared directories
	strFullPath = GetMuleDirectory(EMULE_CONFIGDIR) + L"shareddir.dat";
	CStdioFile* sdirfile = new CStdioFile();
	bool bIsUnicodeFile = IsUnicodeFile(strFullPath); // check for BOM
	// open the text file either in ANSI (text) or Unicode (binary), this way we can read old and new files
	// with nearly the same code..
	if (sdirfile->Open(strFullPath, CFile::modeRead | CFile::shareDenyWrite | (bIsUnicodeFile ? CFile::typeBinary : 0)))
	{
		try {
			if (bIsUnicodeFile)
				sdirfile->Seek(sizeof(WORD), SEEK_CUR); // skip BOM

			CString toadd;
			while (sdirfile->ReadString(toadd))
			{
				toadd.Trim(L" \t\r\n"); // need to trim '\r' in binary mode
				if (toadd.IsEmpty())
					continue;

				TCHAR szFullPath[MAX_PATH];
				if (PathCanonicalize(szFullPath, toadd))
					toadd = szFullPath;

				if (!IsShareableDirectory(toadd))
					continue;

				if (_taccess(toadd, 0) == 0) { // only add directories which still exist
					if (toadd.Right(1) != L'\\')
						toadd.Append(L"\\");
					shareddir_list.AddHead(toadd);
				}
			}
			sdirfile->Close();
		}
		catch (CFileException* ex) {
			ASSERT(0);
			ex->Delete();
		}
	}
	delete sdirfile;

	// serverlist addresses
	// filename update to reasonable name
	if (PathFileExists(GetMuleDirectory(EMULE_CONFIGDIR) + L"adresses.dat") ) {
		if (PathFileExists(GetMuleDirectory(EMULE_CONFIGDIR) + L"addresses.dat") )
			DeleteFile(GetMuleDirectory(EMULE_CONFIGDIR) + L"adresses.dat");
		else 
			MoveFile(GetMuleDirectory(EMULE_CONFIGDIR) + L"adresses.dat", GetMuleDirectory(EMULE_CONFIGDIR) + L"addresses.dat");
	}

	strFullPath = GetMuleDirectory(EMULE_CONFIGDIR) + L"addresses.dat";
	sdirfile = new CStdioFile();
	bIsUnicodeFile = IsUnicodeFile(strFullPath);
	if (sdirfile->Open(strFullPath, CFile::modeRead | CFile::shareDenyWrite | (bIsUnicodeFile ? CFile::typeBinary : 0)))
	{
		try {
			if (bIsUnicodeFile)
				sdirfile->Seek(sizeof(WORD), SEEK_CUR); // skip BOM

			CString toadd;
			while (sdirfile->ReadString(toadd))
			{
				toadd.Trim(L" \t\r\n"); // need to trim '\r' in binary mode
				if (toadd.IsEmpty())
					continue;
				addresses_list.AddHead(toadd);
			}
		}
		catch (CFileException* ex) {
			ASSERT(0);
			ex->Delete();
		}
		sdirfile->Close();
	}
	delete sdirfile;

	userhash[5] = 14;
	userhash[14] = 111;

	// Explicitly inform the user about errors with incoming/temp folders!
	if (!PathFileExists(GetMuleDirectory(EMULE_INCOMINGDIR)) && !::CreateDirectory(GetMuleDirectory(EMULE_INCOMINGDIR),0)) {
		CString strError;
		strError.Format(GetResString(IDS_ERR_CREATE_DIR), GetResString(IDS_PW_INCOMING), GetMuleDirectory(EMULE_INCOMINGDIR), GetErrorMessage(GetLastError()));
		AfxMessageBox(strError, MB_ICONERROR);

		m_strIncomingDir = GetDefaultDirectory(EMULE_INCOMINGDIR, true); // will also try to create it if needed
		if (!PathFileExists(GetMuleDirectory(EMULE_INCOMINGDIR))){
			strError.Format(GetResString(IDS_ERR_CREATE_DIR), GetResString(IDS_PW_INCOMING), GetMuleDirectory(EMULE_INCOMINGDIR), GetErrorMessage(GetLastError()));
			AfxMessageBox(strError, MB_ICONERROR);
		}
	}
	if (!PathFileExists(GetTempDir()) && !::CreateDirectory(GetTempDir(),0)) {
		CString strError;
		strError.Format(GetResString(IDS_ERR_CREATE_DIR), GetResString(IDS_PW_TEMP), GetTempDir(), GetErrorMessage(GetLastError()));
		AfxMessageBox(strError, MB_ICONERROR);
		
		tempdir.SetAt(0, GetDefaultDirectory(EMULE_TEMPDIR, true)); // will also try to create it if needed);
		if (!PathFileExists(GetTempDir())){
			strError.Format(GetResString(IDS_ERR_CREATE_DIR), GetResString(IDS_PW_TEMP), GetTempDir(), GetErrorMessage(GetLastError()));
			AfxMessageBox(strError, MB_ICONERROR);
		}
	}

//>>> JvA::SLS [enkeyDEV]
	CString sSourceListsPath = CString(GetTempDir()) + L"\\Saved Sources";
	if (UseSaveLoadSources() && !PathFileExists(sSourceListsPath.GetBuffer()) && !::CreateDirectory(sSourceListsPath.GetBuffer(), 0)) {
		CString strError;
		strError.Format(_T("Failed to create source lists directory \"%s\" - %s"), sSourceListsPath, GetErrorMessage(GetLastError()));
		AfxMessageBox(strError, MB_ICONERROR);
	}
//<<< JvA::SLS [enkeyDEV]

	if (((int*)userhash)[0] == 0 && ((int*)userhash)[1] == 0 && ((int*)userhash)[2] == 0 && ((int*)userhash)[3] == 0) //==> dlarge Bugfix (ilmira)
		CreateUserHash();
}

void CPreferences::Uninit()
{
	while (!catMap.IsEmpty())
	{
		Category_Struct* delcat = catMap.GetAt(0); 
		catMap.RemoveAt(0); 
		delete delcat;
	}
}

void CPreferences::SetStandartValues()
{
	CreateUserHash();

	WINDOWPLACEMENT defaultWPM;
	defaultWPM.length = sizeof(WINDOWPLACEMENT);
	defaultWPM.rcNormalPosition.left=10;defaultWPM.rcNormalPosition.top=10;
	defaultWPM.rcNormalPosition.right=700;defaultWPM.rcNormalPosition.bottom=500;
	defaultWPM.showCmd=0;
	EmuleWindowPlacement=defaultWPM;
	versioncheckLastAutomatic=0;

//	Save();
}

bool CPreferences::IsTempFile(const CString& rstrDirectory, const CString& rstrName)
{
	bool bFound = false;
	for (int i=0;i<tempdir.GetCount() && !bFound;i++)
		if (CompareDirectories(rstrDirectory, GetTempDir(i))==0)
			bFound = true; //ok, found a directory
	
	if(!bFound) //found nowhere - not a tempfile...
		return false;

	// do not share a file from the temp directory, if it matches one of the following patterns
	CString strNameLower(rstrName);
	strNameLower.MakeLower();
	strNameLower += L"|"; // append an EOS character which we can query for
	static const LPCTSTR _apszNotSharedExts[] = {
		L"%u.part" L"%c", 
		L"%u.part.met" L"%c", 
		L"%u.part.met" PARTMET_BAK_EXT L"%c", 
		L"%u.part.met" PARTMET_TMP_EXT L"%c" 
	};
	for (int i = 0; i < _countof(_apszNotSharedExts); i++){
		UINT uNum;
		TCHAR iChar;
		// "misuse" the 'scanf' function for a very simple pattern scanning.
		if (_stscanf(strNameLower, _apszNotSharedExts[i], &uNum, &iChar) == 2 && iChar == L'|')
			return true;
	}

	return false;
}

// SLUGFILLER: SafeHash
bool CPreferences::IsConfigFile(const CString& rstrDirectory, const CString& rstrName)
{
	if (CompareDirectories(rstrDirectory, GetMuleDirectory(EMULE_CONFIGDIR)))
		return false;

	// do not share a file from the config directory, if it contains one of the following extensions
	static const LPCTSTR _apszNotSharedExts[] = { L".met.bak", L".ini.old" };
	for (int i = 0; i < _countof(_apszNotSharedExts); i++){
		int iLen = _tcslen(_apszNotSharedExts[i]);
		if (rstrName.GetLength()>=iLen && rstrName.Right(iLen).CompareNoCase(_apszNotSharedExts[i])==0)
			return true;
	}

	// do not share following files from the config directory
	static const LPCTSTR _apszNotSharedFiles[] = 
	{
		L"AC_SearchStrings.dat",
		L"AC_ServerMetURLs.dat",
		L"addresses.dat",
		L"category.ini",
		L"clients.met",
		L"cryptkey.dat",
		L"emfriends.met",
		L"fileinfo.ini",
		L"ipfilter.dat",
		L"known.met",
		L"preferences.dat",
		L"preferences.ini",
		L"server.met",
		L"server.met.new",
		L"server_met.download",
		L"server_met.old",
		L"shareddir.dat",
		L"sharedsubdir.dat",
		L"staticservers.dat",
		L"webservices.dat"
	};
	for (int i = 0; i < _countof(_apszNotSharedFiles); i++){
		if (rstrName.CompareNoCase(_apszNotSharedFiles[i])==0)
			return true;
	}

	return false;
}
// SLUGFILLER: SafeHash

uint16 CPreferences::GetMaxDownload(){
//>>> WiZaRd::SessionRatio
	//no need to limit that here, it will be limited dynamically!
	return maxdownload;
//    return (uint16)(GetMaxDownloadInBytesPerSec()/1024);
//<<< WiZaRd::SessionRatio
}

uint64 CPreferences::GetMaxDownloadInBytesPerSec(bool dynamic){
//>>> WiZaRd::SessionRatio
	uint64 m_uimaxDownload = maxdownload*1024;
	//Session limit, are we leeching?
	//Don't download more than 3 times our upload (multiFU, partial PS)
	const double uploaded = max(0, (double)theStats.sessionSentBytes - (double)theStats.sessionSentBytesToFriend - (double)theStats.sessionSentBytesViaPartPS); //>>> WiZaRd::MultiFU //>>> WiZaRd::PowerShare
	const double sessionUlDlRatio = (uploaded + 1.0) / (theStats.sessionReceivedBytes - sesDownData_URL + 1.0); //>>> WiZaRd::Exclude HTTP Traffic [Quezl]
	if(sessionUlDlRatio < 0.4) //Activate throttling if close to limit
	{		
		//if we cannot upload, yet, then it's not our fault!
		const UINT currUpload = theApp.uploadqueue->GetWaitingUserCount() && theApp.uploadqueue->GetUploadQueueLength() && theApp.uploadqueue->GetDatarate() ? theApp.uploadqueue->GetDatarate() : 10240;
		const UINT minDownload = max(currUpload, 10240); //we will let them at least 10k DL
		m_uimaxDownload = (uint64)min(max(minDownload, (9*currUpload*sessionUlDlRatio)), m_uimaxDownload);
}
//<<< WiZaRd::SessionRatio

	//don't be a Lam3r :)
	UINT maxup;
	if (dynamic && thePrefs.IsDynUpEnabled() && theApp.uploadqueue->GetWaitingUserCount() != 0 && theApp.uploadqueue->GetDatarate() != 0) 
 		maxup = theApp.uploadqueue->GetDatarate();
 	else
		maxup = GetMaxUpload()*1024;

//>>> WiZaRd::SessionRatio
	uint64 m_uioffimaxDownload = 0;
	if( maxup < 4*1024 )
		m_uioffimaxDownload = (( (maxup < 10*1024) && ((uint64)maxup*3 < maxdownload*1024) )? (uint64)maxup*3 : maxdownload*1024);
	else
		m_uioffimaxDownload = (( (maxup < 10*1024) && ((uint64)maxup*4 < maxdownload*1024) )? (uint64)maxup*4 : maxdownload*1024);
	
	//we use the lower one to respect the (IMHO dumb) rules of official client
	//Why is it dumb? 
	//Because someone may download at 10000kB and upload 10kB (1:1000) but
	//one may not download with more than 9kB if he can only upload 3kB (1:3) 
	//Pretty unfair... and that's why eMule IS a lamer soft already... 
	//it allows incredible leeching! *narf*!
	//But we use a sessionratio to limit it at least a *bit*
	return min(m_uimaxDownload, m_uioffimaxDownload);
//	if( maxup < 4*1024 )
//		return (((maxup < 10*1024) && ((uint64)maxup*3 < maxdownload*1024)) ? (uint64)maxup*3 : maxdownload*1024);
//	return (((maxup < 10*1024) && ((uint64)maxup*4 < maxdownload*1024)) ? (uint64)maxup*4 : maxdownload*1024);
//<<< WiZaRd::SessionRatio
}

//==> dlarge SlotControl
uint32	CPreferences::GetMaxClientDataRate()
{
	return maxclientdatarate*1024;
}
//<== dlarge SlotControl

// -khaos--+++> A whole bunch of methods!  Keep going until you reach the end tag.
void CPreferences::SaveStats(int bBackUp){
	// This function saves all of the new statistics in my addon.  It is also used to
	// save backups for the Reset Stats function, and the Restore Stats function (Which is actually LoadStats)
	// bBackUp = 0: DEFAULT; save to statistics.ini
	// bBackUp = 1: Save to statbkup.ini, which is used to restore after a reset
	// bBackUp = 2: Save to statbkuptmp.ini, which is temporarily created during a restore and then renamed to statbkup.ini

	CString strFullPath(GetMuleDirectory(EMULE_CONFIGDIR));
	if (bBackUp == 1)
		strFullPath += L"statbkup.ini";
	else if (bBackUp == 2)
		strFullPath += L"statbkuptmp.ini";
	else
		strFullPath += L"statistics.ini";
	
	CIni ini(strFullPath, L"Statistics");

	// Save cumulative statistics to preferences.ini, going in order as they appear in CStatisticsDlg::ShowStatistics.
	// We do NOT SET the values in prefs struct here.

    // Save Cum Down Data
	ini.WriteUInt64(L"TotalDownloadedBytes", theStats.sessionReceivedBytes + GetTotalDownloaded());
	ini.WriteInt(L"DownSuccessfulSessions", cumDownSuccessfulSessions);
	ini.WriteInt(L"DownFailedSessions", cumDownFailedSessions);
	ini.WriteInt(L"DownAvgTime", (GetDownC_AvgTime() + GetDownS_AvgTime()) / 2);
	ini.WriteUInt64(L"LostFromCorruption", cumLostFromCorruption + sesLostFromCorruption);
	ini.WriteUInt64(L"SavedFromCompression", sesSavedFromCompression + cumSavedFromCompression);
	ini.WriteInt(L"PartsSavedByICH", cumPartsSavedByICH + sesPartsSavedByICH);

	ini.WriteUInt64(L"DownData_EDONKEY", GetCumDownData_EDONKEY());
	ini.WriteUInt64(L"DownData_EDONKEYHYBRID", GetCumDownData_EDONKEYHYBRID());
	ini.WriteUInt64(L"DownData_EMULE", GetCumDownData_EMULE());
	ini.WriteUInt64(L"DownData_MLDONKEY", GetCumDownData_MLDONKEY());
	ini.WriteUInt64(L"DownData_LMULE", GetCumDownData_EMULECOMPAT());
	ini.WriteUInt64(L"DownData_AMULE", GetCumDownData_AMULE());
	ini.WriteUInt64(L"DownData_SHAREAZA", GetCumDownData_SHAREAZA());
	ini.WriteUInt64(L"DownData_URL", GetCumDownData_URL());
	ini.WriteUInt64(L"DownDataPort_4662", GetCumDownDataPort_4662());
	ini.WriteUInt64(L"DownDataPort_OTHER", GetCumDownDataPort_OTHER());
	ini.WriteUInt64(L"DownDataPort_PeerCache", GetCumDownDataPort_PeerCache());

	ini.WriteUInt64(L"DownOverheadTotal",theStats.GetDownDataOverheadFileRequest() +
										theStats.GetDownDataOverheadSourceExchange() +
										theStats.GetDownDataOverheadServer() +
										theStats.GetDownDataOverheadKad() +
										theStats.GetDownDataOverheadOther() +
										GetDownOverheadTotal());
	ini.WriteUInt64(L"DownOverheadFileReq", theStats.GetDownDataOverheadFileRequest() + GetDownOverheadFileReq());
	ini.WriteUInt64(L"DownOverheadSrcEx", theStats.GetDownDataOverheadSourceExchange() + GetDownOverheadSrcEx());
	ini.WriteUInt64(L"DownOverheadServer", theStats.GetDownDataOverheadServer() + GetDownOverheadServer());
	ini.WriteUInt64(L"DownOverheadKad", theStats.GetDownDataOverheadKad() + GetDownOverheadKad());
	
	ini.WriteUInt64(L"DownOverheadTotalPackets", theStats.GetDownDataOverheadFileRequestPackets() + 
												theStats.GetDownDataOverheadSourceExchangePackets() + 
												theStats.GetDownDataOverheadServerPackets() + 
												theStats.GetDownDataOverheadKadPackets() + 
												theStats.GetDownDataOverheadOtherPackets() + 
												GetDownOverheadTotalPackets());
	ini.WriteUInt64(L"DownOverheadFileReqPackets", theStats.GetDownDataOverheadFileRequestPackets() + GetDownOverheadFileReqPackets());
	ini.WriteUInt64(L"DownOverheadSrcExPackets", theStats.GetDownDataOverheadSourceExchangePackets() + GetDownOverheadSrcExPackets());
	ini.WriteUInt64(L"DownOverheadServerPackets", theStats.GetDownDataOverheadServerPackets() + GetDownOverheadServerPackets());
	ini.WriteUInt64(L"DownOverheadKadPackets", theStats.GetDownDataOverheadKadPackets() + GetDownOverheadKadPackets());

	// Save Cumulative Upline Statistics
	ini.WriteUInt64(L"TotalUploadedBytes", theStats.sessionSentBytes + GetTotalUploaded());
	ini.WriteInt(L"UpSuccessfulSessions", theApp.uploadqueue->GetSuccessfullUpCount() + GetUpSuccessfulSessions());
	ini.WriteInt(L"UpFailedSessions", theApp.uploadqueue->GetFailedUpCount() + GetUpFailedSessions());
	ini.WriteInt(L"UpAvgTime", (theApp.uploadqueue->GetAverageUpTime() + GetUpAvgTime())/2);
	ini.WriteUInt64(L"UpData_EDONKEY", GetCumUpData_EDONKEY());
	ini.WriteUInt64(L"UpData_EDONKEYHYBRID", GetCumUpData_EDONKEYHYBRID());
	ini.WriteUInt64(L"UpData_EMULE", GetCumUpData_EMULE());
	ini.WriteUInt64(L"UpData_MLDONKEY", GetCumUpData_MLDONKEY());
	ini.WriteUInt64(L"UpData_LMULE", GetCumUpData_EMULECOMPAT());
	ini.WriteUInt64(L"UpData_AMULE", GetCumUpData_AMULE());
	ini.WriteUInt64(L"UpData_SHAREAZA", GetCumUpData_SHAREAZA());
	ini.WriteUInt64(L"UpDataPort_4662", GetCumUpDataPort_4662());
	ini.WriteUInt64(L"UpDataPort_OTHER", GetCumUpDataPort_OTHER());
	ini.WriteUInt64(L"UpDataPort_PeerCache", GetCumUpDataPort_PeerCache());
	ini.WriteUInt64(L"UpData_File", GetCumUpData_File());
	ini.WriteUInt64(L"UpData_Partfile", GetCumUpData_Partfile());

	ini.WriteUInt64(L"UpOverheadTotal", theStats.GetUpDataOverheadFileRequest() + 
										theStats.GetUpDataOverheadSourceExchange() + 
										theStats.GetUpDataOverheadServer() + 
										theStats.GetUpDataOverheadKad() + 
										theStats.GetUpDataOverheadOther() + 
										GetUpOverheadTotal());
	ini.WriteUInt64(L"UpOverheadFileReq", theStats.GetUpDataOverheadFileRequest() + GetUpOverheadFileReq());
	ini.WriteUInt64(L"UpOverheadSrcEx", theStats.GetUpDataOverheadSourceExchange() + GetUpOverheadSrcEx());
	ini.WriteUInt64(L"UpOverheadServer", theStats.GetUpDataOverheadServer() + GetUpOverheadServer());
	ini.WriteUInt64(L"UpOverheadKad", theStats.GetUpDataOverheadKad() + GetUpOverheadKad());

	ini.WriteUInt64(L"UpOverheadTotalPackets", theStats.GetUpDataOverheadFileRequestPackets() + 
										theStats.GetUpDataOverheadSourceExchangePackets() + 
										theStats.GetUpDataOverheadServerPackets() + 
										theStats.GetUpDataOverheadKadPackets() + 
										theStats.GetUpDataOverheadOtherPackets() + 
										GetUpOverheadTotalPackets());
	ini.WriteUInt64(L"UpOverheadFileReqPackets", theStats.GetUpDataOverheadFileRequestPackets() + GetUpOverheadFileReqPackets());
	ini.WriteUInt64(L"UpOverheadSrcExPackets", theStats.GetUpDataOverheadSourceExchangePackets() + GetUpOverheadSrcExPackets());
	ini.WriteUInt64(L"UpOverheadServerPackets", theStats.GetUpDataOverheadServerPackets() + GetUpOverheadServerPackets());
	ini.WriteUInt64(L"UpOverheadKadPackets", theStats.GetUpDataOverheadKadPackets() + GetUpOverheadKadPackets());

	// Save Cumulative Connection Statistics
	float tempRate = 0.0F;

	// Download Rate Average
	tempRate = theStats.GetAvgDownloadRate(AVG_TOTAL);
	ini.WriteFloat(L"ConnAvgDownRate", tempRate);
	
	// Max Download Rate Average
	if (tempRate > GetConnMaxAvgDownRate())
		SetConnMaxAvgDownRate(tempRate);
	ini.WriteFloat(L"ConnMaxAvgDownRate", GetConnMaxAvgDownRate());
	
	// Max Download Rate
	tempRate = (float)theApp.downloadqueue->GetDatarate() / 1024;
	if (tempRate > GetConnMaxDownRate())
		SetConnMaxDownRate(tempRate);
	ini.WriteFloat(L"ConnMaxDownRate", GetConnMaxDownRate());
	
	// Upload Rate Average
	tempRate = theStats.GetAvgUploadRate(AVG_TOTAL);
	ini.WriteFloat(L"ConnAvgUpRate", tempRate);
	
	// Max Upload Rate Average
	if (tempRate > GetConnMaxAvgUpRate())
		SetConnMaxAvgUpRate(tempRate);
	ini.WriteFloat(L"ConnMaxAvgUpRate", GetConnMaxAvgUpRate());
	
	// Max Upload Rate
	tempRate = (float)theApp.uploadqueue->GetDatarate() / 1024;
	if (tempRate > GetConnMaxUpRate())
		SetConnMaxUpRate(tempRate);
	ini.WriteFloat(L"ConnMaxUpRate", GetConnMaxUpRate());
	
	// Overall Run Time
	ini.WriteInt(L"ConnRunTime", (UINT)((GetTickCount() - theStats.starttime)/1000 + GetConnRunTime()));
	
	// Number of Reconnects
	ini.WriteInt(L"ConnNumReconnects", (theStats.reconnects>0) ? (theStats.reconnects - 1 + GetConnNumReconnects()) : GetConnNumReconnects());
	
	// Average Connections
	if (theApp.serverconnect->IsConnected())
		ini.WriteInt(L"ConnAvgConnections", (UINT)((theApp.listensocket->GetAverageConnections() + cumConnAvgConnections)/2));
	
	// Peak Connections
	if (theApp.listensocket->GetPeakConnections() > cumConnPeakConnections)
		cumConnPeakConnections = theApp.listensocket->GetPeakConnections();
	ini.WriteInt(L"ConnPeakConnections", cumConnPeakConnections);
	
	// Max Connection Limit Reached
	if (theApp.listensocket->GetMaxConnectionReached() + cumConnMaxConnLimitReached > cumConnMaxConnLimitReached)
		ini.WriteInt(L"ConnMaxConnLimitReached", theApp.listensocket->GetMaxConnectionReached() + cumConnMaxConnLimitReached);
	
	// Time Stuff...
	ini.WriteInt(L"ConnTransferTime", GetConnTransferTime() + theStats.GetTransferTime());
	ini.WriteInt(L"ConnUploadTime", GetConnUploadTime() + theStats.GetUploadTime());
	ini.WriteInt(L"ConnDownloadTime", GetConnDownloadTime() + theStats.GetDownloadTime());
	ini.WriteInt(L"ConnServerDuration", GetConnServerDuration() + theStats.GetServerDuration());
	
	// Compare and Save Server Records
	uint32 servtotal, servfail, servuser, servfile, servlowiduser, servtuser, servtfile;
	float servocc;
	theApp.serverlist->GetStatus(servtotal, servfail, servuser, servfile, servlowiduser, servtuser, servtfile, servocc);
	
	if (servtotal - servfail > cumSrvrsMostWorkingServers)
		cumSrvrsMostWorkingServers = servtotal - servfail;
	ini.WriteInt(L"SrvrsMostWorkingServers", cumSrvrsMostWorkingServers);

	if (servtuser > cumSrvrsMostUsersOnline)
		cumSrvrsMostUsersOnline = servtuser;
	ini.WriteInt(L"SrvrsMostUsersOnline", cumSrvrsMostUsersOnline);

	if (servtfile > cumSrvrsMostFilesAvail)
		cumSrvrsMostFilesAvail = servtfile;
	ini.WriteInt(L"SrvrsMostFilesAvail", cumSrvrsMostFilesAvail);

	// Compare and Save Shared File Records
	if ((UINT)theApp.sharedfiles->GetCount() > cumSharedMostFilesShared)
		cumSharedMostFilesShared = theApp.sharedfiles->GetCount();
	ini.WriteInt(L"SharedMostFilesShared", cumSharedMostFilesShared);

	uint64 bytesLargestFile = 0;
	uint64 allsize = theApp.sharedfiles->GetDatasize(bytesLargestFile);
	if (allsize > cumSharedLargestShareSize)
		cumSharedLargestShareSize = allsize;
	ini.WriteUInt64(L"SharedLargestShareSize", cumSharedLargestShareSize);
	if (bytesLargestFile > cumSharedLargestFileSize)
		cumSharedLargestFileSize = bytesLargestFile;
	ini.WriteUInt64(L"SharedLargestFileSize", cumSharedLargestFileSize);

	if (theApp.sharedfiles->GetCount() != 0) {
		uint64 tempint = allsize/theApp.sharedfiles->GetCount();
		if (tempint > cumSharedLargestAvgFileSize)
			cumSharedLargestAvgFileSize = tempint;
	}

	ini.WriteUInt64(L"SharedLargestAvgFileSize", cumSharedLargestAvgFileSize);
	ini.WriteInt(L"statsDateTimeLastReset", stat_datetimeLastReset);

	// If we are saving a back-up or a temporary back-up, return now.
	if (bBackUp != 0)
		return;
}

void CPreferences::SetRecordStructMembers() {

	// The purpose of this function is to be called from CStatisticsDlg::ShowStatistics()
	// This was easier than making a bunch of functions to interface with the record
	// members of the prefs struct from ShowStatistics.

	// This function is going to compare current values with previously saved records, and if
	// the current values are greater, the corresponding member of prefs will be updated.
	// We will not write to INI here, because this code is going to be called a lot more often
	// than SaveStats()  - Khaos

	CString buffer;

	// Servers
	uint32 servtotal, servfail, servuser, servfile, servlowiduser, servtuser, servtfile;
	float servocc;
	theApp.serverlist->GetStatus( servtotal, servfail, servuser, servfile, servlowiduser, servtuser, servtfile, servocc );
	if ((servtotal-servfail)>cumSrvrsMostWorkingServers) cumSrvrsMostWorkingServers = (servtotal-servfail);
	if (servtuser>cumSrvrsMostUsersOnline) cumSrvrsMostUsersOnline = servtuser;
	if (servtfile>cumSrvrsMostFilesAvail) cumSrvrsMostFilesAvail = servtfile;

	// Shared Files
	if ((UINT)theApp.sharedfiles->GetCount() > cumSharedMostFilesShared)
		cumSharedMostFilesShared = theApp.sharedfiles->GetCount();
	uint64 bytesLargestFile = 0;
	uint64 allsize=theApp.sharedfiles->GetDatasize(bytesLargestFile);
	if (allsize>cumSharedLargestShareSize) cumSharedLargestShareSize = allsize;
	if (bytesLargestFile>cumSharedLargestFileSize) cumSharedLargestFileSize = bytesLargestFile;
	if (theApp.sharedfiles->GetCount() != 0) {
		uint64 tempint = allsize/theApp.sharedfiles->GetCount();
		if (tempint>cumSharedLargestAvgFileSize) cumSharedLargestAvgFileSize = tempint;
	}
} // SetRecordStructMembers()

void CPreferences::SaveCompletedDownloadsStat(){

	// This function saves the values for the completed
	// download members to INI.  It is called from
	// CPartfile::PerformFileComplete ...   - Khaos

	CIni ini(GetMuleDirectory(EMULE_CONFIGDIR) + L"statistics.ini", L"Statistics" );

	ini.WriteInt(L"DownCompletedFiles",			GetDownCompletedFiles());
	ini.WriteInt(L"DownSessionCompletedFiles",	GetDownSessionCompletedFiles());
} // SaveCompletedDownloadsStat()

void CPreferences::Add2SessionTransferData(UINT uClientID, UINT uClientPort, BOOL bFromPF, 
										   BOOL bUpDown, uint32 bytes, bool sentToFriend)
{
	//	This function adds the transferred bytes to the appropriate variables,
	//	as well as to the totals for all clients. - Khaos
	//	PARAMETERS:
	//	uClientID - The identifier for which client software sent or received this data, eg SO_EMULE
	//	uClientPort - The remote port of the client that sent or received this data, eg 4662
	//	bFromPF - Applies only to uploads.  True is from partfile, False is from non-partfile.
	//	bUpDown - True is Up, False is Down
	//	bytes - Number of bytes sent by the client.  Subtract header before calling.

	switch (bUpDown){
		case true:
			//	Upline Data
			switch (uClientID){
				// Update session client breakdown stats for sent bytes...
				case SO_EMULE:
				case SO_OLDEMULE:		sesUpData_EMULE+=bytes;			break;
				case SO_EDONKEYHYBRID:	sesUpData_EDONKEYHYBRID+=bytes;	break;
				case SO_EDONKEY:		sesUpData_EDONKEY+=bytes;		break;
				case SO_MLDONKEY:		sesUpData_MLDONKEY+=bytes;		break;
				case SO_AMULE:			sesUpData_AMULE+=bytes;			break;
				case SO_SHAREAZA:		sesUpData_SHAREAZA+=bytes;		break;
				case SO_CDONKEY:
				case SO_LPHANT:
				case SO_XMULE:			sesUpData_EMULECOMPAT+=bytes;	break;
			}

			switch (uClientPort){
				// Update session port breakdown stats for sent bytes...
				case 4662:				sesUpDataPort_4662+=bytes;		break;
				case (UINT)-1:			sesUpDataPort_PeerCache+=bytes;	break;
				//case (UINT)-2:		sesUpDataPort_URL+=bytes;		break;
				default:				sesUpDataPort_OTHER+=bytes;		break;
			}

			if (bFromPF)				sesUpData_Partfile+=bytes;
			else						sesUpData_File+=bytes;

			//	Add to our total for sent bytes...
			theApp.UpdateSentBytes(bytes, sentToFriend);

			break;

		case false:
			// Downline Data
			switch (uClientID){
                // Update session client breakdown stats for received bytes...
				case SO_EMULE:
				case SO_OLDEMULE:		sesDownData_EMULE+=bytes;		break;
				case SO_EDONKEYHYBRID:	sesDownData_EDONKEYHYBRID+=bytes;break;
				case SO_EDONKEY:		sesDownData_EDONKEY+=bytes;		break;
				case SO_MLDONKEY:		sesDownData_MLDONKEY+=bytes;	break;
				case SO_AMULE:			sesDownData_AMULE+=bytes;		break;
				case SO_SHAREAZA:		sesDownData_SHAREAZA+=bytes;	break;
				case SO_CDONKEY:
				case SO_LPHANT:
				case SO_XMULE:			sesDownData_EMULECOMPAT+=bytes;	break;
				case SO_URL:			sesDownData_URL+=bytes;			break;
			}

			switch (uClientPort){
				// Update session port breakdown stats for received bytes...
				// For now we are only going to break it down by default and non-default.
				// A statistical analysis of all data sent from every single port/domain is
				// beyond the scope of this add-on.
				case 4662:				sesDownDataPort_4662+=bytes;	break;
				case (UINT)-1:			sesDownDataPort_PeerCache+=bytes;break;
				//case (UINT)-2:		sesDownDataPort_URL+=bytes;		break;
				default:				sesDownDataPort_OTHER+=bytes;	break;
			}

			//	Add to our total for received bytes...
			theApp.UpdateReceivedBytes(bytes);
	}
}

// Reset Statistics by Khaos

void CPreferences::ResetCumulativeStatistics(){

	// Save a backup so that we can undo this action
	SaveStats(1);

	// SET ALL CUMULATIVE STAT VALUES TO 0  :'-(

	totalDownloadedBytes=0;
	totalUploadedBytes=0;
	cumDownOverheadTotal=0;
	cumDownOverheadFileReq=0;
	cumDownOverheadSrcEx=0;
	cumDownOverheadServer=0;
	cumDownOverheadKad=0;
	cumDownOverheadTotalPackets=0;
	cumDownOverheadFileReqPackets=0;
	cumDownOverheadSrcExPackets=0;
	cumDownOverheadServerPackets=0;
	cumDownOverheadKadPackets=0;
	cumUpOverheadTotal=0;
	cumUpOverheadFileReq=0;
	cumUpOverheadSrcEx=0;
	cumUpOverheadServer=0;
	cumUpOverheadKad=0;
	cumUpOverheadTotalPackets=0;
	cumUpOverheadFileReqPackets=0;
	cumUpOverheadSrcExPackets=0;
	cumUpOverheadServerPackets=0;
	cumUpOverheadKadPackets=0;
	cumUpSuccessfulSessions=0;
	cumUpFailedSessions=0;
	cumUpAvgTime=0;
	cumUpData_EDONKEY=0;
	cumUpData_EDONKEYHYBRID=0;
	cumUpData_EMULE=0;
	cumUpData_MLDONKEY=0;
	cumUpData_AMULE=0;
	cumUpData_EMULECOMPAT=0;
	cumUpData_SHAREAZA=0;
	cumUpDataPort_4662=0;
	cumUpDataPort_OTHER=0;
	cumUpDataPort_PeerCache=0;
	cumDownCompletedFiles=0;
	cumDownSuccessfulSessions=0;
	cumDownFailedSessions=0;
	cumDownAvgTime=0;
	cumLostFromCorruption=0;
	cumSavedFromCompression=0;
	cumPartsSavedByICH=0;
	cumDownData_EDONKEY=0;
	cumDownData_EDONKEYHYBRID=0;
	cumDownData_EMULE=0;
	cumDownData_MLDONKEY=0;
	cumDownData_AMULE=0;
	cumDownData_EMULECOMPAT=0;
	cumDownData_SHAREAZA=0;
	cumDownData_URL=0;
	cumDownDataPort_4662=0;
	cumDownDataPort_OTHER=0;
	cumDownDataPort_PeerCache=0;
	cumConnAvgDownRate=0;
	cumConnMaxAvgDownRate=0;
	cumConnMaxDownRate=0;
	cumConnAvgUpRate=0;
	cumConnRunTime=0;
	cumConnNumReconnects=0;
	cumConnAvgConnections=0;
	cumConnMaxConnLimitReached=0;
	cumConnPeakConnections=0;
	cumConnDownloadTime=0;
	cumConnUploadTime=0;
	cumConnTransferTime=0;
	cumConnServerDuration=0;
	cumConnMaxAvgUpRate=0;
	cumConnMaxUpRate=0;
	cumSrvrsMostWorkingServers=0;
	cumSrvrsMostUsersOnline=0;
	cumSrvrsMostFilesAvail=0;
    cumSharedMostFilesShared=0;
	cumSharedLargestShareSize=0;
	cumSharedLargestAvgFileSize=0;

	// Set the time of last reset...
	time_t timeNow;
	time(&timeNow);
	stat_datetimeLastReset = timeNow;

	// Save the reset stats
	SaveStats();
	theApp.emuledlg->statisticswnd->ShowStatistics(true);
}


// Load Statistics
// This used to be integrated in LoadPreferences, but it has been altered
// so that it can be used to load the backup created when the stats are reset.
// Last Modified: 2-22-03 by Khaos
bool CPreferences::LoadStats(int loadBackUp)
{
	// loadBackUp is 0 by default
	// loadBackUp = 0: Load the stats normally like we used to do in LoadPreferences
	// loadBackUp = 1: Load the stats from statbkup.ini and create a backup of the current stats.  Also, do not initialize session variables.
	CString sINI;
	CFileFind findBackUp;

	switch (loadBackUp) {
		case 0:{
			// for transition...
			if(PathFileExists(GetMuleDirectory(EMULE_CONFIGDIR) + L"statistics.ini"))
				sINI.Format(L"%sstatistics.ini", GetMuleDirectory(EMULE_CONFIGDIR));
			else
				sINI.Format(L"%spreferences.ini", GetMuleDirectory(EMULE_CONFIGDIR));

			break;
			   }
		case 1:
			sINI.Format(L"%sstatbkup.ini", GetMuleDirectory(EMULE_CONFIGDIR));
			if (!findBackUp.FindFile(sINI))
				return false;
			SaveStats(2); // Save our temp backup of current values to statbkuptmp.ini, we will be renaming it at the end of this function.
			break;
	}

	BOOL fileex = PathFileExists(sINI);
	CIni ini(sINI, L"Statistics");

	totalDownloadedBytes			= ini.GetUInt64(L"TotalDownloadedBytes");
	totalUploadedBytes				= ini.GetUInt64(L"TotalUploadedBytes");

	// Load stats for cumulative downline overhead
	cumDownOverheadTotal			= ini.GetUInt64(L"DownOverheadTotal");
	cumDownOverheadFileReq			= ini.GetUInt64(L"DownOverheadFileReq");
	cumDownOverheadSrcEx			= ini.GetUInt64(L"DownOverheadSrcEx");
	cumDownOverheadServer			= ini.GetUInt64(L"DownOverheadServer");
	cumDownOverheadKad				= ini.GetUInt64(L"DownOverheadKad");
	cumDownOverheadTotalPackets		= ini.GetUInt64(L"DownOverheadTotalPackets");
	cumDownOverheadFileReqPackets	= ini.GetUInt64(L"DownOverheadFileReqPackets");
	cumDownOverheadSrcExPackets		= ini.GetUInt64(L"DownOverheadSrcExPackets");
	cumDownOverheadServerPackets	= ini.GetUInt64(L"DownOverheadServerPackets");
	cumDownOverheadKadPackets		= ini.GetUInt64(L"DownOverheadKadPackets");

	// Load stats for cumulative upline overhead
	cumUpOverheadTotal				= ini.GetUInt64(L"UpOverHeadTotal");
	cumUpOverheadFileReq			= ini.GetUInt64(L"UpOverheadFileReq");
	cumUpOverheadSrcEx				= ini.GetUInt64(L"UpOverheadSrcEx");
	cumUpOverheadServer				= ini.GetUInt64(L"UpOverheadServer");
	cumUpOverheadKad				= ini.GetUInt64(L"UpOverheadKad");
	cumUpOverheadTotalPackets		= ini.GetUInt64(L"UpOverHeadTotalPackets");
	cumUpOverheadFileReqPackets		= ini.GetUInt64(L"UpOverheadFileReqPackets");
	cumUpOverheadSrcExPackets		= ini.GetUInt64(L"UpOverheadSrcExPackets");
	cumUpOverheadServerPackets		= ini.GetUInt64(L"UpOverheadServerPackets");
	cumUpOverheadKadPackets			= ini.GetUInt64(L"UpOverheadKadPackets");

	// Load stats for cumulative upline data
	cumUpSuccessfulSessions			= ini.GetInt(L"UpSuccessfulSessions");
	cumUpFailedSessions				= ini.GetInt(L"UpFailedSessions");
	cumUpAvgTime					= ini.GetInt(L"UpAvgTime");

	// Load cumulative client breakdown stats for sent bytes
	cumUpData_EDONKEY				= ini.GetUInt64(L"UpData_EDONKEY");
	cumUpData_EDONKEYHYBRID			= ini.GetUInt64(L"UpData_EDONKEYHYBRID");
	cumUpData_EMULE					= ini.GetUInt64(L"UpData_EMULE");
	cumUpData_MLDONKEY				= ini.GetUInt64(L"UpData_MLDONKEY");
	cumUpData_EMULECOMPAT			= ini.GetUInt64(L"UpData_LMULE");
	cumUpData_AMULE					= ini.GetUInt64(L"UpData_AMULE");
	cumUpData_SHAREAZA				= ini.GetUInt64(L"UpData_SHAREAZA");

	// Load cumulative port breakdown stats for sent bytes
	cumUpDataPort_4662				= ini.GetUInt64(L"UpDataPort_4662");
	cumUpDataPort_OTHER				= ini.GetUInt64(L"UpDataPort_OTHER");
	cumUpDataPort_PeerCache			= ini.GetUInt64(L"UpDataPort_PeerCache");

	// Load cumulative source breakdown stats for sent bytes
	cumUpData_File					= ini.GetUInt64(L"UpData_File");
	cumUpData_Partfile				= ini.GetUInt64(L"UpData_Partfile");

	// Load stats for cumulative downline data
	cumDownCompletedFiles			= ini.GetInt(L"DownCompletedFiles");
	cumDownSuccessfulSessions		= ini.GetInt(L"DownSuccessfulSessions");
	cumDownFailedSessions			= ini.GetInt(L"DownFailedSessions");
	cumDownAvgTime					= ini.GetInt(L"DownAvgTime");

	// Cumulative statistics for saved due to compression/lost due to corruption
	cumLostFromCorruption			= ini.GetUInt64(L"LostFromCorruption");
	cumSavedFromCompression			= ini.GetUInt64(L"SavedFromCompression");
	cumPartsSavedByICH				= ini.GetInt(L"PartsSavedByICH");

	// Load cumulative client breakdown stats for received bytes
	cumDownData_EDONKEY				= ini.GetUInt64(L"DownData_EDONKEY");
	cumDownData_EDONKEYHYBRID		= ini.GetUInt64(L"DownData_EDONKEYHYBRID");
	cumDownData_EMULE				= ini.GetUInt64(L"DownData_EMULE");
	cumDownData_MLDONKEY			= ini.GetUInt64(L"DownData_MLDONKEY");
	cumDownData_EMULECOMPAT			= ini.GetUInt64(L"DownData_LMULE");
	cumDownData_AMULE				= ini.GetUInt64(L"DownData_AMULE");
	cumDownData_SHAREAZA			= ini.GetUInt64(L"DownData_SHAREAZA");
	cumDownData_URL					= ini.GetUInt64(L"DownData_URL");

	// Load cumulative port breakdown stats for received bytes
	cumDownDataPort_4662			= ini.GetUInt64(L"DownDataPort_4662");
	cumDownDataPort_OTHER			= ini.GetUInt64(L"DownDataPort_OTHER");
	cumDownDataPort_PeerCache		= ini.GetUInt64(L"DownDataPort_PeerCache");

	// Load stats for cumulative connection data
	cumConnAvgDownRate				= ini.GetFloat(L"ConnAvgDownRate");
	cumConnMaxAvgDownRate			= ini.GetFloat(L"ConnMaxAvgDownRate");
	cumConnMaxDownRate				= ini.GetFloat(L"ConnMaxDownRate");
	cumConnAvgUpRate				= ini.GetFloat(L"ConnAvgUpRate");
	cumConnMaxAvgUpRate				= ini.GetFloat(L"ConnMaxAvgUpRate");
	cumConnMaxUpRate				= ini.GetFloat(L"ConnMaxUpRate");
	cumConnRunTime					= ini.GetInt(L"ConnRunTime");
	cumConnTransferTime				= ini.GetInt(L"ConnTransferTime");
	cumConnDownloadTime				= ini.GetInt(L"ConnDownloadTime");
	cumConnUploadTime				= ini.GetInt(L"ConnUploadTime");
	cumConnServerDuration			= ini.GetInt(L"ConnServerDuration");
	cumConnNumReconnects			= ini.GetInt(L"ConnNumReconnects");
	cumConnAvgConnections			= ini.GetInt(L"ConnAvgConnections");
	cumConnMaxConnLimitReached		= ini.GetInt(L"ConnMaxConnLimitReached");
	cumConnPeakConnections			= ini.GetInt(L"ConnPeakConnections");

	// Load date/time of last reset
	stat_datetimeLastReset			= ini.GetInt(L"statsDateTimeLastReset");

	// Smart Load For Restores - Don't overwrite records that are greater than the backed up ones
	if (loadBackUp == 1)
	{
		// Load records for servers / network
		if ((UINT)ini.GetInt(L"SrvrsMostWorkingServers") > cumSrvrsMostWorkingServers)
			cumSrvrsMostWorkingServers = ini.GetInt(L"SrvrsMostWorkingServers");

		if ((UINT)ini.GetInt(L"SrvrsMostUsersOnline") > cumSrvrsMostUsersOnline)
			cumSrvrsMostUsersOnline = ini.GetInt(L"SrvrsMostUsersOnline");

		if ((UINT)ini.GetInt(L"SrvrsMostFilesAvail") > cumSrvrsMostFilesAvail)
			cumSrvrsMostFilesAvail = ini.GetInt(L"SrvrsMostFilesAvail");

		// Load records for shared files
		if ((UINT)ini.GetInt(L"SharedMostFilesShared") > cumSharedMostFilesShared)
			cumSharedMostFilesShared =	ini.GetInt(L"SharedMostFilesShared");

		uint64 temp64 = ini.GetUInt64(L"SharedLargestShareSize");
		if (temp64 > cumSharedLargestShareSize)
			cumSharedLargestShareSize = temp64;

		temp64 = ini.GetUInt64(L"SharedLargestAvgFileSize");
		if (temp64 > cumSharedLargestAvgFileSize)
			cumSharedLargestAvgFileSize = temp64;

		temp64 = ini.GetUInt64(L"SharedLargestFileSize");
		if (temp64 > cumSharedLargestFileSize)
			cumSharedLargestFileSize = temp64;

		// Check to make sure the backup of the values we just overwrote exists.  If so, rename it to the backup file.
		// This allows us to undo a restore, so to speak, just in case we don't like the restored values...
		CString sINIBackUp;
		sINIBackUp.Format(L"%sstatbkuptmp.ini", GetMuleDirectory(EMULE_CONFIGDIR));
		if (findBackUp.FindFile(sINIBackUp))
		{
//>>> WiZaRd::FiX
//calling the "CFile" static functions here is dangerous because they will 
//throw exceptions if they fail and those aren't caught anywhere...
			_tremove(sINI);				// Remove the backup that we just restored from
			_trename(sINIBackUp, sINI);	// Rename our temporary backup to the normal statbkup.ini filename.
//			CFile::Remove(sINI);				// Remove the backup that we just restored from
//			CFile::Rename(sINIBackUp, sINI);	// Rename our temporary backup to the normal statbkup.ini filename.
//<<< WiZaRd::FiX
		}

		// Since we know this is a restore, now we should call ShowStatistics to update the data items to the new ones we just loaded.
		// Otherwise user is left waiting around for the tick counter to reach the next automatic update (Depending on setting in prefs)
		theApp.emuledlg->statisticswnd->ShowStatistics();
	}
	// Stupid Load -> Just load the values.
	else
	{
		// Load records for servers / network
		cumSrvrsMostWorkingServers	= ini.GetInt(L"SrvrsMostWorkingServers");
		cumSrvrsMostUsersOnline		= ini.GetInt(L"SrvrsMostUsersOnline");
		cumSrvrsMostFilesAvail		= ini.GetInt(L"SrvrsMostFilesAvail");

		// Load records for shared files
		cumSharedMostFilesShared	= ini.GetInt(L"SharedMostFilesShared");
		cumSharedLargestShareSize	= ini.GetUInt64(L"SharedLargestShareSize");
		cumSharedLargestAvgFileSize = ini.GetUInt64(L"SharedLargestAvgFileSize");
		cumSharedLargestFileSize	= ini.GetUInt64(L"SharedLargestFileSize");

		// Initialize new session statistic variables...
		sesDownCompletedFiles		= 0;
		
		sesUpData_EDONKEY			= 0;
		sesUpData_EDONKEYHYBRID		= 0;
		sesUpData_EMULE				= 0;
		sesUpData_MLDONKEY			= 0;
		sesUpData_AMULE				= 0;
		sesUpData_EMULECOMPAT		= 0;
		sesUpData_SHAREAZA			= 0;
		sesUpDataPort_4662			= 0;
		sesUpDataPort_OTHER			= 0;
		sesUpDataPort_PeerCache		= 0;

		sesDownData_EDONKEY			= 0;
		sesDownData_EDONKEYHYBRID	= 0;
		sesDownData_EMULE			= 0;
		sesDownData_MLDONKEY		= 0;
		sesDownData_AMULE			= 0;
		sesDownData_EMULECOMPAT		= 0;
		sesDownData_SHAREAZA		= 0;
		sesDownData_URL				= 0;
		sesDownDataPort_4662		= 0;
		sesDownDataPort_OTHER		= 0;
		sesDownDataPort_PeerCache	= 0;

		sesDownSuccessfulSessions	= 0;
		sesDownFailedSessions		= 0;
		sesPartsSavedByICH			= 0;
	}

	if (!fileex || (stat_datetimeLastReset==0 && totalDownloadedBytes==0 && totalUploadedBytes==0))
	{
		time_t timeNow;
		time(&timeNow);
		stat_datetimeLastReset = timeNow;
	}

	return true;
}

// This formats the UTC long value that is saved for stat_datetimeLastReset
// If this value is 0 (Never reset), then it returns Unknown.
CString CPreferences::GetStatsLastResetStr(bool formatLong)
{
	// formatLong dictates the format of the string returned.
	// For example...
	// true: DateTime format from the .ini
	// false: DateTime format from the .ini for the log
	CString	returnStr;
	if (GetStatsLastResetLng()) {
		tm *statsReset;
		TCHAR szDateReset[128];
		time_t lastResetDateTime = (time_t) GetStatsLastResetLng();
		statsReset = localtime(&lastResetDateTime);
		if (statsReset){
			_tcsftime(szDateReset, _countof(szDateReset), formatLong ? GetDateTimeFormat() : L"%c", statsReset);
			returnStr = szDateReset;
		}
	}
	if (returnStr.IsEmpty())
		returnStr = GetResString(IDS_UNKNOWN);
	return returnStr;
}

// <-----khaos-

bool CPreferences::Save(){

	bool error = false;
	CString strFullPath;
	strFullPath = GetMuleDirectory(EMULE_CONFIGDIR) + L"preferences.dat";

	FILE* preffile = _tfsopen(strFullPath, L"wb", _SH_DENYWR);
	prefsExt->version = PREFFILE_VERSION;
	if (preffile){
		prefsExt->version=PREFFILE_VERSION;
		prefsExt->EmuleWindowPlacement=EmuleWindowPlacement;
		md4cpy(prefsExt->userhash, userhash);

		error = fwrite(prefsExt,sizeof(Preferences_Ext_Struct),1,preffile)!=1;
		if (thePrefs.GetCommitFiles() >= 2 || (thePrefs.GetCommitFiles() >= 1 && !theApp.emuledlg->IsRunning())){
			fflush(preffile); // flush file stream buffers to disk buffers
			(void)_commit(_fileno(preffile)); // commit disk buffers to disk
		}
		fclose(preffile);
	}
	else
		error = true;

	SavePreferences();
	SaveStats();
	SaveCats(); //==> dlarge Smart Category Control 

	strFullPath = GetMuleDirectory(EMULE_CONFIGDIR) + L"shareddir.dat";
	CStdioFile sdirfile;
	if (sdirfile.Open(strFullPath, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite | CFile::typeBinary))
	{
		try{
			// write Unicode byte-order mark 0xFEFF
			WORD wBOM = 0xFEFF;
			sdirfile.Write(&wBOM, sizeof(wBOM));

			for (POSITION pos = shareddir_list.GetHeadPosition();pos != 0;){
				sdirfile.WriteString(shareddir_list.GetNext(pos));
				sdirfile.Write(L"\r\n", sizeof(TCHAR)*2);
			}
			if (thePrefs.GetCommitFiles() >= 2 || (thePrefs.GetCommitFiles() >= 1 && !theApp.emuledlg->IsRunning())){
				sdirfile.Flush(); // flush file stream buffers to disk buffers
				if (_commit(_fileno(sdirfile.m_pStream)) != 0) // commit disk buffers to disk
					AfxThrowFileException(CFileException::hardIO, GetLastError(), sdirfile.GetFileName());
			}
			sdirfile.Close();
		}
		catch(CFileException* error){
			TCHAR buffer[MAX_CFEXP_ERRORMSG];
			error->GetErrorMessage(buffer,_countof(buffer));
			if (thePrefs.GetVerbose())
				AddDebugLogLine(true, L"Failed to save %s - %s", strFullPath, buffer);
			error->Delete();
		}
	}
	else
		error = true;

	::CreateDirectory(GetMuleDirectory(EMULE_INCOMINGDIR), 0);
	::CreateDirectory(GetTempDir(), 0);
	return error;
}

void CPreferences::CreateUserHash()
{
	for (int i = 0; i < 8; i++)
	{
		uint16 random = GetRandomUInt16();
		memcpy(&userhash[i*2], &random, 2);
	}

	// mark as emule client. that will be need in later version
	userhash[5] = 14;
	userhash[14] = 111;
}

int CPreferences::GetRecommendedMaxConnections() {
	int iRealMax = ::GetMaxWindowsTCPConnections();
	if(iRealMax == -1 || iRealMax > 520)
		return 500;

	if(iRealMax < 20)
		return iRealMax;

	if(iRealMax <= 256)
		return iRealMax - 10;

	return iRealMax - 20;
}

void CPreferences::SavePreferences()
{
//>>> WiZaRd::Fresh Prefs
	if(IsFirstStart())
	{
		m_bFirstStart = false; //reset the trigger
		
		//backup the current prefs file and then create a new one...
		CString newpath;
		newpath.Format(_T("%spreferences.old"), GetMuleDirectory(EMULE_CONFIGDIR));
		::MoveFile(GetMuleDirectory(EMULE_CONFIGDIR), newpath);
	}
//<<< WiZaRd::Fresh Prefs

	CString buffer;
	
	CIni ini(GetConfigFile(), L"eMule");
	//---
	ini.WriteString(L"AppVersion", theApp.m_strCurVersionLong + _T(" [") + theApp.m_strModLongVersion + _T("]")); //==> dlarge Modname
	//---

#ifdef _DEBUG
	ini.WriteInt(L"DebugHeap", m_iDbgHeap);
#endif

	ini.WriteStringUTF8(L"Nick", strNick);
	ini.WriteString(L"IncomingDir", m_strIncomingDir);
	
	ini.WriteString(L"TempDir", tempdir.GetAt(0));

	CString tempdirs;
	for (int i=1;i<tempdir.GetCount();i++) {
		tempdirs.Append(tempdir.GetAt(i) );
		if (i+1<tempdir.GetCount())
			tempdirs.Append(L"|");
	}
	ini.WriteString(L"TempDirs", tempdirs);

    ini.WriteInt(L"MinUpload", minupload);
	ini.WriteInt(L"MaxUpload",maxupload);
	ini.WriteInt(L"MaxDownload",maxdownload);
	ini.WriteInt(L"MaxConnections",maxconnections);
	ini.WriteInt(L"MaxHalfConnections",maxhalfconnections);
	ini.WriteBool(L"ConditionalTCPAccept", m_bConditionalTCPAccept);
	ini.WriteInt(L"Port",port);
	ini.WriteInt(L"UDPPort",udpport);
	ini.WriteInt(L"ServerUDPPort", nServerUDPPort);
	ini.WriteInt(L"MaxSourcesPerFile",maxsourceperfile );
	ini.WriteWORD(L"Language",m_wLanguageID);
	ini.WriteInt(L"SeeShare",m_iSeeShares);
	ini.WriteInt(L"ToolTipDelay",m_iToolDelayTime);
	ini.WriteInt(L"StatGraphsInterval",trafficOMeterInterval);
	ini.WriteInt(L"StatsInterval",statsInterval);
	ini.WriteBool(L"StatsFillGraphs",m_bFillGraphs);
	ini.WriteBool(L"DontCompressAvi",dontcompressavi); //==> dlarge Hidden Prefs
	ini.WriteInt(L"DownloadCapacity",maxGraphDownloadRate);
	ini.WriteInt(L"UploadCapacityNew",maxGraphUploadRate);
	ini.WriteInt(L"DeadServerRetry",m_uDeadServerRetries);
	ini.WriteInt(L"ServerKeepAliveTimeout",m_dwServerKeepAliveTimeout);
	ini.WriteInt(L"SplitterbarPosition",splitterbarPosition+2);
	ini.WriteInt(L"SplitterbarPositionServer",splitterbarPositionSvr);
	ini.WriteInt(L"SplitterbarPositionStat",splitterbarPositionStat+1);
	ini.WriteInt(L"SplitterbarPositionStat_HL",splitterbarPositionStat_HL); //==> dlarge Stats Fix (BlueSonicBoy)
	ini.WriteInt(L"SplitterbarPositionStat_HR",splitterbarPositionStat_HR); //==> dlarge Stats Fix (BlueSonicBoy)
	ini.WriteInt(L"SplitterbarPositionFriend",splitterbarPositionFriend);
	ini.WriteInt(L"SplitterbarPositionShared",splitterbarPositionShared);
	ini.WriteInt(L"TransferWnd1",m_uTransferWnd1);
	ini.WriteInt(L"TransferWnd2",m_uTransferWnd2);
	ini.WriteInt(L"VariousStatisticsMaxValue",statsMax);
	ini.WriteInt(L"StatsAverageMinutes",statsAverageMinutes);
	ini.WriteInt(L"MaxConnectionsPerFiveSeconds",MaxConperFive);
	ini.WriteInt(L"Check4NewVersionDelay",versioncheckdays);

	ini.WriteBool(L"Reconnect",reconnect);
	ini.WriteBool(L"Scoresystem",m_bUseServerPriorities);
//==> dlarge Hidden Prefs
	ini.WriteBool(L"UserSortedServerList", m_bUseUserSortedServerList);
	ini.WriteBool(L"ICH", ICH);
//<== dlarge Hidden Prefs
	ini.WriteBool(L"Serverlist",m_bAutoUpdateServerList);
	ini.WriteBool(L"UpdateNotifyTestClient",updatenotify);
	if (IsRunningAeroGlassTheme())
		ini.WriteBool(L"MinToTray_Aero",mintotray);
	else
		ini.WriteBool(L"MinToTray",mintotray);
	ini.WriteBool(L"PreventStandby", m_bPreventStandby);
	ini.WriteBool(L"StoreSearches", m_bStoreSearches);
	ini.WriteBool(L"AddServersFromServer",m_bAddServersFromServer);
	ini.WriteBool(L"AddServersFromClient",m_bAddServersFromClients);
	ini.WriteBool(L"Splashscreen",splashscreen);
	ini.WriteBool(L"BringToFront",bringtoforeground);
	ini.WriteBool(L"TransferDoubleClick",transferDoubleclick);
	ini.WriteBool(L"BeepOnError",beepOnError);
	ini.WriteBool(L"ConfirmExit",confirmExit);
	ini.WriteBool(L"FilterBadIPs",filterLANIPs);
    ini.WriteBool(L"Autoconnect",autoconnect);
	ini.WriteBool(L"OnlineSignature",onlineSig);
	ini.WriteBool(L"StartupMinimized",startMinimized);
	ini.WriteBool(L"AutoStart",m_bAutoStart);
	ini.WriteBool(L"RestoreLastMainWndDlg",m_bRestoreLastMainWndDlg); //==> dlarge Hidden Prefs
	ini.WriteInt(L"LastMainWndDlgID",m_iLastMainWndDlgID);
	ini.WriteBool(L"RestoreLastLogPane",m_bRestoreLastLogPane); //==> dlarge Hidden Prefs
	ini.WriteInt(L"LastLogPaneID",m_iLastLogPaneID);
	ini.WriteBool(L"SafeServerConnect",m_bSafeServerConnect);
	ini.WriteBool(L"ShowRatesOnTitle",showRatesInTitle);
	ini.WriteBool(L"IconflashOnNewMessage",m_bIconflashOnNewMessage); //==> dlarge Hidden Prefs
	ini.WriteBool(L"IndicateRatings",indicateratings);
	ini.WriteBool(L"WatchClipboard4ED2kFilelinks",watchclipboard);
	ini.WriteInt(L"SearchMethod",m_iSearchMethod);
	ini.WriteBool(L"CheckDiskspace",checkDiskspace);
	ini.WriteInt(L"MinFreeDiskSpace",m_uMinFreeDiskSpace);
	ini.WriteBool(L"SparsePartFiles",m_bSparsePartFiles);
	ini.WriteString(L"YourHostname",m_strYourHostname);

	// Barry - New properties...
    ini.WriteBool(L"AutoConnectStaticOnly", m_bAutoConnectToStaticServersOnly);
	ini.WriteBool(L"AutoTakeED2KLinks", autotakeed2klinks);
    ini.WriteBool(L"AddNewFilesPaused", addnewfilespaused);
    ini.WriteInt (L"3DDepth", depth3D);  
	ini.WriteBool(L"MiniMule", m_bEnableMiniMule);
	ini.WriteBool(L"MiniMuleAutoClose", m_bMiniMuleAutoClose); //==> dlarge Hidden Prefs

	ini.WriteString(L"NotifierConfiguration", notifierConfiguration);
	ini.WriteBool(L"NotifyOnDownload", notifierOnDownloadFinished);
	ini.WriteBool(L"NotifyOnNewDownload", notifierOnNewDownload);
	ini.WriteBool(L"NotifyOnChat", notifierOnChat);
	ini.WriteBool(L"NotifyOnLog", notifierOnLog);
	ini.WriteBool(L"NotifyOnImportantError", notifierOnImportantError);
	ini.WriteBool(L"NotifierPopEveryChatMessage", notifierOnEveryChatMsg);
	ini.WriteBool(L"NotifierPopNewVersion", notifierOnNewVersion);
	ini.WriteInt(L"NotifierUseSound", (int)notifierSoundType);
	ini.WriteString(L"NotifierSoundPath", notifierSoundFile);

	ini.WriteString(L"TxtEditor",m_strTxtEditor);
	ini.WriteString(L"VideoPlayer",m_strVideoPlayer);
	ini.WriteString(L"VideoPlayerArgs",m_strVideoPlayerArgs);
	ini.WriteString(L"MessageFilter",messageFilter);
	ini.WriteString(L"CommentFilter",commentFilter);
	ini.WriteString(L"DateTimeFormat",GetDateTimeFormat());
	ini.WriteString(L"DateTimeFormat4Log",GetDateTimeFormat4Log());
	ini.WriteString(L"WebTemplateFile",m_strTemplateFile);
	ini.WriteString(L"FilenameCleanups",filenameCleanups);
	ini.WriteInt(L"ExtractMetaData",m_iExtractMetaData);
	ini.WriteBool(L"AdjustNTFSDaylightFileTime", m_bAdjustNTFSDaylightFileTime); //==> dlarge Hidden Prefs

	ini.WriteBool(L"MessageEnableSmileys",m_bMessageEnableSmileys);

	ini.WriteBool(L"SmartIdCheck", m_bSmartServerIdCheck);
	ini.WriteBool(L"Verbose", m_bVerbose);
	ini.WriteBool(L"DebugSourceExchange", m_bDebugSourceExchange);	// do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogBannedClients", m_bLogBannedClients);			// do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogRatingDescReceived", m_bLogRatingDescReceived);// do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogSecureIdent", m_bLogSecureIdent);				// do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogFilteredIPs", m_bLogFilteredIPs);				// do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogFileSaving", m_bLogFileSaving);				// do *not* use the according 'Get...' function here!
    ini.WriteBool(L"LogA4AF", m_bLogA4AF);                           // do *not* use the according 'Get...' function here!
	ini.WriteBool(L"LogUlDlEvents", m_bLogUlDlEvents);
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	// following options are for debugging or when using an external debug device viewer only.
	ini.WriteInt(L"DebugServerTCP",m_iDebugServerTCPLevel);
	ini.WriteInt(L"DebugServerUDP",m_iDebugServerUDPLevel);
	ini.WriteInt(L"DebugServerSources",m_iDebugServerSourcesLevel);
	ini.WriteInt(L"DebugServerSearches",m_iDebugServerSearchesLevel);
	ini.WriteInt(L"DebugClientTCP",m_iDebugClientTCPLevel);
	ini.WriteInt(L"DebugClientUDP",m_iDebugClientUDPLevel);
	ini.WriteInt(L"DebugClientKadUDP",m_iDebugClientKadUDPLevel);
	ini.WriteInt(L"DebugSearchResultDetailLevel", m_iDebugSearchResultDetailLevel); //==> dlarge Hidden Prefs
#endif
	ini.WriteBool(L"PreviewPrio", m_bpreviewprio);
	ini.WriteBool(L"UpdateQueueListPref", m_bupdatequeuelist);
	ini.WriteBool(L"ManualHighPrio", m_bManualAddedServersHighPriority);
//      ini.WriteBool(L"FullChunkTransfers", m_btransferfullchunks); // VQB: fullChunk
	ini.WriteBool(L"ShowOverhead", m_bshowoverhead);
	ini.WriteBool(L"VideoPreviewBackupped", moviePreviewBackup);
//==> dlarge Hidden Prefs
	ini.WriteInt(L"PreviewSmallBlocks", m_iPreviewSmallBlocks);
	ini.WriteBool(L"PreviewCopiedArchives", m_bPreviewCopiedArchives);
	ini.WriteInt(L"InspectAllFileTypes", m_iInspectAllFileTypes);
//<== dlarge Hidden Prefs
	ini.WriteInt(L"StartNextFile", m_istartnextfile);

	ini.DeleteKey(L"FileBufferSizePref"); // delete old 'file buff size' setting
	ini.WriteInt(L"FileBufferSize", m_iFileBufferSize);
//>>> WiZaRd::IntelliFlush
	ini.WriteBool(L"IntelliFlush", m_bUseIntelliFlush);
	ini.WriteInt(L"FileBufferFlushTime", m_uiFileBufferFlushTime);
//<<< WiZaRd::IntelliFlush

	ini.DeleteKey(L"QueueSizePref"); // delete old 'queue size' setting
	ini.WriteInt(L"QueueSize", m_iQueueSize);

	ini.WriteInt(L"CommitFiles", m_iCommitFiles);
	ini.WriteBool(L"DAPPref", m_bDAP);
	ini.WriteBool(L"UAPPref", m_bUAP);
	ini.WriteBool(L"PreviewOnIconDblClk",m_bPreviewOnIconDblClk); //==> dlarge Hidden Prefs
	ini.WriteBool(L"FilterServersByIP",filterserverbyip);
	ini.WriteBool(L"DisableKnownClientList",m_bDisableKnownClientList);
	ini.WriteBool(L"DisableQueueList",m_bDisableQueueList);
	ini.WriteBool(L"UseCreditSystem",m_bCreditSystem);
	ini.WriteBool(L"SaveLogToDisk",log2disk);
//==> dlarge Hidden Prefs
	ini.WriteInt(L"MaxLogFileSize", uMaxLogFileSize);
	ini.WriteInt(L"MaxLogBuff",iMaxLogBuff/1024);
	ini.WriteInt(L"LogFileFormat", (int)m_iLogFileFormat);
//<== dlarge Hidden Prefs
	ini.WriteBool(L"SaveDebugToDisk",debug2disk);
	ini.WriteBool(L"EnableScheduler",scheduler);
	ini.WriteBool(L"MessagesFromFriendsOnly",msgonlyfriends);
	ini.WriteBool(L"MessageFromValidSourcesOnly",msgsecure);
	ini.WriteBool(L"MessageUseCaptchas", m_bUseChatCaptchas);
	ini.WriteBool(L"ShowInfoOnCatTabs",showCatTabInfos);
	ini.WriteBool(L"DontRecreateStatGraphsOnResize",dontRecreateGraphs);
	ini.WriteBool(L"AutoFilenameCleanup",autofilenamecleanup);
	ini.WriteBool(L"ShowExtControls",m_bExtControls);
	ini.WriteBool(L"UseAutocompletion",m_bUseAutocompl);
	ini.WriteBool(L"NetworkKademlia",networkkademlia);
	ini.WriteBool(L"NetworkED2K",networked2k);
	ini.WriteBool(L"AutoClearCompleted",m_bRemoveFinishedDownloads);
	ini.WriteBool(L"TransflstRemainOrder",m_bTransflstRemain);
	ini.WriteBool(L"UseSimpleTimeRemainingcomputation",m_bUseOldTimeRemaining);
	ini.WriteBool(L"AllocateFullFile",m_bAllocFull);

	ini.WriteInt(L"VersionCheckLastAutomatic", versioncheckLastAutomatic);
	ini.WriteInt(L"FilterLevel",filterlevel);

	ini.WriteBool(L"SecureIdent", m_bUseSecureIdent);// change the name in future version to enable it by default
	ini.WriteBool(L"AdvancedSpamFilter",m_bAdvancedSpamfilter);
	ini.WriteBool(L"ShowDwlPercentage",m_bShowDwlPercentage);
	ini.WriteBool(L"RemoveFilesToBin",m_bRemove2bin);
//==> dlarge Hidden Prefs
	ini.WriteBool(L"ShowCopyEd2kLinkCmd",m_bShowCopyEd2kLinkCmd); 
	ini.WriteInt(L"MaxChatHistoryLines",m_iMaxChatHistory);
	ini.WriteInt(L"MaxMessageSessions",maxmsgsessions);
	//ini.WriteBool(L"ShowActiveDownloadsBold", m_bShowActiveDownloadsBold); //dlarge not needed
//<== dlarge Hidden Prefs
	ini.WriteBool(L"AutoArchivePreviewStart", m_bAutomaticArcPreviewStart);
//==> dlarge Hidden Prefs
	//ini.WriteBool(L"ReBarToolbar", m_bReBarToolbar); //dlarge not needed
	ini.WriteInt(L"StraightWindowStyles",m_iStraightWindowStyles);
	ini.WriteBool(L"RTLWindowsLayout",m_bRTLWindowsLayout);
//<== dlarge Hidden Prefs
	ini.WriteBinary(L"HyperTextFont", (LPBYTE)&m_lfHyperText, sizeof m_lfHyperText);
	ini.WriteBinary(L"LogTextFont", (LPBYTE)&m_lfLogText, sizeof m_lfLogText);

//==> dlarge Hidden Prefs
	ini.WriteColRef(L"LogErrorColor", m_crLogError);
	ini.WriteColRef(L"LogWarningColor", m_crLogWarning);
	ini.WriteColRef(L"LogSuccessColor", m_crLogSuccess);
//<== dlarge Hidden Prefs

	// ZZ:UploadSpeedSense -->
    ini.WriteBool(L"USSEnabled", m_bDynUpEnabled);
    ini.WriteBool(L"USSUseMillisecondPingTolerance", m_bDynUpUseMillisecondPingTolerance);
    ini.WriteInt(L"USSPingTolerance", m_iDynUpPingTolerance);
	ini.WriteInt(L"USSPingToleranceMilliseconds", m_iDynUpPingToleranceMilliseconds); // EastShare - Add by TAHO, USS limit
    ini.WriteInt(L"USSGoingUpDivider", m_iDynUpGoingUpDivider);
    ini.WriteInt(L"USSGoingDownDivider", m_iDynUpGoingDownDivider);
    ini.WriteInt(L"USSNumberOfPings", m_iDynUpNumberOfPings);
	// ZZ:UploadSpeedSense <--

    ini.WriteBool(L"A4AFSaveCpu", m_bA4AFSaveCpu); // ZZ:DownloadManager
    ini.WriteBool(L"HighresTimer", m_bHighresTimer);
	ini.WriteInt(L"WebMirrorAlertLevel", m_nWebMirrorAlertLevel);
	ini.WriteBool(L"RunAsUnprivilegedUser", m_bRunAsUser);
	ini.WriteBool(L"PreferRestrictedOverUser", m_bPreferRestrictedOverUser); //==> dlarge Hidden Prefs
	ini.WriteBool(L"OpenPortsOnStartUp", m_bOpenPortsOnStartUp);
	ini.WriteInt(L"DebugLogLevel", m_byLogLevel);
	ini.WriteBool(L"AICHTrustEveryHash", m_bTrustEveryHash); //==> dlarge Hidden Prefs
	ini.WriteInt(L"WinXPSP2OrHigher", IsRunningXPSP2OrHigher());
	ini.WriteBool(L"RememberCancelledFiles", m_bRememberCancelledFiles);
	ini.WriteBool(L"RememberDownloadedFiles", m_bRememberDownloadedFiles);

	ini.WriteBool(L"NotifierSendMail", m_bNotifierSendMail);
	ini.WriteString(L"NotifierMailSender", m_strNotifierMailSender);
	ini.WriteString(L"NotifierMailServer", m_strNotifierMailServer);
	ini.WriteString(L"NotifierMailRecipient", m_strNotifierMailReceiver);

	ini.WriteBool(L"WinaTransToolbar", m_bWinaTransToolbar);

	ini.WriteBool(L"CryptLayerRequested", m_bCryptLayerRequested);
	ini.WriteBool(L"CryptLayerRequired", m_bCryptLayerRequired);
	ini.WriteBool(L"CryptLayerSupported", m_bCryptLayerSupported);
	ini.WriteInt(L"KadUDPKey", m_dwKadUDPKey);

	ini.WriteBool(L"EnableSearchResultSpamFilter", m_bEnableSearchResultFilter);
	ini.WriteBool(L"CryptLayerRequiredStrictServer",IsServerCryptLayerRequiredStrict()); //==> dlarge lh require obfuscated server connection (MorphXT)


	///////////////////////////////////////////////////////////////////////////
	// Section: "Proxy"
	//
	ini.WriteBool(L"ProxyEnablePassword",proxy.EnablePassword,L"Proxy");
	ini.WriteBool(L"ProxyEnableProxy",proxy.UseProxy,L"Proxy");
	ini.WriteString(L"ProxyName",CStringW(proxy.name),L"Proxy");
	ini.WriteString(L"ProxyPassword",CStringW(proxy.password),L"Proxy");
	ini.WriteString(L"ProxyUser",CStringW(proxy.user),L"Proxy");
	ini.WriteInt(L"ProxyPort",proxy.port,L"Proxy");
	ini.WriteInt(L"ProxyType",proxy.type,L"Proxy");


	///////////////////////////////////////////////////////////////////////////
	// Section: "Statistics"
	//
	ini.WriteInt(L"statsConnectionsGraphRatio", statsConnectionsGraphRatio,L"Statistics");
	ini.WriteString(L"statsExpandedTreeItems", m_strStatsExpandedTreeItems);
	CString buffer2;
//==> dlarge Source Graph 
	/*
	for (int i=0;i<15;i++) {
	*/
	for (int i=0;i<16;i++) {
//<== dlarge Source Graph
		buffer.Format(L"0x%06x",GetStatsColor(i));
		buffer2.Format(L"StatColor%i",i);
		ini.WriteString(buffer2,buffer,L"Statistics" );
	}
	ini.WriteBool(L"ShowVerticalHourMarkers", m_bShowVerticalHourMarkers, L"Statistics"); //==> dlarge Hidden Prefs


	///////////////////////////////////////////////////////////////////////////
	// Section: "WebServer"
	//
	ini.WriteString(L"Password", GetWSPass(), L"WebServer");
	ini.WriteString(L"PasswordLow", GetWSLowPass());
	ini.WriteInt(L"Port", m_nWebPort);
	ini.WriteBool(L"Enabled", m_bWebEnabled);
	ini.WriteBool(L"UseGzip", m_bWebUseGzip);
	ini.WriteInt(L"PageRefreshTime", m_nWebPageRefresh);
	ini.WriteBool(L"UseLowRightsUser", m_bWebLowEnabled);
	ini.WriteBool(L"AllowAdminHiLevelFunc",m_bAllowAdminHiLevFunc);
	ini.WriteInt(L"WebTimeoutMins", m_iWebTimeoutMins);
//==> dlarge Hidden Prefs
	ini.WriteInt(L"MaxFileUploadSizeMB", m_iWebFileUploadSizeLimitMB ); 
	CString sAllowedRemoteAccessIPs;
	for (int i = 0; thePrefs.m_aAllowedRemoteAccessIPs.GetCount(); i++)
		sAllowedRemoteAccessIPs += ipstr(thePrefs.m_aAllowedRemoteAccessIPs[i]) + _T(";");
	sAllowedRemoteAccessIPs.TrimRight(_T(";"));
	ini.WriteString(L"AllowedIPs",sAllowedRemoteAccessIPs);
//<== dlarge Hidden Prefs

	///////////////////////////////////////////////////////////////////////////
	// Section: "MobileMule"
	//
	ini.WriteString(L"Password", GetMMPass(), L"MobileMule");
	ini.WriteBool(L"Enabled", m_bMMEnabled);
	ini.WriteInt(L"Port", m_nMMPort);


	///////////////////////////////////////////////////////////////////////////
	// Section: "PeerCache"
	//
	ini.WriteInt(L"LastSearch", m_uPeerCacheLastSearch, L"PeerCache");
	ini.WriteBool(L"Found", m_bPeerCacheWasFound);
	ini.WriteBool(L"EnabledDeprecated", m_bPeerCacheEnabled);
	ini.WriteInt(L"PCPort", m_nPeerCachePort);
	ini.WriteBool(L"Show", m_bPeerCacheShow); //==> dlarge Hidden Prefs

	///////////////////////////////////////////////////////////////////////////
	// Section: "UPnP"
	//
	ini.WriteBool(L"EnableUPnP", m_bEnableUPnP, L"UPnP");
	ini.WriteBool(L"SkipWANIPSetup", m_bSkipWANIPSetup);
	ini.WriteBool(L"SkipWANPPPSetup", m_bSkipWANPPPSetup);
	ini.WriteBool(L"CloseUPnPOnExit", m_bCloseUPnPOnExit);

//>>> WiZaRd::Own Prefs
	//backup the current prefs file and then create a new one...
	CString newpath;
	newpath.Format(_T("%semfprefs.ini"), GetMuleDirectory(EMULE_CONFIGDIR));
	CIni iniEMF(newpath, L"EMF");
	//ini.SetSection(_T("EMF"));
//<<< WiZaRd::Own Prefs
	
	iniEMF.WriteInt(L"FUChunks", m_uiFUChunks);
//>>> WiZaRd::AutoHL
	iniEMF.WriteInt(L"AutoHLUpdate", m_iAutoHLUpdateTimer);
	iniEMF.WriteInt(L"UseAutoHL", m_iUseAutoHL);
	iniEMF.WriteInt(L"MinAutoHL", m_iMinAutoHL);
	iniEMF.WriteInt(L"MaxAutoHL", m_iMaxAutoHL);
	iniEMF.WriteInt(L"MaxSourcesHL", m_iMaxSourcesHL);
//<<< WiZaRd::AutoHL
//>>> shadow2004::FDC [BlueSonicBoy]
	iniEMF.WriteBool(L"FilenameDisparityCheck", m_bFDCEnabled);
	iniEMF.WriteBool(L"FDCDoubleCheck", m_bFDCDouble);
	iniEMF.WriteInt(L"FDCSensitivity", m_uiFDCSensitivity);
//<<< shadow2004::FDC [BlueSonicBoy]
	iniEMF.WriteInt(L"PBF", m_uiPaybackFirst); //>>> WiZaRd::Payback First
//>>> Spike2::Emulate other
	iniEMF.WriteBool(L"Emulate eDonkey", m_bEmueDonkey);
	iniEMF.WriteBool(L"Emulate eDonkeyHybrid", m_bEmueDonkeyHybrid);
	iniEMF.WriteBool(L"Emulate MLDonkey", m_bEmuMLDonkey);
	iniEMF.WriteBool(L"Emulate Shareaza", m_bEmuShareaza);
	iniEMF.WriteBool(L"Emulate Lphant", m_bEmuLphant);
//<<< Spike2::Emulate other
//>>> WiZaRd::ServerMessageFilter
	iniEMF.WriteBool(L"BlockServerMessages", m_bBlockServerMessagesCompletely);
	iniEMF.WriteString(L"ServerMessageFilter", m_strServerMessageFilter);
//<<< WiZaRd::ServerMessageFilter
	iniEMF.WriteInt(L"ToolbarLabelStyle", m_uiToolbarLabelStyle);	//>>> shadow2004::Toolbar
//>>> shadow2004::IP2Country [EastShare]
	iniEMF.WriteInt(L"IP2Country", m_uiIP2CountryNameMode);
	iniEMF.WriteBool(L"IP2CountryShowFlag", m_bIP2CountryShowFlag);
	iniEMF.WriteInt(L"IP2CountryVersion", (int)m_uiIP2CountryVersion);
	iniEMF.WriteBool(L"AutoUpdateIP2Country", m_bIP2CountryAutoUpdate);
	iniEMF.WriteString(L"UpdateURLIP2Country", m_strIP2CountryUpdateURL);
	iniEMF.WriteString(L"UpdateVerURLIP2Country", m_strIP2CountryUpdateVerURL);
//<<< shadow2004::IP2Country [EastShare]
//>>> shadow2004::ModIconDLL Update
	iniEMF.WriteBool(L"AutoUpdateModIconDll", m_bModIconDllAutoUpdate);
	iniEMF.WriteString(L"UpdateURLModIconDll", m_strModIconDllUpdateURL);
//<<< shadow2004::ModIconDLL Update
//>>> Spike2::ConChecker [eWombat]
	iniEMF.WriteBool(L"CheckConnection", m_bCheckCon); 
	iniEMF.WriteBool(L"UseICMP", m_bICMP);  
	iniEMF.WriteInt(L"PingTimeOut", m_uiPingTimeOut); 
	iniEMF.WriteInt(L"PingTTL", m_uiPingTTL);
//<<< Spike2::ConChecker [eWombat]
//>>> shadow2004::IPFilter-Update [Morph]
	iniEMF.WriteInt(L"IPFilterVersion", m_uiIPfilterVersion); 
	iniEMF.WriteBool(L"AutoUpdateIPFilter", m_bAutoUpdateIPFilter);
 	iniEMF.WriteString(L"UpdateURLIPFilter", strUpdateURLIPFilter);
//<<< shadow2004::IPFilter-Update [Morph]
//>>> shadow2004::ed2k updates [WiZaRd]
	iniEMF.WriteInt(L"DownloadingIpFilterVersion", m_dwDLingIpFilterVersion);
	iniEMF.WriteString(L"DownloadingIpFilterLink", m_strDLingIpFilterLink);
	iniEMF.WriteBool(L"AutoStartED2KIPFilter", m_bAutoResumePausedIPFilter);
	iniEMF.WriteBool(L"IPFilterUploadManuell", m_bIPFilterUploadPrioManuell);
	iniEMF.WriteInt(L"IPFilterUpload", m_uiIPFilterUploadPrio);
//<<< shadow2004::ed2k updates [WiZaRd]
//>>> JvA::SLS [enkeyDEV]
	iniEMF.WriteBool(L"UseSaveLoadSources", m_bUseSaveLoadSources);
	iniEMF.WriteInt(L"ActivationLimitSLS", m_iActivationLimitSLS);
	iniEMF.WriteInt(L"SourcesToSaveSLS", m_iSourcesToSaveSLS);
//<<< JvA::SLS [enkeyDEV]
//>>> WiZaRd::minRQR [WiZaRd]
	iniEMF.WriteBool(L"MinRQR", m_bShowMinRQR);
//<<< WiZaRd::minRQR [WiZaRd]
//>>> shadow2004::InfiniteQueue [SLUGFILLER]
	iniEMF.WriteBool(L"InfiniteQueue", m_bInfiniteQueue);
//<<< shadow2004::InfiniteQueue [SLUGFILLER]

///////////////////////////////////////////////////////////////////////////
// dlarge Silversurfer Tweaks:
//

//==> dlarge TrayPasswordProtection (Xanatos)
	iniEMF.WriteBool(L"TrayPasswordProtection", m_bTrayPasswordProtection);
	iniEMF.WriteString(L"TrayPassword", m_sTrayPassword);
//<== dlarge TrayPasswordProtection (Xanatos)

//==> dlarge MTU Configuration
	iniEMF.WriteInt(L"MTU", MTU, L"EMF");
	iniEMF.WriteBool(L"usedoublesendsize",usedoublesendsize, L"EMF");
//<== dlarge MTU Configuration

//==> dlarge Drop
	iniEMF.WriteInt(L"DropSourcesTimerNNS",m_iDropSourcesTimerNNS, L"EMF");
	iniEMF.WriteInt(L"DropSourcesNNS",m_bDropSourcesNNS, L"EMF");
	iniEMF.WriteInt(L"DropSourcesTimerFQ",m_iDropSourcesTimerFQ, L"EMF");
	iniEMF.WriteInt(L"DropSourcesFQ",m_bDropSourcesFQ, L"EMF");
	iniEMF.WriteInt(L"DropSourcesTimerHQR",m_iDropSourcesTimerHQR, L"EMF");
	iniEMF.WriteInt(L"DropSourcesHQR",m_bDropSourcesHQR, L"EMF");
        iniEMF.WriteInt(L"MaxRemoveQueueRatingSources",MaxRemoveQRS, L"EMF");
//<== dlarge Drop

//==> dlarge lowIdRetry
 	iniEMF.WriteInt(L"ReconnectOnLowIdRetries",LowIdRetries, L"EMF");	
//<== dlarge lowIdRetry

//==> dlarge Invisible Mode
        iniEMF.WriteBool (L"InvisibleMode",m_bInvisibleMode, L"EMF");
	iniEMF.WriteBool (L"StartInvisible",m_bStartInvisible, L"EMF");
        iniEMF.WriteInt	(L"InvisibleModeHKKey",(int)m_cInvisibleModeHotKey, L"EMF");
        iniEMF.WriteInt	(L"InvisibleModeHKKeyModifier",m_iInvisibleModeHotKeyModifier, L"EMF"); 
//<== dlarge Invisible Mode

//==> dlarge Mass Rename
	iniEMF.WriteInt (L"SimpleCleanupOptions",m_SimpleCleanupOptions);
	// Enclose the strings with '"' before writing them to the file.
	// These will be filtered if the string is read again
	iniEMF.WriteString (L"SimpleCleanupSearch",CString ('\"')+m_SimpleCleanupSearch+'\"');
	iniEMF.WriteString (L"SimpleCleanupReplace",CString ('\"')+m_SimpleCleanupReplace+'\"');
	iniEMF.WriteString (L"SimpleCleanupSearchChars",CString ('\"')+m_SimpleCleanupSearchChars+'\"');
	iniEMF.WriteString (L"SimpleCleanupReplaceChars",CString ('\"')+m_SimpleCleanupReplaceChars+'\"');
//<== dlarge Mass Rename

//==> dlarge QuickStart (Xanatos)
	iniEMF.WriteBool(L"UseQuickStart", m_bQuickStart, L"EMF");
	iniEMF.WriteInt(L"QuickStartTime", m_iQuickStartTime, L"EMF");
	//iniEMF.WriteInt(L"QuickStartTimePerFile", m_iQuickStartTimePerFile, L"EMF");
	iniEMF.WriteInt(L"QuickMaxConperFive", m_iQuickMaxConperFive, L"EMF");
	iniEMF.WriteInt(L"QuickMaxHalfOpen", m_iQuickMaxHalfOpen, L"EMF");
	iniEMF.WriteInt(L"QuickMaxConnections", m_iQuickMaxConnections, L"EMF");
//<== dlarge QuickStart (Xanatos)

//==> dlarge Source Graph 
	iniEMF.WriteBool(_T("SrcGraph"), m_bSrcGraph, L"EMF");
	iniEMF.WriteInt(_T("StatsHLMin"), m_iStatsHLMin, L"EMF");
	iniEMF.WriteInt(_T("StatsHLMax"), m_iStatsHLMax, L"EMF");
//<== dlarge Source Graph 

//==> dlarge MenuXP
	iniEMF.WriteBool(_T("SHOW_XP_SIDEBAR"), m_bShowXPSideBar, L"EMF");
	iniEMF.WriteBool(_T("SHOW_XP_BITMAP"), m_bShowXPBitmap, L"EMF");
	iniEMF.WriteInt(_T("XP_MENU_STYLE"), m_iXPMenuStyle, L"EMF");
	iniEMF.WriteBool(_T("GRAY_MENU_ICON"), m_bGrayMenuIcon, L"EMF");
//<== dlarge MenuXP

//==> dlarge CPU/MEM 
	iniEMF.WriteBool(_T("SysInfos"),m_bSysInfo, L"EMF");
	iniEMF.WriteBool(_T("SysInfosGlobal"),m_bSysInfoGlobal, L"EMF");
//<== dlarge CPU/MEM 

//==> dlarge high process priority 
	iniEMF.WriteInt(L"ProcessPriority", m_iProcessPrio, L"EMF");
//<== dlarge high process priority 

//==> dlarge Backup
	iniEMF.WriteBool(_T("AutoBackup"),autobackup, L"EMF");
	iniEMF.WriteBool(_T("AutoBackup2"),autobackup2, L"EMF");
//<== dlarge Backup

//==> dlarge Static server handling (Xman)
	iniEMF.WriteBool (L"DontRemoveStaticServers",m_bDontRemoveStaticServers, L"EMF");
//<== dlarge Static server handling (Xman)

//==> dlarge remove unused AICH-hashes (Xman)
	iniEMF.WriteBool(L"rememberAICH", m_rememberAICH, L"EMF");
//<== dlarge remove unused AICH-hashes (Xman)

//==> dlarge SUC/USS
	iniEMF.WriteBool(_T("AutoDynUpSwitching"),isautodynupswitching, L"EMF"); 
	iniEMF.WriteInt(_T("MaxConnectionsSwitchBorder"),maxconnectionsswitchborder, L"EMF");
	iniEMF.WriteBool(_T("USSLog"), m_bDynUpLog, L"EMF");
	//MORPH END    - Added by SiRoB,  ZZ dynamic upload (USS)
	iniEMF.WriteBool(_T("USSUDP_FORCE"), m_bUSSUDP, L"EMF"); 
	iniEMF.WriteInt(_T("USSPingDataSize"), (int)m_sPingDataSize); 
	iniEMF.WriteInt(_T("USSInitialTTL"), m_iUSSinitialTTL, L"EMF");

	iniEMF.WriteBool(L"SUCEnabled",m_bSUCEnabled, L"EMF");
	iniEMF.WriteInt(L"SUCLog",m_bSUCLog, L"EMF");
	iniEMF.WriteInt(L"SUCHigh",m_iSUCHigh, L"EMF");
	iniEMF.WriteInt(L"SUCLow",m_iSUCLow, L"EMF");
	iniEMF.WriteInt(L"SUCDrift",m_iSUCDrift, L"EMF");
	iniEMF.WriteInt(L"SUCPitch",m_iSUCPitch, L"EMF");
//<== dlarge SUC/USS

//==> dlarge NiceHash
iniEMF.WriteInt(L"NiceHashWeight", m_iNiceHashWeight, L"EMF");
//<== dlarge NiceHash

//==> dlarge ReleaseBonus 
	iniEMF.WriteInt(L"ReleaseBonus", m_uReleaseBonus, L"EMF");
	iniEMF.WriteBool(L"UseReleaseBonus", m_bReleaseBonus, L"EMF");
//<== dlarge ReleaseBonus 

//==> dlarge queue progress bar - Client Percentage - chunk dots
	iniEMF.WriteBool(_T("ClientQueueProgressBar"),m_bClientQueueProgressBar, L"EMF"); 
	iniEMF.WriteBool(_T("ShowClientPercentage"),m_bShowClientPercentage, L"EMF"); 
	iniEMF.WriteInt(_T("EnableChunkDots"), m_bEnableChunkDots, L"EMF");
	iniEMF.WriteBool(L"ShowSessionDownload", m_bShowSessionDownload, L"EMF");
        iniEMF.WriteBool(_T("StaticIcon"),m_bStaticIcon, L"EMF"); //==> dlarge Static Tray Icon
        iniEMF.WriteBool(_T("TrayComplete"), m_bTrayComplete, L"EMF"); //==> dlarge Completed in Tray 
	iniEMF.WriteBool(L"Sidebanner",m_bSideBanner, L"EMF"); //==> dlarge switch Banner
	iniEMF.WriteBool(L"UseRelativeChunkDisplay", m_bUseRelativeChunkDisplay, L"EMF"); //==> dlarge relative chunk display
//<== dlarge queue progress bar - Client Percentage - chunk dots

//==> dlarge Virus Scanner (TK4)
	iniEMF.WriteBool(L"VirusScannerEnabled",virusscannerenabled, L"EMF");
	iniEMF.WriteString(L"VirusScanner",virusscanner, L"EMF");
	iniEMF.WriteString(L"PreFileSwitches",virusscanprefilesw, L"EMF");
	iniEMF.WriteString(L"PostFileSwithes",virusscanswitches, L"EMF");
	iniEMF.WriteInt(L"ScannerListPos",virusscannertype, L"EMF");
	iniEMF.WriteInt(L"ScannerRadioOp",virusscanradio, L"EMF");
//<== dlarge Virus Scanner (TK4)

//==> dlarge auto priority
	iniEMF.WriteBool(L"pp_bUseAutoPrio", pp_bUseAutoPrio, L"EMF");
	iniEMF.WriteBool(L"pp_bAutoPrioKeepLow", pp_bAutoPrioKeepLow, L"EMF");
	iniEMF.WriteInt(L"pp_uAutoPrioLimit", pp_uAutoPrioHigh, L"EMF");
	iniEMF.WriteInt(L"pp_uAutoPrioLimit2", pp_uAutoPrioNormal, L"EMF");
//<== dlarge auto priority

//==> dlarge Design Settings 
	SaveStylePrefs(ini);
//<== dlarge Design Settings 

	iniEMF.WriteBool(_T("AutoReloadSharedFiles"), GetDirectoryWatcher(), L"EMF"); //==> dlarge Automatic shared files updater 
	iniEMF.WriteInt(_T("KnownMetDays"), m_iKnownMetDays, L"EMF"); 	//==> dlarge .met file control

//==> dlarge don't overwrite bak files if last sessions crashed (Xman)
	iniEMF.WriteBool(L"last_session_aborted_in_an_unnormal_way", m_this_session_aborted_in_an_unnormal_way, L"EMF");
//<== dlarge don't overwrite bak files if last sessions crashed (Xman)

//==> dlarge minimule 
	iniEMF.WriteInt(_T("SpeedMeterMin"), speedmetermin, L"EMF");
	iniEMF.WriteInt(_T("SpeedMeterMax"), speedmetermax, L"EMF");	
	iniEMF.WriteBool(_T("ShowMiniMule"),m_bMiniMule, L"EMF");
	iniEMF.WriteInt(_T("MiniMuleUpdate"),m_iMiniMuleUpdate, L"EMF");
	iniEMF.WriteBool(_T("MiniMuleLives"),m_bMiniMuleLives, L"EMF");
	iniEMF.WriteInt(_T("MiniMuleTransparency"),m_iMiniMuleTransparency, L"EMF");
	iniEMF.WriteBool(_T("ShowSpeedMeter"),m_bShowSpeedMeter, L"EMF");
	iniEMF.WriteBool(_T("MiniMuleCompl"),m_bMMCompl, L"EMF");
	iniEMF.WriteBool(_T("MiniMuleOpen"),m_bMMOpen, L"EMF");
//<== dlarge minimule

//==> dlarge Smart Category Control 
	iniEMF.WriteBool(_T("ValidSrcsOnly"), m_bValidSrcsOnly, L"EMF");
	iniEMF.WriteBool(_T("ShowCatName"), m_bShowCatNames, L"EMF");
	iniEMF.WriteBool(_T("ActiveCatDefault"), m_bActiveCatDefault, L"EMF");
	iniEMF.WriteBool(_T("SelCatOnAdd"), m_bSelCatOnAdd, L"EMF");
	iniEMF.WriteBool(_T("AutoSetResumeOrder"), m_bAutoSetResumeOrder, L"EMF");
	iniEMF.WriteBool(_T("SmallFileDLPush"), m_bSmallFileDLPush, L"EMF");
	iniEMF.WriteInt(_T("StartDLInEmptyCats"), m_iStartDLInEmptyCats, L"EMF");
	iniEMF.WriteBool(_T("UseAutoCat"), m_bUseAutoCat, L"EMF");
	iniEMF.WriteInt(_T("dlMode"),dlMode, L"EMF");
//<== dlarge Smart Category Control 

	iniEMF.WriteBool(L"SaveUploadQueueWaitTime", m_bSaveUploadQueueWaitTime, L"EMF"); //==> dlarge SUQWT

//==> dlarge SlotControl
	iniEMF.WriteInt	(L"UploadSlotCount", m_iUploadSlotCount, L"EMF");			 
	iniEMF.WriteBool (L"IsSlotFocus", m_bSlotFocus, L"EMF");
	iniEMF.WriteInt	(L"MaxClientDataRate", maxclientdatarate, L"EMF");			 		 
//<== dlarge SlotControl

//==> dlarge CreditSystem
	iniEMF.WriteInt(L"CreditSystemMode", creditSystemMode, L"EMF");
//<== dlarge CreditSystem

//==> dlarge Argos System (Xanatos)
	iniEMF.WriteBool(L"UseArgosSystem", m_bUseArgosSystem);
	iniEMF.WriteInt(L"CreditCompensation", m_iCreditCompensation);
	iniEMF.WriteBool(L"TrustUnArgosHashThief", m_bTrustUnArgosHashThief);
	iniEMF.WriteBool(L"TrustUnArgosHashChanged", m_bTrustUnArgosHashChanged);
	iniEMF.WriteBool(L"TrustUnArgosGhostMode", m_bTrustUnArgosGhostMode);
	iniEMF.WriteBool(L"TrustUnArgosAgressiv", m_bTrustUnArgosAgressiv);
	iniEMF.WriteInt(L"ArgosTrustTime", m_iArgosTrustTime);
	iniEMF.WriteInt(L"CloseMaellaBackdoor", m_uCloseMaellaBackdoor);
	iniEMF.WriteInt(L"DontBanFriends", m_uDontBanFriends);
	iniEMF.WriteInt(L"ArgosProcessTime", m_iArgosProcessTime);
	iniEMF.WriteInt(L"ArgosTrackTime", m_iArgosTrackTime);
	iniEMF.WriteInt(L"ArgosGenericBanTime", m_iArgosGenericBanTime);
	iniEMF.WriteInt(L"ArgosCorruptedSenderTime", m_iArgosCorruptedSenderTime);
	iniEMF.WriteInt(L"ArgosFileScannerTime", m_iArgosFileScannerTime);
	iniEMF.WriteInt(L"ArgosFileFakerTime", m_iArgosFileFakerTime);
	iniEMF.WriteInt(L"ArgosAgressionBanTime", m_iArgosAgressionBanTime);
	iniEMF.WriteInt(L"ArgosOpCodeTime", m_iArgosOpCodeTime);
	iniEMF.WriteInt(L"ArgosHashChangedTime", m_iArgosHashChangedTime);
	iniEMF.WriteInt(L"ArgosRankFlooderTime", m_iArgosRankFlooderTime);
	iniEMF.WriteInt(L"ArgosGhostModeTime", m_iArgosGhostModeTime);	
	iniEMF.WriteInt(L"ArgosFailedTime", m_iArgosFailedTime);	
	iniEMF.WriteInt(L"ArgosXSExploitTime", m_iArgosXSExploitTime);
	iniEMF.WriteInt(L"ArgosNickChangerTime", m_iArgosNickChangerTime);
	iniEMF.WriteInt(L"ArgosModChangerTime", m_iArgosModChangerTime);
	iniEMF.WriteInt(L"ArgosNullNickTime", m_iArgosNullNickTime);
	iniEMF.WriteInt(L"ArgosSpamTime", m_iArgosSpamTime);
	iniEMF.WriteInt(L"ArgosBadHelloTime", m_iArgosBadHelloTime);
	iniEMF.WriteInt(L"ArgosBadProtTime", m_iArgosBadProtTime);
	iniEMF.WriteInt(L"ArgosGPLBreakerPunishment", m_iArgosGPLBreakerPunishment);
	iniEMF.WriteInt(L"ArgosHardLeecherPunishment", m_iArgosHardLeecherPunishment);
	iniEMF.WriteInt(L"ArgosNormalLeecherPunishment", m_iArgosNormalLeecherPunishment);
	iniEMF.WriteInt(L"ArgosSoftLeecherPunishment", m_iArgosSoftLeecherPunishment);
	iniEMF.WriteInt(L"ArgosBadModPunishment", m_iArgosBadModPunishment);
	iniEMF.WriteInt(L"ArgosNickThiefPunishment", m_iArgosNickThiefPunishment);
	iniEMF.WriteInt(L"ArgosModThiefPunishment", m_iArgosModThiefPunishment);
	iniEMF.WriteInt(L"ArgosHashThiefPunishment", m_iArgosHashThiefPunishment);
	iniEMF.WriteInt(L"ArgosCreditHackPunishment", m_iArgosCreditHackPunishment);
	iniEMF.WriteInt(L"ArgosHashChangedPunishment", m_iArgosHashChangedPunishment);
	iniEMF.WriteInt(L"ArgosGhostModePunishment", m_iArgosGhostModePunishment);
	iniEMF.WriteInt(L"ArgosFakeClientPunishment", m_iArgosFakeClientPunishment);
	iniEMF.WriteInt(L"ArgosAgressonPunishment", m_iArgosAgressonPunishment);
	iniEMF.WriteInt(L"ArgosFileScannerPunishment", m_iArgosFileScannerPunishment);
	iniEMF.WriteInt(L"ArgosFileFakerPunishment", m_iArgosFileFakerPunishment);
	iniEMF.WriteInt(L"ArgosCorruptedSenderPunishment", m_iArgosCorruptedSenderPunishment);
	iniEMF.WriteInt(L"ArgosRankFlooderPunishment", m_iArgosRankFlooderPunishment);
	iniEMF.WriteInt(L"ArgosFailedPunishment", m_iArgosFailedPunishment);
	iniEMF.WriteInt(L"ArgosXSExploitPunishment", m_iArgosXSExploitPunishment);
	iniEMF.WriteInt(L"ArgosNickChangerPunishment", m_iArgosNickChangerPunishment);
	iniEMF.WriteInt(L"ArgosModChangerPunishment", m_iArgosModChangerPunishment);
	iniEMF.WriteInt(L"ArgosNullNickPunishment", m_iArgosNullNickPunishment);
	iniEMF.WriteInt(L"ArgosSpamPunishment", m_iArgosSpamPunishment);
	iniEMF.WriteInt(L"ArgosBadHelloPunishment", m_iArgosBadHelloPunishment);
	iniEMF.WriteInt(L"ArgosBadProtPunishment", m_iArgosBadProtPunishment);
	iniEMF.WriteBool(L"ArgosLeecherModDetection", m_bArgosLeecherModDetection);
	iniEMF.WriteInt(L"ArgosLeecherNickDetection", m_uArgosLeecherNickDetection);
	iniEMF.WriteInt(L"ArgosDetectionLevel", m_iArgosDetectionLevel);
	iniEMF.WriteBool(L"ArgosOpcodeDetection", m_bArgosOpcodeDetection);
	iniEMF.WriteBool(L"ArgosLeecherHashDetection", m_bArgosLeecherHashDetection);
	iniEMF.WriteBool(L"ArgosNickThiefDetection", m_bArgosNickThiefDetection);
	iniEMF.WriteBool(L"PlainAntiniXckThief", m_bPlainAntiNickThief);
	iniEMF.WriteBool(L"ArgosModThiefDetection", m_bArgosModThiefDetection);
	iniEMF.WriteBool(L"ArgosHashThiefDetection", m_bArgosHashThiefDetection);
	iniEMF.WriteBool(L"ArgosCreditHackDetection", m_bArgosCreditHackDetection);
	iniEMF.WriteBool(L"HashChangeDetection", m_bHashChangeDetection);
	iniEMF.WriteBool(L"ArgosGhostModDetection", m_bArgosGhostModDetection);
	iniEMF.WriteInt(L"ArgosFakeClientDetection", m_uArgosFakeClientDetection);
	iniEMF.WriteInt(L"AgressionDetection", m_uAgressionDetection);
	iniEMF.WriteInt(L"AgressionIntervals", m_iAgressionIntervals);
	iniEMF.WriteInt(L"AgressionThreshold", m_iAgressionThreshold);
	iniEMF.WriteBool(L"FileScannerDetection", m_bFileScannerDetection);
	iniEMF.WriteBool(L"FileFakerDetection", m_bFileFakerDetection);
	iniEMF.WriteBool(L"BadSenderDetection", m_bBadSenderDetection);
	iniEMF.WriteBool(L"RankFloodDetection", m_bRankFloodDetection);
	iniEMF.WriteBool(L"FailedDetection", m_bFailedDetection);
	iniEMF.WriteInt(L"FailedTries", m_iFailedTries);
	iniEMF.WriteInt(L"FailedThreshold", m_iFailedThreshold);
	iniEMF.WriteBool(L"XSExploitDetection", m_bXSExploitDetection);
	iniEMF.WriteInt(L"XSExploitIntervals", m_iXSExploitIntervals);
	iniEMF.WriteInt(L"XSExploitThreshold", m_iXSExploitThreshold);
	iniEMF.WriteBool(L"NickChangerDetection", m_bNickChangerDetection);
	iniEMF.WriteInt(L"NickChangeIntervals", m_iNickChangeIntervals);
	iniEMF.WriteInt(L"NickChangeThreshold", m_iNickChangeThreshold);
	iniEMF.WriteBool(L"ModChangerDetection", m_bModChangerDetection);
	iniEMF.WriteInt(L"ModChangeIntervals", m_iModChangeIntervals);
	iniEMF.WriteInt(L"ModChangeThreshold", m_iModChangeThreshold);
	iniEMF.WriteBool(L"NullNickDetection", m_bNullNickDetection);
	iniEMF.WriteBool(L"SpamDetection", m_bSpamDetection);
	iniEMF.WriteBool(L"BadHelloDetection", m_bBadHelloDetection);
	iniEMF.WriteInt(L"eMCryptDetection", m_ueMCryptDetection);
	iniEMF.WriteBool(L"BadProtDetection", m_bBadProtDetection);
	iniEMF.WriteInt(L"DLPDetection", m_uDLPDetection);
	iniEMF.WriteBool(L"ArgosLogLeechers", m_bArgosLogLeechers);
//<== dlarge Argos System (Xanatos)

}

void CPreferences::ResetStatsColor(int index)
{
	switch(index)
	{
		case  0: m_adwStatsColors[ 0]=RGB(  0,  0, 64);break;
		case  1: m_adwStatsColors[ 1]=RGB(192,192,255);break;
		case  2: m_adwStatsColors[ 2]=RGB(128,255,128);break;
		case  3: m_adwStatsColors[ 3]=RGB(  0,210,  0);break;
		case  4: m_adwStatsColors[ 4]=RGB(  0,128,  0);break;
		case  5: m_adwStatsColors[ 5]=RGB(255,128,128);break;
		case  6: m_adwStatsColors[ 6]=RGB(200,  0,  0);break;
		case  7: m_adwStatsColors[ 7]=RGB(140,  0,  0);break;
		case  8: m_adwStatsColors[ 8]=RGB(150,150,255);break;
		case  9: m_adwStatsColors[ 9]=RGB(192,  0,192);break;
		case 10: m_adwStatsColors[10]=RGB(255,255,128);break;
		case 11: m_adwStatsColors[11]=RGB(192,192,192);break;
		case 12: m_adwStatsColors[12]=RGB(255,255,255);break;
		case 13: m_adwStatsColors[13]=RGB(255,255,255);break;
		case 14: m_adwStatsColors[14]=RGB(255,190,190);break;
		case 15 : m_adwStatsColors[15]=RGB(192,192,255);break; //==> dlarge Source Graph 

	}
}

void CPreferences::GetAllStatsColors(int iCount, LPDWORD pdwColors)
{
	memset(pdwColors, 0, sizeof(*pdwColors) * iCount);
	memcpy(pdwColors, m_adwStatsColors, sizeof(*pdwColors) * min(_countof(m_adwStatsColors), iCount));
}

bool CPreferences::SetAllStatsColors(int iCount, const DWORD* pdwColors)
{
	bool bModified = false;
	int iMin = min(_countof(m_adwStatsColors), iCount);
	for (int i = 0; i < iMin; i++)
	{
		if (m_adwStatsColors[i] != pdwColors[i])
		{
			m_adwStatsColors[i] = pdwColors[i];
			bModified = true;
		}
	}
	return bModified;
}

void CPreferences::IniCopy(CString si, CString di)
{
	CIni ini(GetConfigFile(), L"eMule");
	CString s = ini.GetString(si);
	// Do NOT write empty settings, this will mess up reading of default settings in case
	// there were no settings (fresh emule install) at all available!
	if (!s.IsEmpty())
	{
		ini.SetSection(L"ListControlSetup");
		ini.WriteString(di,s);
	}
}

// Imports the tablesetups of emuleversions (.ini) <0.46b		- temporary
void CPreferences::ImportOldTableSetup() {

	IniCopy(L"DownloadColumnHidden" ,	L"DownloadListCtrlColumnHidden" );
	IniCopy(L"DownloadColumnWidths" ,	L"DownloadListCtrlColumnWidths" );
	IniCopy(L"DownloadColumnOrder" ,		L"DownloadListCtrlColumnOrders" );
	IniCopy(L"TableSortItemDownload" ,	L"DownloadListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingDownload" , L"DownloadListCtrlTableSortAscending" );

	IniCopy(L"ONContactListCtrlColumnHidden" ,	L"ONContactListCtrlColumnHidden" );
	IniCopy(L"ONContactListCtrlColumnWidths" ,	L"ONContactListCtrlColumnWidths" );
	IniCopy(L"ONContactListCtrlColumnOrders" ,		L"ONContactListCtrlColumnOrders" );

	IniCopy(L"KadSearchListCtrlColumnHidden" ,	L"KadSearchListCtrlColumnHidden" );
	IniCopy(L"KadSearchListCtrlColumnWidths" ,	L"KadSearchListCtrlColumnWidths" );
	IniCopy(L"KadSearchListCtrlColumnOrders" ,		L"KadSearchListCtrlColumnOrders" );
	
	IniCopy(L"UploadColumnHidden" ,		L"UploadListCtrlColumnHidden" );
	IniCopy(L"UploadColumnWidths" ,		L"UploadListCtrlColumnWidths" );
	IniCopy(L"UploadColumnOrder" ,		L"UploadListCtrlColumnOrders" );
	IniCopy(L"TableSortItemUpload" ,		L"UploadListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingUpload", L"UploadListCtrlTableSortAscending" );

	IniCopy(L"QueueColumnHidden" ,		L"QueueListCtrlColumnHidden" );
	IniCopy(L"QueueColumnWidths" ,		L"QueueListCtrlColumnWidths" );
	IniCopy(L"QueueColumnOrder" ,		L"QueueListCtrlColumnOrders" );
	IniCopy(L"TableSortItemQueue" ,		L"QueueListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingQueue" , L"QueueListCtrlTableSortAscending" );

	IniCopy(L"SearchColumnHidden" ,		L"SearchListCtrlColumnHidden" );
	IniCopy(L"SearchColumnWidths" ,		L"SearchListCtrlColumnWidths" );
	IniCopy(L"SearchColumnOrder" ,		L"SearchListCtrlColumnOrders" );
	IniCopy(L"TableSortItemSearch" ,		L"SearchListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingSearch", L"SearchListCtrlTableSortAscending" );

	IniCopy(L"SharedColumnHidden" ,		L"SharedFilesCtrlColumnHidden" );
	IniCopy(L"SharedColumnWidths" ,		L"SharedFilesCtrlColumnWidths" );
	IniCopy(L"SharedColumnOrder" ,		L"SharedFilesCtrlColumnOrders" );
	IniCopy(L"TableSortItemShared" ,		L"SharedFilesCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingShared", L"SharedFilesCtrlTableSortAscending" );

	IniCopy(L"ServerColumnHidden" ,		L"ServerListCtrlColumnHidden" );
	IniCopy(L"ServerColumnWidths" ,		L"ServerListCtrlColumnWidths" );
	IniCopy(L"ServerColumnOrder" ,		L"ServerListCtrlColumnOrders" );
	IniCopy(L"TableSortItemServer" ,		L"ServerListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingServer", L"ServerListCtrlTableSortAscending" );

	IniCopy(L"ClientListColumnHidden" ,		L"ClientListCtrlColumnHidden" );
	IniCopy(L"ClientListColumnWidths" ,		L"ClientListCtrlColumnWidths" );
	IniCopy(L"ClientListColumnOrder" ,		L"ClientListCtrlColumnOrders" );
	IniCopy(L"TableSortItemClientList" ,		L"ClientListCtrlTableSortItem" );
	IniCopy(L"TableSortAscendingClientList", L"ClientListCtrlTableSortAscending" );

	IniCopy(L"FilenamesListColumnHidden" ,	L"FileDetailDlgNameColumnHidden" );
	IniCopy(L"FilenamesListColumnWidths" ,	L"FileDetailDlgNameColumnWidths" );
	IniCopy(L"FilenamesListColumnOrder" ,	L"FileDetailDlgNameColumnOrders" );
	IniCopy(L"TableSortItemFilenames" ,		L"FileDetailDlgNameTableSortItem" );
	IniCopy(L"TableSortAscendingFilenames",  L"FileDetailDlgNameTableSortAscending" );

	IniCopy(L"DownloadClientsColumnHidden" ,		L"DownloadClientsCtrlColumnHidden" );
	IniCopy(L"DownloadClientsColumnWidths" ,		L"DownloadClientsCtrlColumnWidths" );
	IniCopy(L"DownloadClientsColumnOrder" ,		L"DownloadClientsCtrlColumnOrders" );
}

void CPreferences::LoadPreferences()
{
	CIni ini(GetConfigFile(), L"eMule");

	// import old (<0.46b) table setups - temporary
	if (ini.GetInt(L"SearchListCtrlTableSortItem",-1,L"ListControlSetup")==-1)
		ImportOldTableSetup();
	ini.SetSection(L"eMule");

	CString strCurrVersion, strPrefsVersion;

	strCurrVersion = theApp.m_strCurVersionLong + _T(" [") + theApp.m_strModLongVersion + _T("]"); //==> dlarge Modname
	strPrefsVersion = ini.GetString(L"AppVersion");

	m_bFirstStart = false;

	if (strCurrVersion != strPrefsVersion){
		m_bFirstStart = true;
	}

#ifdef _DEBUG
	m_iDbgHeap = ini.GetInt(L"DebugHeap", 1);
#else
	m_iDbgHeap = 0;
#endif

	m_nWebMirrorAlertLevel = ini.GetInt(L"WebMirrorAlertLevel",0);
	updatenotify=ini.GetBool(L"UpdateNotifyTestClient",false);

	SetUserNick(ini.GetStringUTF8(L"Nick", DEFAULT_NICK));
	if (strNick.IsEmpty() || IsDefaultNick(strNick))
		SetUserNick(DEFAULT_NICK);

	m_strIncomingDir = ini.GetString(L"IncomingDir", _T(""));
	if (m_strIncomingDir.IsEmpty()) // We want GetDefaultDirectory to also create the folder, so we have to know if we use the default or not
		m_strIncomingDir = GetDefaultDirectory(EMULE_INCOMINGDIR, true);
	MakeFoldername(m_strIncomingDir);

	// load tempdir(s) setting
	CString tempdirs;
	tempdirs = ini.GetString(L"TempDir", _T(""));
	if (tempdirs.IsEmpty()) // We want GetDefaultDirectory to also create the folder, so we have to know if we use the default or not
		tempdirs = GetDefaultDirectory(EMULE_TEMPDIR, true);
	tempdirs += L"|" + ini.GetString(L"TempDirs");

	int curPos=0;
	bool doubled;
	CString atmp=tempdirs.Tokenize(L"|", curPos);
	while (!atmp.IsEmpty())
	{
		atmp.Trim();
		if (!atmp.IsEmpty()) {
			MakeFoldername(atmp);
			doubled=false;
			for (int i=0;i<tempdir.GetCount();i++)	// avoid double tempdirs
				if (atmp.CompareNoCase(GetTempDir(i))==0) {
					doubled=true;
					break;
				}
			if (!doubled) {
				if (PathFileExists(atmp)==FALSE) {
					CreateDirectory(atmp,NULL);
					if (PathFileExists(atmp)==TRUE || tempdir.GetCount()==0)
						tempdir.Add(atmp);
				}
				else
					tempdir.Add(atmp);
			}
		}
		atmp = tempdirs.Tokenize(L"|", curPos);
	}

	maxGraphDownloadRate=ini.GetInt(L"DownloadCapacity",96);
	if (maxGraphDownloadRate==0)
		maxGraphDownloadRate=96;
	
	maxGraphUploadRate = ini.GetInt(L"UploadCapacityNew",-1);
	if (maxGraphUploadRate == 0)
		maxGraphUploadRate = UNLIMITED;
	else if (maxGraphUploadRate == -1){
		// converting value from prior versions
		int nOldUploadCapacity = ini.GetInt(L"UploadCapacity", 16);
		if (nOldUploadCapacity == 16 && ini.GetInt(L"MaxUpload",12) == 12){
			// either this is a complete new install, or the prior version used the default value
			// in both cases, set the new default values to unlimited
			maxGraphUploadRate = UNLIMITED;
			ini.WriteInt(L"MaxUpload",UNLIMITED, L"eMule");
		}
		else
			maxGraphUploadRate = nOldUploadCapacity; // use old custoum value
	}

	minupload=(uint16)ini.GetInt(L"MinUpload", 5); //==> dlarge Mod

//==> dlarge SUC/USS 
	minupload =(uint16) min(max(minupload,1),maxGraphUploadRate); 
//<== dlarge SUC/USS 

	maxupload=(uint16)ini.GetInt(L"MaxUpload",UNLIMITED);
	if (maxupload > maxGraphUploadRate && maxupload != UNLIMITED)
		maxupload = (uint16)(maxGraphUploadRate * .8);
	
	maxdownload=(uint16)ini.GetInt(L"MaxDownload", UNLIMITED);
	if (maxdownload > maxGraphDownloadRate && maxdownload != UNLIMITED)
		maxdownload = (uint16)(maxGraphDownloadRate * .8);
	maxconnections=ini.GetInt(L"MaxConnections",GetRecommendedMaxConnections());
	maxhalfconnections=ini.GetInt(L"MaxHalfConnections",9);
	m_bConditionalTCPAccept = ini.GetBool(L"ConditionalTCPAccept", false);

	// reset max halfopen to a default if OS changed to SP2 (or higher) or away
	int dwSP2OrHigher = ini.GetInt(L"WinXPSP2OrHigher", -1);
	int dwCurSP2OrHigher = IsRunningXPSP2OrHigher();
	if (dwSP2OrHigher != dwCurSP2OrHigher){
		if (dwCurSP2OrHigher == 0)
			maxhalfconnections = 50;
		else if (dwCurSP2OrHigher == 1)
			maxhalfconnections = 9;
	}

	m_strBindAddrW = ini.GetString(L"BindAddr");
	m_strBindAddrW.Trim();
	m_pszBindAddrW = m_strBindAddrW.IsEmpty() ? NULL : (LPCWSTR)m_strBindAddrW;
	m_strBindAddrA = m_strBindAddrW;
	m_pszBindAddrA = m_strBindAddrA.IsEmpty() ? NULL : (LPCSTR)m_strBindAddrA;

	port = (uint16)ini.GetInt(L"Port", 0);
	if (port == 0)
		port = thePrefs.GetRandomTCPPort();

	// 0 is a valid value for the UDP port setting, as it is used for disabling it.
	int iPort = ini.GetInt(L"UDPPort", INT_MAX/*invalid port value*/);
	if (iPort == INT_MAX)
		udpport = thePrefs.GetRandomUDPPort();
	else
		udpport = (uint16)iPort;

	nServerUDPPort = (uint16)ini.GetInt(L"ServerUDPPort", -1); // 0 = Don't use UDP port for servers, -1 = use a random port (for backward compatibility)
	maxsourceperfile=ini.GetInt(L"MaxSourcesPerFile",400 );
	m_wLanguageID=ini.GetWORD(L"Language",0);
	m_iSeeShares=(EViewSharedFilesAccess)ini.GetInt(L"SeeShare",vsfaNobody);
	m_iToolDelayTime=ini.GetInt(L"ToolTipDelay",1);
	trafficOMeterInterval=ini.GetInt(L"StatGraphsInterval",3);
	statsInterval=ini.GetInt(L"statsInterval",5);
	m_bFillGraphs=ini.GetBool(L"StatsFillGraphs");
	dontcompressavi=ini.GetBool(L"DontCompressAvi",false);

	m_uDeadServerRetries=ini.GetInt(L"DeadServerRetry",3); //==> dlarge changed to 3
	if (m_uDeadServerRetries > MAX_SERVERFAILCOUNT)
		m_uDeadServerRetries = MAX_SERVERFAILCOUNT;
	m_dwServerKeepAliveTimeout=ini.GetInt(L"ServerKeepAliveTimeout",0);
	splitterbarPosition=ini.GetInt(L"SplitterbarPosition",75);
	if (splitterbarPosition < 9)
		splitterbarPosition = 9;
	else if (splitterbarPosition > 93)
		splitterbarPosition = 93;
	splitterbarPositionStat=ini.GetInt(L"SplitterbarPositionStat",30);
	splitterbarPositionStat_HL=ini.GetInt(L"SplitterbarPositionStat_HL",66);
	splitterbarPositionStat_HR=ini.GetInt(L"SplitterbarPositionStat_HR",33);
	if (splitterbarPositionStat_HR+1>=splitterbarPositionStat_HL){
		splitterbarPositionStat_HL = 66;
		splitterbarPositionStat_HR = 33;
	}
	splitterbarPositionFriend=ini.GetInt(L"SplitterbarPositionFriend",170);
	splitterbarPositionShared=ini.GetInt(L"SplitterbarPositionShared",179);
	splitterbarPositionSvr=ini.GetInt(L"SplitterbarPositionServer",75);
	if (splitterbarPositionSvr>90 || splitterbarPositionSvr<10)
		splitterbarPositionSvr=75;

	m_uTransferWnd1 = ini.GetInt(L"TransferWnd1",0);
	m_uTransferWnd2 = ini.GetInt(L"TransferWnd2",1);

	statsMax=ini.GetInt(L"VariousStatisticsMaxValue",100);
	statsAverageMinutes=ini.GetInt(L"StatsAverageMinutes",5);
	MaxConperFive=ini.GetInt(L"MaxConnectionsPerFiveSeconds",GetDefaultMaxConperFive());

	reconnect = ini.GetBool(L"Reconnect", true);
	m_bUseServerPriorities = ini.GetBool(L"Scoresystem", true);
	m_bUseUserSortedServerList = ini.GetBool(L"UserSortedServerList", false);
	ICH = ini.GetBool(L"ICH", true);
	m_bAutoUpdateServerList = ini.GetBool(L"Serverlist", false);

	// since the minimize to tray button is not working under Aero (at least not at this point),
	// we enable map the minimize to tray on the minimize button by default if Aero is running
	if (IsRunningAeroGlassTheme())
		mintotray=ini.GetBool(L"MinToTray_Aero", true);
	else
		mintotray=ini.GetBool(L"MinToTray", false);

	m_bPreventStandby = ini.GetBool(L"PreventStandby", false);
	m_bStoreSearches = ini.GetBool(L"StoreSearches", true);
	m_bAddServersFromServer=ini.GetBool(L"AddServersFromServer",false);
	m_bAddServersFromClients=ini.GetBool(L"AddServersFromClient",false);
	splashscreen=ini.GetBool(L"Splashscreen",true);
	bringtoforeground=ini.GetBool(L"BringToFront",true);
	transferDoubleclick=ini.GetBool(L"TransferDoubleClick",true);
	beepOnError=ini.GetBool(L"BeepOnError",true);
	confirmExit=ini.GetBool(L"ConfirmExit",true);
	filterLANIPs=ini.GetBool(L"FilterBadIPs",true);
	m_bAllocLocalHostIP=ini.GetBool(L"AllowLocalHostIP",false);
	autoconnect=ini.GetBool(L"Autoconnect",true); //==> changed dlarge
	showRatesInTitle=ini.GetBool(L"ShowRatesOnTitle",true); //==> changed dlarge
	m_bIconflashOnNewMessage=ini.GetBool(L"IconflashOnNewMessage",false);

	onlineSig=ini.GetBool(L"OnlineSignature",false);
	startMinimized=ini.GetBool(L"StartupMinimized",false);
	m_bAutoStart=ini.GetBool(L"AutoStart",false);
	m_bRestoreLastMainWndDlg=ini.GetBool(L"RestoreLastMainWndDlg",false);
	m_iLastMainWndDlgID=ini.GetInt(L"LastMainWndDlgID",0);
	m_bRestoreLastLogPane=ini.GetBool(L"RestoreLastLogPane",false);
	m_iLastLogPaneID=ini.GetInt(L"LastLogPaneID",0);
	m_bSafeServerConnect =ini.GetBool(L"SafeServerConnect",false);

	m_bTransflstRemain =ini.GetBool(L"TransflstRemainOrder",false);
	filterserverbyip=ini.GetBool(L"FilterServersByIP",true); //==> changed dlarge
	filterlevel=ini.GetInt(L"FilterLevel",127);
	checkDiskspace=ini.GetBool(L"CheckDiskspace",false);
	m_uMinFreeDiskSpace=ini.GetInt(L"MinFreeDiskSpace",20*1024*1024);
	m_bSparsePartFiles=ini.GetBool(L"SparsePartFiles",false);
	m_strYourHostname=ini.GetString(L"YourHostname", L"");

	// Barry - New properties...
	m_bAutoConnectToStaticServersOnly = ini.GetBool(L"AutoConnectStaticOnly",false); 
	autotakeed2klinks = ini.GetBool(L"AutoTakeED2KLinks",true); 
	addnewfilespaused = ini.GetBool(L"AddNewFilesPaused",false); 
	depth3D = ini.GetInt(L"3DDepth", 5);
	m_bEnableMiniMule = ini.GetBool(L"MiniMule", true);
//==> dlarge Hidden Prefs
	m_bMiniMuleAutoClose = ini.GetBool(L"MiniMuleAutoClose", false);
//<== dlarge Hidden Prefs

	// Notifier
	notifierConfiguration = ini.GetString(L"NotifierConfiguration", GetMuleDirectory(EMULE_CONFIGDIR) + L"Notifier.ini");
    notifierOnDownloadFinished = ini.GetBool(L"NotifyOnDownload");
	notifierOnNewDownload = ini.GetBool(L"NotifyOnNewDownload");
    notifierOnChat = ini.GetBool(L"NotifyOnChat");
    notifierOnLog = ini.GetBool(L"NotifyOnLog");
	notifierOnImportantError = ini.GetBool(L"NotifyOnImportantError");
	notifierOnEveryChatMsg = ini.GetBool(L"NotifierPopEveryChatMessage");
	notifierOnNewVersion = ini.GetBool(L"NotifierPopNewVersion");
    notifierSoundType = (ENotifierSoundType)ini.GetInt(L"NotifierUseSound", ntfstNoSound);
	notifierSoundFile = ini.GetString(L"NotifierSoundPath");

	m_strDateTimeFormat = ini.GetString(L"DateTimeFormat", L"%A, %c");
	m_strDateTimeFormat4Log = ini.GetString(L"DateTimeFormat4Log", L"%c");

	m_bMessageEnableSmileys = ini.GetBool(L"MessageEnableSmileys", true);

	m_bSmartServerIdCheck = ini.GetBool(L"SmartIdCheck",true);
	log2disk = ini.GetBool(L"SaveLogToDisk",false);
	uMaxLogFileSize = ini.GetInt(L"MaxLogFileSize", 1024*1024);
	iMaxLogBuff = ini.GetInt(L"MaxLogBuff",64) * 1024;
	m_iLogFileFormat = (ELogFileFormat)ini.GetInt(L"LogFileFormat", Unicode);
	m_bEnableVerboseOptions=ini.GetBool(L"VerboseOptions", true);
	if (m_bEnableVerboseOptions)
	{
		m_bVerbose=ini.GetBool(L"Verbose",false);
		m_bFullVerbose=ini.GetBool(L"FullVerbose",false);
		debug2disk=ini.GetBool(L"SaveDebugToDisk",false);
		m_bDebugSourceExchange=ini.GetBool(L"DebugSourceExchange",false);
		m_bLogBannedClients=ini.GetBool(L"LogBannedClients", true); //==> changed dlarge
		m_bLogRatingDescReceived=ini.GetBool(L"LogRatingDescReceived",true); //==> changed dlarge
		m_bLogSecureIdent=ini.GetBool(L"LogSecureIdent",true); //==> changed dlarge
		m_bLogFilteredIPs=ini.GetBool(L"LogFilteredIPs",true); //==> changed dlarge
		m_bLogFileSaving=ini.GetBool(L"LogFileSaving",false);
        m_bLogA4AF=ini.GetBool(L"LogA4AF",false); // ZZ:DownloadManager
		m_bLogUlDlEvents=ini.GetBool(L"LogUlDlEvents",true);
	}
	else
	{
		if (m_bRestoreLastLogPane && m_iLastLogPaneID>=2)
			m_iLastLogPaneID = 1;
	}
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	// following options are for debugging or when using an external debug device viewer only.
	m_iDebugServerTCPLevel = ini.GetInt(L"DebugServerTCP", 0);
	m_iDebugServerUDPLevel = ini.GetInt(L"DebugServerUDP", 0);
	m_iDebugServerSourcesLevel = ini.GetInt(L"DebugServerSources", 0);
	m_iDebugServerSearchesLevel = ini.GetInt(L"DebugServerSearches", 0);
	m_iDebugClientTCPLevel = ini.GetInt(L"DebugClientTCP", 0);
	m_iDebugClientUDPLevel = ini.GetInt(L"DebugClientUDP", 0);
	m_iDebugClientKadUDPLevel = ini.GetInt(L"DebugClientKadUDP", 0);
	m_iDebugSearchResultDetailLevel = ini.GetInt(L"DebugSearchResultDetailLevel", 0);
#else
	// for normal release builds ensure that those options are all turned off
	m_iDebugServerTCPLevel = 0;
	m_iDebugServerUDPLevel = 0;
	m_iDebugServerSourcesLevel = 0;
	m_iDebugServerSearchesLevel = 0;
	m_iDebugClientTCPLevel = 0;
	m_iDebugClientUDPLevel = 0;
	m_iDebugClientKadUDPLevel = 0;
	m_iDebugSearchResultDetailLevel = 0;
#endif

	m_bpreviewprio=ini.GetBool(L"PreviewPrio",false);
	m_bupdatequeuelist=ini.GetBool(L"UpdateQueueListPref",false);
	m_bManualAddedServersHighPriority=ini.GetBool(L"ManualHighPrio",false);
//	m_btransferfullchunks=ini.GetBool(L"FullChunkTransfers",true); //VQB: fullChunk
	m_istartnextfile=ini.GetInt(L"StartNextFile",0);
	m_bshowoverhead=ini.GetBool(L"ShowOverhead",false);
	moviePreviewBackup=ini.GetBool(L"VideoPreviewBackupped",true);
	m_iPreviewSmallBlocks=ini.GetInt(L"PreviewSmallBlocks", 0);
	m_bPreviewCopiedArchives=ini.GetBool(L"PreviewCopiedArchives", true);
	m_iInspectAllFileTypes=ini.GetInt(L"InspectAllFileTypes", 0);
	m_bAllocFull=ini.GetBool(L"AllocateFullFile",0);
	m_bAutomaticArcPreviewStart=ini.GetBool(L"AutoArchivePreviewStart", true );

	// read file buffer size (with backward compatibility)
	m_iFileBufferSize=ini.GetInt(L"FileBufferSizePref",0); // old setting
	if (m_iFileBufferSize == 0)
		m_iFileBufferSize = 256*1024;
	else
		m_iFileBufferSize = ((m_iFileBufferSize*15000 + 512)/1024)*1024;
	m_iFileBufferSize=ini.GetInt(L"FileBufferSize",m_iFileBufferSize);
//>>> WiZaRd::IntelliFlush
	m_bUseIntelliFlush = ini.GetBool(L"IntelliFlush", true);
	m_uiFileBufferFlushTime = (UINT)ini.GetInt(L"FileBufferFlushTime", 60000);
//<<< WiZaRd::IntelliFlush

	// read queue size (with backward compatibility)
	m_iQueueSize=ini.GetInt(L"QueueSizePref",0); // old setting
	if (m_iQueueSize == 0)
		m_iQueueSize = 50*100;
	else
		m_iQueueSize = m_iQueueSize*100;
	m_iQueueSize=ini.GetInt(L"QueueSize",m_iQueueSize);

	m_iCommitFiles=ini.GetInt(L"CommitFiles", 1); // 1 = "commit" on application shut down; 2 = "commit" on each file saveing
	versioncheckdays=ini.GetInt(L"Check4NewVersionDelay",5);
	m_bDAP=ini.GetBool(L"DAPPref",true);
	m_bUAP=ini.GetBool(L"UAPPref",true);
	m_bPreviewOnIconDblClk=ini.GetBool(L"PreviewOnIconDblClk",false);
	indicateratings=ini.GetBool(L"IndicateRatings",true);
	watchclipboard=ini.GetBool(L"WatchClipboard4ED2kFilelinks",false);
	m_iSearchMethod=ini.GetInt(L"SearchMethod",0);
	showCatTabInfos=ini.GetBool(L"ShowInfoOnCatTabs",true); //==> dlarge changed 
//	resumeSameCat=ini.GetBool(L"ResumeNextFromSameCat",false);
	dontRecreateGraphs =ini.GetBool(L"DontRecreateStatGraphsOnResize",false);
	m_bExtControls =ini.GetBool(L"ShowExtControls",true); //==> dlarge changed 

	versioncheckLastAutomatic=ini.GetInt(L"VersionCheckLastAutomatic",0);
	m_bDisableKnownClientList=ini.GetBool(L"DisableKnownClientList",false);
	m_bDisableQueueList=ini.GetBool(L"DisableQueueList",false);
	m_bCreditSystem=true; //==> dlarge CreditSystem
	scheduler=ini.GetBool(L"EnableScheduler",false);
	msgonlyfriends=ini.GetBool(L"MessagesFromFriendsOnly",false);
	msgsecure=ini.GetBool(L"MessageFromValidSourcesOnly",true);
	m_bUseChatCaptchas = ini.GetBool(L"MessageUseCaptchas", true);
	autofilenamecleanup=ini.GetBool(L"AutoFilenameCleanup",false);
	m_bUseAutocompl=ini.GetBool(L"UseAutocompletion",true);
	m_bShowDwlPercentage=ini.GetBool(L"ShowDwlPercentage",false);
	networkkademlia=ini.GetBool(L"NetworkKademlia",true); //==> dlarge changed 
	networked2k=ini.GetBool(L"NetworkED2K",false); //==> dlarge changed 
	m_bRemove2bin=ini.GetBool(L"RemoveFilesToBin",true);
	m_bShowCopyEd2kLinkCmd=ini.GetBool(L"ShowCopyEd2kLinkCmd",false);

	m_iMaxChatHistory=ini.GetInt(L"MaxChatHistoryLines",100);
	if (m_iMaxChatHistory < 1)
		m_iMaxChatHistory = 100;
	maxmsgsessions=ini.GetInt(L"MaxMessageSessions",50);
//	m_bShowActiveDownloadsBold = ini.GetBool(L"ShowActiveDownloadsBold", false); //==> dlarge Design Settings 

	m_strTxtEditor = ini.GetString(L"TxtEditor", L"notepad.exe");
	m_strVideoPlayer = ini.GetString(L"VideoPlayer", L"");
	m_strVideoPlayerArgs = ini.GetString(L"VideoPlayerArgs",L"");
	
	m_strTemplateFile = ini.GetString(L"WebTemplateFile", GetMuleDirectory(EMULE_EXECUTEABLEDIR) + L"eMule.tmpl");
	// if emule is using the default, check if the file is in the config folder, as it used to be in prior version
	// and might be wanted by the user when switching to a personalized template
	if (m_strTemplateFile.Compare(GetMuleDirectory(EMULE_EXECUTEABLEDIR) + L"eMule.tmpl") == 0){
		CFileFind ff;
		if (ff.FindFile(GetMuleDirectory(EMULE_CONFIGDIR) + L"eMule.tmpl"))
			m_strTemplateFile = GetMuleDirectory(EMULE_CONFIGDIR) + L"eMule.tmpl";
		ff.Close();
	}

	messageFilter=ini.GetStringLong(L"MessageFilter", DEF_MSG_FILTER); //==> dlarge Argos System (Xanatos)
	commentFilter = ini.GetStringLong(L"CommentFilter", DEF_COM_FILTER); //==> dlarge Argos System (Xanatos)
	commentFilter.MakeLower();
	filenameCleanups=ini.GetStringLong(L"FilenameCleanups",L"http|www.|.com|.de|.org|.net|shared|powered|sponsored|sharelive|filedonkey|saugstube|eselfilme|eseldownloads|emulemovies|spanishare|eselpsychos.de|saughilfe.de|goldesel.6x.to|freedivx.org|elitedivx|deviance|-ftv|ftv|-flt|flt"); //==> dlarge changed 
	m_iExtractMetaData = ini.GetInt(L"ExtractMetaData", 1); // 0=disable, 1=mp3, 2=MediaDet
	if (m_iExtractMetaData > 1)
		m_iExtractMetaData = 1;
	m_bAdjustNTFSDaylightFileTime=ini.GetBool(L"AdjustNTFSDaylightFileTime", true);

	m_bUseSecureIdent=ini.GetBool(L"SecureIdent",true);
	m_bAdvancedSpamfilter=ini.GetBool(L"AdvancedSpamFilter",true);
	m_bRemoveFinishedDownloads=ini.GetBool(L"AutoClearCompleted",false);
	m_bUseOldTimeRemaining= ini.GetBool(L"UseSimpleTimeRemainingcomputation",false);

	m_iStraightWindowStyles=ini.GetInt(L"StraightWindowStyles",0);
	m_bUseSystemFontForMainControls=ini.GetBool(L"UseSystemFontForMainControls",0);
	m_bRTLWindowsLayout = ini.GetBool(L"RTLWindowsLayout");

	LPBYTE pData = NULL;
	UINT uSize = sizeof m_lfHyperText;
	if (ini.GetBinary(L"HyperTextFont", &pData, &uSize) && uSize == sizeof m_lfHyperText)
		memcpy(&m_lfHyperText, pData, sizeof m_lfHyperText);
	else
		memset(&m_lfHyperText, 0, sizeof m_lfHyperText);
	delete[] pData;

	pData = NULL;
	uSize = sizeof m_lfLogText;
	if (ini.GetBinary(L"LogTextFont", &pData, &uSize) && uSize == sizeof m_lfLogText)
		memcpy(&m_lfLogText, pData, sizeof m_lfLogText);
	else
		memset(&m_lfLogText, 0, sizeof m_lfLogText);
	delete[] pData;

	m_crLogError = ini.GetColRef(L"LogErrorColor", m_crLogError);
	m_crLogWarning = ini.GetColRef(L"LogWarningColor", m_crLogWarning);
	m_crLogSuccess = ini.GetColRef(L"LogSuccessColor", m_crLogSuccess);

	if (statsAverageMinutes < 1)
		statsAverageMinutes = 5;

	// ZZ:UploadSpeedSense -->
	if (!m_bSUCEnabled) 	//==> dlarge SUC/USS
    m_bDynUpEnabled = ini.GetBool(L"USSEnabled", false);
    m_bDynUpUseMillisecondPingTolerance = ini.GetBool(L"USSUseMillisecondPingTolerance", false);
    m_iDynUpPingTolerance = ini.GetInt(L"USSPingTolerance", 500);
	m_iDynUpPingToleranceMilliseconds = ini.GetInt(L"USSPingToleranceMilliseconds", 200);
	if( minupload < 1 )
		minupload = 1;
	m_iDynUpGoingUpDivider = ini.GetInt(L"USSGoingUpDivider", 1000);
    m_iDynUpGoingDownDivider = ini.GetInt(L"USSGoingDownDivider", 1000);
    m_iDynUpNumberOfPings = ini.GetInt(L"USSNumberOfPings", 1);
	// ZZ:UploadSpeedSense <--

    m_bA4AFSaveCpu = ini.GetBool(L"A4AFSaveCpu", false); // ZZ:DownloadManager
    m_bHighresTimer = ini.GetBool(L"HighresTimer", false);
	m_bRunAsUser = ini.GetBool(L"RunAsUnprivilegedUser", false);
	m_bPreferRestrictedOverUser = ini.GetBool(L"PreferRestrictedOverUser", false);
	m_bOpenPortsOnStartUp = ini.GetBool(L"OpenPortsOnStartUp", false);
	m_byLogLevel = ini.GetInt(L"DebugLogLevel", DLP_VERYLOW);
	m_bTrustEveryHash = ini.GetBool(L"AICHTrustEveryHash", false);
	m_bRememberCancelledFiles = ini.GetBool(L"RememberCancelledFiles", true);
	m_bRememberDownloadedFiles = ini.GetBool(L"RememberDownloadedFiles", true);

	m_bNotifierSendMail = ini.GetBool(L"NotifierSendMail", false);
#if _ATL_VER >= 0x0710
	if (!IsRunningXPSP2OrHigher())
		m_bNotifierSendMail = false;
#endif
	m_strNotifierMailSender = ini.GetString(L"NotifierMailSender", L"");
	m_strNotifierMailServer = ini.GetString(L"NotifierMailServer", L"");
	m_strNotifierMailReceiver = ini.GetString(L"NotifierMailRecipient", L"");

	m_bWinaTransToolbar = ini.GetBool(L"WinaTransToolbar", true);

	m_bCryptLayerRequested = ini.GetBool(L"CryptLayerRequested", false);
	m_bCryptLayerRequired = ini.GetBool(L"CryptLayerRequired", false);
	m_bCryptLayerSupported = ini.GetBool(L"CryptLayerSupported", true);
	m_dwKadUDPKey = ini.GetInt(L"KadUDPKey", GetRandomUInt32());
	m_byCryptTCPPaddingLength = (uint8)ini.GetInt(L"CryptTCPPaddingLength", 128);

	m_bEnableSearchResultFilter = ini.GetBool(L"EnableSearchResultSpamFilter", true);

        m_bCryptLayerRequiredStrictServer = ini.GetBool(L"CryptLayerRequiredStrictServer",false); //==> dlarge lh require obfuscated server connection (MorphXT)

	///////////////////////////////////////////////////////////////////////////
	// Section: "Proxy"
	//
	proxy.EnablePassword = ini.GetBool(L"ProxyEnablePassword",false,L"Proxy");
	proxy.UseProxy = ini.GetBool(L"ProxyEnableProxy",false,L"Proxy");
	proxy.name = CStringA(ini.GetString(L"ProxyName", L"", L"Proxy"));
	proxy.user = CStringA(ini.GetString(L"ProxyUser", L"", L"Proxy"));
	proxy.password = CStringA(ini.GetString(L"ProxyPassword", L"", L"Proxy"));
	proxy.port = (uint16)ini.GetInt(L"ProxyPort",1080,L"Proxy");
	proxy.type = (uint16)ini.GetInt(L"ProxyType",PROXYTYPE_NOPROXY,L"Proxy");


	///////////////////////////////////////////////////////////////////////////
	// Section: "Statistics"
	//
	statsSaveInterval = ini.GetInt(L"SaveInterval", 60, L"Statistics");
	statsConnectionsGraphRatio = ini.GetInt(L"statsConnectionsGraphRatio", 3, L"Statistics");
	m_strStatsExpandedTreeItems = ini.GetString(L"statsExpandedTreeItems",L"111000000100000110000010000011110000010010",L"Statistics");
	CString buffer2;
	for (int i = 0; i < _countof(m_adwStatsColors); i++) {
		buffer2.Format(L"StatColor%i", i);
		m_adwStatsColors[i] = 0;
		if (_stscanf(ini.GetString(buffer2, L"", L"Statistics"), L"%i", &m_adwStatsColors[i]) != 1)
			ResetStatsColor(i);
	}
	m_bShowVerticalHourMarkers = ini.GetBool(L"ShowVerticalHourMarkers", true, L"Statistics");

	// -khaos--+++> Load Stats
	// I changed this to a seperate function because it is now also used
	// to load the stats backup and to load stats from preferences.ini.old.
	LoadStats();
	// <-----khaos-

	///////////////////////////////////////////////////////////////////////////
	// Section: "WebServer"
	//
	m_strWebPassword = ini.GetString(L"Password", L"", L"WebServer");
	m_strWebLowPassword = ini.GetString(L"PasswordLow", L"");
	m_nWebPort=(uint16)ini.GetInt(L"Port", 4711);
	m_bWebEnabled=ini.GetBool(L"Enabled", false);
	m_bWebUseGzip=ini.GetBool(L"UseGzip", true);
	m_bWebLowEnabled=ini.GetBool(L"UseLowRightsUser", false);
	m_nWebPageRefresh=ini.GetInt(L"PageRefreshTime", 120);
	m_iWebTimeoutMins=ini.GetInt(L"WebTimeoutMins", 5 );
	m_iWebFileUploadSizeLimitMB=ini.GetInt(L"MaxFileUploadSizeMB", 5 );
	m_bAllowAdminHiLevFunc=ini.GetBool(L"AllowAdminHiLevelFunc", false);
	buffer2 = ini.GetString(L"AllowedIPs");
	int iPos = 0;
	CString strIP = buffer2.Tokenize(L";", iPos);
	while (!strIP.IsEmpty())
	{
		u_long nIP = inet_addr(CStringA(strIP));
		if (nIP != INADDR_ANY && nIP != INADDR_NONE)
			m_aAllowedRemoteAccessIPs.Add(nIP);
		strIP = buffer2.Tokenize(L";", iPos);
	}

	///////////////////////////////////////////////////////////////////////////
	// Section: "MobileMule"
	//
	m_strMMPassword = ini.GetString(L"Password", L"", L"MobileMule");
	m_bMMEnabled = ini.GetBool(L"Enabled", false);
	m_nMMPort = (uint16)ini.GetInt(L"Port", 80);

	///////////////////////////////////////////////////////////////////////////
	// Section: "PeerCache"
	//
	m_uPeerCacheLastSearch = ini.GetInt(L"LastSearch", 0, L"PeerCache");
	m_bPeerCacheWasFound = ini.GetBool(L"Found", false);
	m_bPeerCacheEnabled = ini.GetBool(L"EnabledDeprecated", false);
	m_nPeerCachePort = (uint16)ini.GetInt(L"PCPort", 0);
	m_bPeerCacheShow = ini.GetBool(L"Show", false);

	///////////////////////////////////////////////////////////////////////////
	// Section: "UPnP"
	//
	m_bEnableUPnP = ini.GetBool(L"EnableUPnP", false, L"UPnP");
	m_bSkipWANIPSetup = ini.GetBool(L"SkipWANIPSetup", false);
	m_bSkipWANPPPSetup = ini.GetBool(L"SkipWANPPPSetup", false);
	m_bCloseUPnPOnExit = ini.GetBool(L"CloseUPnPOnExit", true);

//>>> WiZaRd::Own Prefs
	//backup the current prefs file and then create a new one...
	CString newpath;
	newpath.Format(_T("%semfprefs.ini"), GetMuleDirectory(EMULE_CONFIGDIR));
	CIni iniEMF(newpath, L"EMF");
	//ini.SetSection(_T("EMF"));
//<<< WiZaRd::Own Prefs
	//"first start" means that either no prefs were found (in this case the default mechanism would be sufficient) 
	//or that another version was run up to now - this is why I enforce a check-and-set mechanism here
	if(m_bFirstStart)
	{
		m_uiFUChunks = 1;
//>>> WiZaRd::AutoHL
		m_iAutoHLUpdateTimer = 60;
		m_iUseAutoHL = 1;
		m_iMinAutoHL = 25;
		m_iMaxAutoHL = _UI16_MAX;
		m_iMaxSourcesHL = _UI16_MAX;
//<<< WiZaRd::AutoHL
	}
	else
	{
		m_uiFUChunks = (uint8)max(iniEMF.GetInt(L"FUChunks", 1), 1);
//>>> WiZaRd::AutoHL
		m_iAutoHLUpdateTimer = (uint16)iniEMF.GetInt(_T("AutoHLUpdate"), 60);
#define MINMAX(val, mini, maxi)		{val = (min(max(mini, val), maxi));}
		MINMAX(m_iAutoHLUpdateTimer, 10, 600);
		m_iUseAutoHL = (sint8)iniEMF.GetInt(L"UseAutoHL", 1);
		m_iMinAutoHL = (uint16)iniEMF.GetInt(L"MinAutoHL", 25);
		m_iMaxAutoHL = (uint16)iniEMF.GetInt(L"MaxAutoHL", _UI16_MAX);
		m_iMaxAutoHL = max(m_iMinAutoHL, m_iMaxAutoHL);
		m_iMaxSourcesHL = (uint16)iniEMF.GetInt(L"MaxSourcesHL", _UI16_MAX);
//<<< WiZaRd::AutoHL
	}
//>>> WiZaRd::Payback First
	//0: off - 1: one slot at a time - 2: every 5th slot - 3: auto (mix of 1+2)
	m_uiPaybackFirst = (uint8)iniEMF.GetInt(L"PBF", 1); 
//<<< WiZaRd::Payback First
//>>> shadow2004::FDC [BlueSonicBoy]
	m_bFDCEnabled = iniEMF.GetBool(L"FilenameDisparityCheck", true);
	m_bFDCDouble = iniEMF.GetBool(L"FDCDoubleCheck", true);
	m_uiFDCSensitivity = (uint8)iniEMF.GetInt(L"FDCSensitivity", 83);
//<<< shadow2004::FDC [BlueSonicBoy]
//>>> Spike2::Emulate other
	m_bEmueDonkey = iniEMF.GetBool(L"Emulate eDonkey", true);
	m_bEmueDonkeyHybrid = iniEMF.GetBool(L"Emulate eDonkeyHybrid", true);
	m_bEmuMLDonkey = iniEMF.GetBool(L"Emulate MLDonkey", true);
	m_bEmuShareaza = iniEMF.GetBool(L"Emulate Shareaza", true);
	m_bEmuLphant = iniEMF.GetBool(L"Emulate Lphant", true);
//<<< Spike2::Emulate other
//>>> WiZaRd::ServerMessageFilter
	m_bBlockServerMessagesCompletely = iniEMF.GetBool(L"BlockServerMessages", false);
	m_strServerMessageFilter = iniEMF.GetStringLong(L"ServerMessageFilter", L"gratis|legal|www.|ftp.|http://|https://");
//<<< WiZaRd::ServerMessageFilter
//>>> shadow2004::Toolbar
	// switch for ToolbarLabels:    0: hide | 1: show | 2: show only active | 3: show on mouse over | 4: 2+3
	m_uiToolbarLabelStyle = (uint8)iniEMF.GetInt(L"ToolbarLabelStyle", 1); //don't confuse new users
//<<< shadow2004::Toolbar
//>>> shadow2004::IP2Country [EastShare]
	m_uiIP2CountryNameMode = (uint8)iniEMF.GetInt(L"IP2Country", 0);
	m_bIP2CountryShowFlag = iniEMF.GetBool(L"IP2CountryShowFlag", false);
	m_bIP2CountryAutoUpdate = iniEMF.GetBool(L"AutoUpdateIP2Country", false);
	m_uiIP2CountryVersion = (UINT)iniEMF.GetInt(L"IP2CountryVersion", 0);
	m_strIP2CountryUpdateURL = iniEMF.GetString(L"UpdateURLIP2Country", IP2COUNTRY_DEFAULT_URL);
	m_strIP2CountryUpdateVerURL = iniEMF.GetString(L"UpdateVerURLIP2Country", IP2COUNTRY_DEFAULT_VERURL);
//<<< shadow2004::IP2Country [EastShare]
//>>> shadow2004::ModIconDLL Update
	m_bModIconDllAutoUpdate = iniEMF.GetBool(L"AutoUpdateModIconDll", false);
	m_strModIconDllUpdateURL = iniEMF.GetString(L"UpdateURLModIconDll", MODICONDLL_DEFAULT_URL);
//<<< shadow2004::ModIconDLL Update
//>>> Spike2::ConChecker [eWombat]
	m_bCheckCon = iniEMF.GetBool(L"CheckConnection", true); 
	m_bICMP = iniEMF.GetBool(L"UseICMP", true); //false = RAW
	m_uiPingTimeOut = (uint8)iniEMF.GetInt(L"PingTimeOut", 1); 
	m_uiPingTimeOut = min(m_uiPingTimeOut, 20);
	m_uiPingTTL = (uint8)iniEMF.GetInt(L"PingTTL", 16); 
	m_uiPingTTL = min(max(8, m_uiPingTTL), 64);
//<<< Spike2::ConChecker [eWombat]
//>>> shadow2004::IPFilter-Update [Morph]
	m_uiIPfilterVersion = iniEMF.GetInt(L"IPFilterVersion",0); 
	m_bAutoUpdateIPFilter = iniEMF.GetBool(L"AutoUPdateIPFilter",true); 
	strUpdateURLIPFilter = iniEMF.GetString(L"UpdateURLIPFilter", MOD_ED2K_IPF_URL);
//<<< shadow2004::IPFilter-Update [Morph]
//>>> shadow2004::ed2k updates [WiZaRd]
	m_dwDLingIpFilterVersion = iniEMF.GetInt(L"DownloadingIpFilterVersion", 0);
	m_strDLingIpFilterLink = iniEMF.GetString(L"DownloadingIpFilterLink", L"");
	m_bAutoResumePausedIPFilter = iniEMF.GetBool(L"AutoStartED2KIPFilter", true);
	m_bIPFilterUploadPrioManuell = iniEMF.GetBool(L"IPFilterUploadManuell", false);
	m_uiIPFilterUploadPrio = (uint8)iniEMF.GetInt(L"IPFilterUpload", PR_VERYHIGH); //release by default
//<<< shadow2004::ed2k updates [WiZaRd]
//>>> JvA::SLS [enkeyDEV]
	m_bUseSaveLoadSources = iniEMF.GetBool(L"UseSaveLoadSources", true);
	m_iActivationLimitSLS = (uint8)iniEMF.GetInt(L"ActivationLimitSLS", 100);
	m_iSourcesToSaveSLS = (uint8)iniEMF.GetInt(L"SourcesToSaveSLS", 25);
//<<< JvA::SLS [enkeyDEV]
//>>> WiZaRd::minRQR [WiZaRd]
	m_bShowMinRQR = iniEMF.GetBool(L"MinRQR", true);
//<<< WiZaRd::minRQR [WiZaRd]
//>>> shadow2004::InfiniteQueue [SLUGFILLER]
	//WiZaRd: this will "convert" erroneous entries, due to be removed in v0.8
	const int iVal = iniEMF.GetInt(L"InfinitQueue", -1);
	if(iVal != -1)
	{
		iniEMF.DeleteKey(L"InfinitQueue");
		m_bInfiniteQueue = iVal!=0;
	}
	else
		m_bInfiniteQueue = iniEMF.GetBool(L"InfiniteQueue", false);
//<<< shadow2004::InfiniteQueue [SLUGFILLER]

///////////////////////////////////////////////////////////////////////////
// dlarge Silversurfer Tweaks:
//

//==> dlarge TrayPasswordProtection (Xanatos)
	m_bTrayPasswordProtection = iniEMF.GetBool(L"TrayPasswordProtection", false, L"EMF");
	m_sTrayPassword = iniEMF.GetString(L"TrayPassword", L"");
//<== dlarge TrayPasswordProtection (Xanatos)

//==> dlarge Drop
	m_iDropSourcesTimerNNS = iniEMF.GetInt(L"DropSourcesTimerNNS", 25, L"EMF");
	m_bDropSourcesNNS = iniEMF.GetBool(L"DropSourcesNNS", false, L"EMF");
	m_iDropSourcesTimerFQ = iniEMF.GetInt(L"DropSourcesTimerFQ",30, L"EMF");
	m_bDropSourcesFQ = iniEMF.GetBool(L"DropSourcesFQ", true, L"EMF");
	m_iDropSourcesTimerHQR = iniEMF.GetInt(L"DropSourcesTimerHQR",35, L"EMF");
	m_bDropSourcesHQR = iniEMF.GetBool(L"DropSourcesHQR", true, L"EMF");
        MaxRemoveQRS=(uint16)iniEMF.GetInt(L"MaxRemoveQueueRatingSources",3500, L"EMF");
//<== dlarge Drop

//==> dlarge Invisible Mode
	char c = (char)iniEMF.GetInt(L"InvisibleModeHKKey", (int)'E', L"EMF"); 
	SetInvisibleMode( iniEMF.GetBool(L"InvisibleMode", false, L"EMF"),           
        iniEMF.GetInt(L"InvisibleModeHKKeyModifier", MOD_CONTROL | MOD_SHIFT | MOD_ALT), c); 
        m_bStartInvisible = iniEMF.GetBool(L"StartInvisible", true, L"EMF"); //>>> StartUp InvisibleMode Enhancement 
//<== dlarge Invisible Mode

//==> dlarge Mass Rename
	SetSimpleCleanupOptions (iniEMF.GetInt (L"SimpleCleanupOptions",3, L"EMF"));
	SetSimpleCleanupSearch (iniEMF.GetString (L"SimpleCleanupSearch"));
	SetSimpleCleanupReplace (iniEMF.GetString (L"SimpleCleanupReplace"));
	// Format of the preferences string for character replacement:
	//      "str";"str";"str";...;"str"
	// Every "str" in SimpleCleanupSearchChars corresponds to a "str"
	// in SimpleCleanupReplaceChars at the same position.
	SetSimpleCleanupSearchChars (iniEMF.GetString (L"SimpleCleanupSearchChars",
								 L"\"\xE4\";\"\xF6\";\"\xFC\";\"\xC4\";\"\xD6\";\"\xDC\";\"\xDF\""));/*ISO 8859-4*/
	SetSimpleCleanupReplaceChars (iniEMF.GetString (L"SimpleCleanupReplaceChars",
								 L"\"ae\";\"oe\";\"ue\";\"Ae\";\"Oe\";\"Ue\";\"ss\""));
//<== dlarge Mass Rename

//==> dlarge QuickStart (Xanatos)
	m_bQuickStart = iniEMF.GetBool(L"UseQuickStart", false, L"EMF");
	m_iQuickStartTime = iniEMF.GetInt(L"QuickStartTime", 10, L"EMF");
	m_iQuickMaxConperFive = iniEMF.GetInt(L"QuickMaxConperFive", (int)(MaxConperFive*1.5), L"EMF");
	m_iQuickMaxHalfOpen = iniEMF.GetInt(L"QuickMaxHalfOpen", (int)(maxhalfconnections), L"EMF");
	m_iQuickMaxConnections = iniEMF.GetInt(L"QuickMaxConnections", (int)(maxconnections*1.5), L"EMF");
//<== dlarge QuickStart (Xanatos)

//==> dlarge Source Graph 
	m_bSrcGraph = iniEMF.GetBool(L"SrcGraph", false, L"EMF");
	m_iStatsHLMin = (uint16)iniEMF.GetInt(L"StatsHLMin", 2000, L"EMF");
	m_iStatsHLMax = (uint16)iniEMF.GetInt(L"StatsHLMax", 4000, L"EMF");
	m_iStatsHLDif = m_iStatsHLMax-m_iStatsHLMin;
//<== dlarge Source Graph

//==> dlarge MenuXP
	m_bShowXPSideBar = iniEMF.GetBool(L"SHOW_XP_SIDEBAR", true, L"EMF");
	m_bShowXPBitmap = iniEMF.GetBool(L"SHOW_XP_BITMAP", true, L"EMF");
	m_iXPMenuStyle = iniEMF.GetInt(L"XP_MENU_STYLE", 1, L"EMF");
	m_bGrayMenuIcon = iniEMF.GetBool(L"GRAY_MENU_ICON", false, L"EMF");
//<== dlarge MenuXP

//==> dlarge CPU/MEM 
	m_bSysInfo = iniEMF.GetBool(L"SysInfos",true, L"EMF");
	m_bSysInfoGlobal = iniEMF.GetBool(L"SysInfosGlobal",false, L"EMF");
//<== dlarge CPU/MEM 

//==> dlarge lowIdRetry
	LowIdRetries=(uint8)iniEMF.GetInt(L"ReconnectOnLowIdRetries",3, L"EMF");	
//<== dlarge lowIdRetry

//==> dlarge Backup
	autobackup = iniEMF.GetBool(L"AutoBackup",true, L"EMF");
	autobackup2 = iniEMF.GetBool(L"AutoBackup2",true, L"EMF");
//<== dlarge Backup

#define MINMAXE(val, mini, maxi)	(min(max(mini, val), maxi))

//==> dlarge MTU Configuration
	MTU=(uint16)iniEMF.GetInt(L"MTU",1340, L"EMF");
	usedoublesendsize=iniEMF.GetBool(L"usedoublesendsize",false, L"EMF"); 
//<== dlarge MTU Configuration

//==> dlarge Static server handling 
	SetDontRemoveStaticServers (iniEMF.GetBool (L"DontRemoveStaticServers",false, L"EMF"));
//<== dlarge Static server handling

//==> dlarge disable compression (Xman)
	m_bUseCompression=iniEMF.GetBool(L"UseCompression",true, L"EMF");
//<== dlarge disable compression (Xman)

//==> dlarge remove unused AICH-hashes (Xman)
	m_rememberAICH=iniEMF.GetBool(L"rememberAICH",false, L"EMF"); 
//<== dlarge remove unused AICH-hashes (Xman)

//==> dlarge high process priority
	m_iProcessPrio = (uint8)iniEMF.GetInt(L"ProcessPriority", 2, L"EMF");
	MINMAXE(m_iProcessPrio, 0, 4);
//<== dlarge high process priority

//==> dlarge NiceHash
	m_iNiceHashWeight = (uint8)min(iniEMF.GetInt(L"NiceHashWeight", 0, L"EMF"), 100);  
//<== dlarge NiceHash

//==> dlarge ReleaseBonus 
	m_uReleaseBonus = (uint8)iniEMF.GetInt(L"ReleaseBonus", VAL_RELBONUS_DEF, L"EMF");
	m_bReleaseBonus = iniEMF.GetBool(L"UseReleaseBonus", false, L"EMF");
//<== dlarge ReleaseBonus 

//==> dlarge queue progresssbar - Client Percentage - chunk dots
	m_bClientQueueProgressBar=iniEMF.GetBool(L"ClientQueueProgressBar",true, L"EMF"); 
	m_bShowClientPercentage=iniEMF.GetBool(L"ShowClientPercentage",true, L"EMF"); 
	m_bEnableChunkDots=iniEMF.GetBool(L"EnableChunkDots",false, L"EMF"); 
	m_bShowSessionDownload = iniEMF.GetBool(L"ShowSessionDownload", false, L"EMF");
	m_bStaticIcon=iniEMF.GetBool(L"StaticIcon",false, L"EMF"); //==> dlarge Static Tray Icon
	m_bTrayComplete = iniEMF.GetBool(L"TrayComplete",false, L"EMF"); //==> dlarge Completed in Tray
	m_bSideBanner=iniEMF.GetBool(L"Sidebanner",true, L"EMF"); //==> dlarge switch Banner
	m_bUseRelativeChunkDisplay = iniEMF.GetBool(L"UseRelativeChunkDisplay", false, L"EMF"); //==> dlarge relative chunk display
//<== dlarge queue progresssbar - Client Percentage - chunk dots

//==> dlarge Virus Scan (TK4)
	virusscannerenabled = iniEMF.GetBool(L"VirusScannerEnabled", false, L"EMF");
	virusscanner = iniEMF.GetString(L"VirusScanner", _T(""), L"EMF");
	virusscanprefilesw = iniEMF.GetString(L"PreFileSwitches", _T(""), L"EMF");
	virusscanswitches = iniEMF.GetString(L"PostFileSwithes", _T(""), L"EMF");
	virusscannertype = iniEMF.GetInt(L"ScannerListPos",0, L"EMF");
	virusscanradio = iniEMF.GetInt(L"ScannerRadioOp",1, L"EMF");
	//Stop some neferious types editing the config file to run batch files
	if(!virusscanner.IsEmpty())
	  {
	    int chrpos = virusscanner.ReverseFind(_T('.'));
	    CString Filetype=virusscanner.Mid(chrpos+1,3);
	    if(Filetype.CompareNoCase(_T("exe"))!=0 && Filetype.CompareNoCase(_T("com"))!=0 && Filetype.CompareNoCase(_T("bin"))!=0) virusscanner="";//reset
	   }
//<== dlarge Virus Scan (TK4)

//==> dlarge auto priority
	pp_bFirstStart = true;
	pp_bUseAutoPrio=iniEMF.GetBool(L"pp_bUseAutoPrio", false, L"EMF");
	pp_bAutoPrioKeepLow=iniEMF.GetBool(L"pp_bAutoPrioKeepLow", true, L"EMF");
	pp_uAutoPrioHigh=(uint8)iniEMF.GetInt(L"pp_uAutoPrioLimit", 90, L"EMF");
	pp_uAutoPrioNormal=(uint8)iniEMF.GetInt(L"pp_uAutoPrioLimit2", 75, L"EMF");
//<== dlarge auto priority

//==> dlarge SUC/USS
	isautodynupswitching= iniEMF.GetBool(L"AutoDynUpSwitching",false, L"EMF"); 
	maxconnectionsswitchborder = iniEMF.GetInt(L"MaxConnectionsSwitchBorder",100, L"EMF"); 
	maxconnectionsswitchborder = min(max(maxconnectionsswitchborder,50),60000); 
	m_bDynUpLog = iniEMF.GetBool(L"USSLog", true, L"EMF");
	m_bUSSUDP = iniEMF.GetBool(L"USSUDP_FORCE", false, L"EMF"); 
        m_sPingDataSize = (short)ini.GetInt(L"USSPingDataSize", 0, L"EMF"); 
	m_iUSSinitialTTL = (uint8)iniEMF.GetInt(L"USSInitialTTL", 1, L"EMF");

	m_bSUCEnabled = iniEMF.GetBool(L"SUCEnabled",false, L"EMF");
	m_bSUCLog =  iniEMF.GetBool(L"SUCLog",false, L"EMF");
	m_iSUCHigh = iniEMF.GetInt(L"SUCHigh",900, L"EMF");
	m_iSUCHigh = min(max(m_iSUCHigh,350),1000);
	m_iSUCLow = iniEMF.GetInt(L"SUCLow",600, L"EMF");
	m_iSUCLow = min(max(m_iSUCLow,350),m_iSUCHigh);
	m_iSUCPitch = iniEMF.GetInt(L"SUCPitch",3000, L"EMF");
	m_iSUCPitch = min(max(m_iSUCPitch,2500),10000);
	m_iSUCDrift = iniEMF.GetInt(L"SUCDrift",50, L"EMF");
	m_iSUCDrift = min(max(m_iSUCDrift,0),100);
//<== dlarge SUC/USS 

//==> dlarge Design Settings 
	LoadStylePrefs(ini);
//<== dlarge Design Settings 

	SetDirectoryWatcher(iniEMF.GetBool(L"AutoReloadSharedFiles", true, L"EMF")); //==> dlarge Automatic shared files updater

//==> dlarge .met file control
	m_iKnownMetDays = iniEMF.GetInt(L"KnownMetDays", 90, L"EMF");
	if (m_iKnownMetDays == 0) m_iKnownMetDays = 90;
//<== dlarge .met file control

//==> dlarge don't overwrite bak files if last sessions crashed (Xman)
	m_last_session_aborted_in_an_unnormal_way = iniEMF.GetBool(L"last_session_aborted_in_an_unnormal_way",false, L"EMF");
//<== dlarge don't overwrite bak files if last sessions crashed (Xman)

//==> dlarge minimule
	speedmetermin = iniEMF.GetInt(L"SpeedMeterMin",0, L"EMF");
	speedmetermax = iniEMF.GetInt(L"SpeedMeterMax",(int)GetMaxGraphDownloadRate(), L"EMF");	
	m_bMiniMule = iniEMF.GetBool(L"ShowMiniMule", false, L"EMF");
	m_iMiniMuleUpdate = iniEMF.GetInt(L"MiniMuleUpdate", 2, L"EMF");
	m_bMiniMuleLives = iniEMF.GetBool(L"MiniMuleLives", true, L"EMF");
	m_iMiniMuleTransparency = (uint8)iniEMF.GetInt(L"MiniMuleTransparency", 255, L"EMF");
	m_bShowSpeedMeter=iniEMF.GetBool(L"ShowSpeedMeter",false, L"EMF");
	m_bMMCompl = iniEMF.GetBool(L"MiniMuleCompl",false, L"EMF");
	m_bMMOpen = iniEMF.GetBool(L"MiniMuleOpen",true, L"EMF");
//<== dlarge minimule

//==> dlarge Smart Category Control 
	m_bShowCatNames=iniEMF.GetBool(L"ShowCatName",true, L"EMF");
	m_bValidSrcsOnly=iniEMF.GetBool(L"ValidSrcsOnly", false, L"EMF");
	m_bActiveCatDefault=iniEMF.GetBool(L"ActiveCatDefault", true, L"EMF");
	m_bSelCatOnAdd=iniEMF.GetBool(L"SelCatOnAdd", true, L"EMF");
	m_bAutoSetResumeOrder=iniEMF.GetBool(L"AutoSetResumeOrder", true, L"EMF");
	m_bSmallFileDLPush=iniEMF.GetBool(L"SmallFileDLPush", true, L"EMF");
	m_iStartDLInEmptyCats=(uint8)iniEMF.GetInt(L"StartDLInEmptyCats", 0, L"EMF");
	m_bUseAutoCat=iniEMF.GetBool(L"UseAutoCat", true, L"EMF");
	dlMode = (uint8)iniEMF.GetInt(L"dlMode",0, L"EMF");
//<== dlarge Smart Category Control 

	m_bSaveUploadQueueWaitTime = iniEMF.GetBool(L"SaveUploadQueueWaitTime", true, L"EMF"); //==> dlarge SUQWT

//==> dlarge SlotControl
	m_iUploadSlotCount = iniEMF.GetInt(L"UploadSlotCount", 4, L"EMF");
	m_bSlotFocus = iniEMF.GetBool(L"IsSlotFocus", false, L"EMF");
	maxclientdatarate = (uint16)iniEMF.GetInt (L"MaxClientDataRate",4, L"EMF");														
//<== dlarge SlotControl

//==> dlarge CreditSystem
	creditSystemMode = (uint8)iniEMF.GetInt(L"CreditSystemMode", CS_PAWCIO, L"EMF"); 
	if ((creditSystemMode < CS_OFFICIAL )  || (creditSystemMode > CS_ZZUL )) 
		creditSystemMode = CS_PAWCIO; 
//<== dlarge CreditSystem

//==> dlarge Argos System (Xanatos)
	m_bUseArgosSystem = iniEMF.GetBool(L"UseArgosSystem", true);
	m_iCreditCompensation = iniEMF.GetInt(L"CreditCompensation", 9);
	m_bTrustUnArgosHashThief = iniEMF.GetBool(L"TrustUnArgosHashThief", true);
	m_bTrustUnArgosHashChanged = iniEMF.GetBool(L"TrustUnArgosHashChanged", true);
	m_bTrustUnArgosGhostMode = iniEMF.GetBool(L"TrustUnArgosGhostMode", true);
	m_bTrustUnArgosAgressiv = iniEMF.GetBool(L"TrustUnArgosAgressiv", false);
	m_iArgosTrustTime = iniEMF.GetInt(L"ArgosTrustTime", TIM_ARGOS_TRUST_TIME_DEF);
	m_uCloseMaellaBackdoor = iniEMF.GetInt(L"CloseMaellaBackdoor", TRUE);
	m_uDontBanFriends = iniEMF.GetInt(L"DontBanFriends", TRUE);
	m_iArgosProcessTime = iniEMF.GetInt(L"ArgosProcessTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosTrackTime = iniEMF.GetInt(L"ArgosTrackTime", TIM_ARGOS_TRACK_TIME_DEF);
	m_iArgosGenericBanTime = iniEMF.GetInt(L"ArgosGenericBanTime", TIM_ARGOS_GENERIC_BAN_TIME_DEF);
	m_iArgosCorruptedSenderTime = iniEMF.GetInt(L"ArgosCorruptedSenderTime", TIM_ARGOS_BAN_TIME_CORRUPT_DEF);
	m_iArgosFileScannerTime = iniEMF.GetInt(L"ArgosFileScannerTime", TIM_ARGOS_BAN_TIME_SCANNER_DEF);
	m_iArgosFileFakerTime = iniEMF.GetInt(L"ArgosFileFakerTime", TIM_ARGOS_BAN_TIME_SCANNER_DEF);
	m_iArgosAgressionBanTime = iniEMF.GetInt(L"ArgosAgressionBanTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosOpCodeTime = iniEMF.GetInt(L"ArgosOpCodeTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosHashChangedTime = iniEMF.GetInt(L"ArgosHashChangedTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosRankFlooderTime = iniEMF.GetInt(L"ArgosRankFlooderTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosGhostModeTime = iniEMF.GetInt(L"ArgosGhostModeTime", TIM_ARGOS_BAN_TIME_DEF);	
	m_iArgosFailedTime = iniEMF.GetInt(L"ArgosFailedTime", TIM_ARGOS_BAN_TIME_FAILED_DEF);	
	m_iArgosXSExploitTime = iniEMF.GetInt(L"ArgosXSExploitTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosNickChangerTime = iniEMF.GetInt(L"ArgosNickChangerTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosModChangerTime = iniEMF.GetInt(L"ArgosModChangerTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosNullNickTime = iniEMF.GetInt(L"ArgosNullNickTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosSpamTime = iniEMF.GetInt(L"ArgosSpamTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosBadHelloTime = iniEMF.GetInt(L"ArgosBadHelloTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosBadProtTime = iniEMF.GetInt(L"ArgosBadProtTime", TIM_ARGOS_BAN_TIME_DEF);
	m_iArgosGPLBreakerPunishment = iniEMF.GetInt(L"ArgosGPLBreakerPunishment", 10);
	m_iArgosHardLeecherPunishment = iniEMF.GetInt(L"ArgosHardLeecherPunishment", 8);
	m_iArgosNormalLeecherPunishment = iniEMF.GetInt(L"ArgosNormalLeecherPunishment", 5);
	m_iArgosSoftLeecherPunishment = iniEMF.GetInt(L"ArgosSoftLeecherPunishment", 2);
	m_iArgosBadModPunishment = iniEMF.GetInt(L"ArgosBadModPunishment", 1);
	m_iArgosNickThiefPunishment = iniEMF.GetInt(L"ArgosNickThiefPunishment", 5);
	m_iArgosModThiefPunishment = iniEMF.GetInt(L"ArgosModThiefPunishment", 9);
	m_iArgosHashThiefPunishment = iniEMF.GetInt(L"ArgosHashThiefPunishment", 5);
	m_iArgosCreditHackPunishment = iniEMF.GetInt(L"ArgosCreditHackPunishment", 7);
	m_iArgosHashChangedPunishment = iniEMF.GetInt(L"ArgosHashChangedPunishment", 3);
	m_iArgosGhostModePunishment = iniEMF.GetInt(L"ArgosGhostModePunishment", 0);
	m_iArgosFakeClientPunishment = iniEMF.GetInt(L"ArgosFakeClientPunishment", 7);
	m_iArgosAgressonPunishment = iniEMF.GetInt(L"ArgosAgressonPunishment", 100);
	m_iArgosFileScannerPunishment = iniEMF.GetInt(L"ArgosFileScannerPunishment", 100);
	m_iArgosFileFakerPunishment = iniEMF.GetInt(L"ArgosFileFakerPunishment", 100);
	m_iArgosCorruptedSenderPunishment = iniEMF.GetInt(L"ArgosCorruptedSenderPunishment", 100);
	m_iArgosRankFlooderPunishment = iniEMF.GetInt(L"ArgosRankFlooderPunishment", 100);
	m_iArgosFailedPunishment = iniEMF.GetInt(L"ArgosFailedPunishment", 100);
	m_iArgosXSExploitPunishment = iniEMF.GetInt(L"ArgosXSExploitPunishment", 100);
	m_iArgosNickChangerPunishment = iniEMF.GetInt(L"ArgosNickChangerPunishment", 100);
	m_iArgosModChangerPunishment = iniEMF.GetInt(L"ArgosModChangerPunishment", 100);
	m_iArgosNullNickPunishment = iniEMF.GetInt(L"ArgosNullNickPunishment", 100);
	m_iArgosSpamPunishment = iniEMF.GetInt(L"ArgosSpamPunishment", 100);
	m_iArgosBadHelloPunishment = iniEMF.GetInt(L"ArgosBadHelloPunishment", 7);
	m_iArgosBadProtPunishment = iniEMF.GetInt(L"ArgosBadProtPunishment", 7);
	m_bArgosLeecherModDetection = iniEMF.GetBool(L"ArgosLeecherModDetection", true);
	m_uArgosLeecherNickDetection = iniEMF.GetInt(L"ArgosLeecherNickDetection", 2);
	m_iArgosDetectionLevel = iniEMF.GetInt(L"ArgosDetectionLevel", 2);
	m_bArgosOpcodeDetection = iniEMF.GetBool(L"ArgosOpcodeDetection", true);
	m_bArgosLeecherHashDetection = iniEMF.GetBool(L"ArgosLeecherHashDetection", true);
	m_bArgosNickThiefDetection = iniEMF.GetBool(L"ArgosNickThiefDetection", false);
	m_bPlainAntiNickThief = iniEMF.GetBool(L"PlainAntiNickThief", false);
	m_bArgosModThiefDetection = iniEMF.GetBool(L"ArgosModThiefDetection", true);
	m_bArgosHashThiefDetection = iniEMF.GetBool(L"ArgosHashThiefDetection", true);
	m_bArgosCreditHackDetection = iniEMF.GetBool(L"ArgosCreditHackDetection", true);
	m_bHashChangeDetection = iniEMF.GetBool(L"HashChangeDetection", true);
	m_bArgosGhostModDetection = iniEMF.GetBool(L"ArgosGhostModDetection", true);
	m_uArgosFakeClientDetection = iniEMF.GetInt(L"ArgosFakeClientDetection", TRUE);
	m_uAgressionDetection = iniEMF.GetInt(L"AgressionDetection", TRUE);
	m_iAgressionIntervals = iniEMF.GetInt(L"AgressionIntervals", TIM_ARGOS_AGRESSION_INTERVALS_DEF);
	m_iAgressionThreshold = iniEMF.GetInt(L"AgressionThreshold", VAL_ARGOS_AGRESSION_THRESHOLD_DEF);
	m_bFileScannerDetection = iniEMF.GetBool(L"FileScannerDetection", true);
	m_bFileFakerDetection = iniEMF.GetBool(L"FileFakerDetection", true);
	m_bBadSenderDetection = iniEMF.GetBool(L"BadSenderDetection", true);
	m_bRankFloodDetection = iniEMF.GetBool(L"RankFloodDetection", true);
	m_bFailedDetection = iniEMF.GetBool(L"FailedDetection", true);
	m_iFailedTries = iniEMF.GetInt(L"FailedTries", VAL_ARGOS_FAILED_TRIES_DEF);
	m_iFailedThreshold = iniEMF.GetInt(L"FailedThreshold", VAL_ARGOS_FAILED_THRESHOLD_DEF);
	m_bXSExploitDetection = iniEMF.GetBool(L"XSExploitDetection", true);
	m_iXSExploitIntervals = iniEMF.GetInt(L"XSExploitIntervals", TIM_ARGOS_XS_EXPLOIT_INTERVALS_DEF);
	m_iXSExploitThreshold = iniEMF.GetInt(L"XSExploitThreshold", VAL_ARGOS_XS_EXPLOIT_THRESHOLD_DEF);
	m_bNickChangerDetection = iniEMF.GetBool(L"NickChangerDetection", true);
	m_iNickChangeIntervals = iniEMF.GetInt(L"NickChangeIntervals", TIM_ARGOS_NICK_CHANGE_INTERVALS_DEF);
	m_iNickChangeThreshold = iniEMF.GetInt(L"NickChangeThreshold", VAL_ARGOS_NICK_CHANGE_THRESHOLD_DEF);
	m_bModChangerDetection = iniEMF.GetBool(L"ModChangerDetection", true);
	m_iModChangeIntervals = iniEMF.GetInt(L"ModChangeIntervals", TIM_ARGOS_MOD_CHANGE_INTERVALS_DEF);
	m_iModChangeThreshold = iniEMF.GetInt(L"ModChangeThreshold", VAL_ARGOS_MOD_CHANGE_THRESHOLD_DEF);
	m_bNullNickDetection = iniEMF.GetBool(L"NullNickDetection", true);
	m_bSpamDetection = iniEMF.GetBool(L"SpamDetection", true);
	m_bBadHelloDetection = iniEMF.GetBool(L"BadHelloDetection", true);
	m_ueMCryptDetection = iniEMF.GetInt(L"eMCryptDetection", TRUE);
	m_bBadProtDetection = iniEMF.GetBool(L"BadProtDetection", true);
	m_uDLPDetection = iniEMF.GetInt(L"DLPDetection", TRUE);
	m_bArgosLogLeechers = iniEMF.GetBool(L"ArgosLogLeechers", false);
//<== dlarge Argos System (Xanatos)

	CheckSilverPreferences(); //==> dlarge SafePrefsettings

	LoadCats();
	SetLanguage();
}


WORD CPreferences::GetWindowsVersion(){
	static bool bWinVerAlreadyDetected = false;
	if(!bWinVerAlreadyDetected)
	{	
		bWinVerAlreadyDetected = true;
		m_wWinVer = DetectWinVersion();	
	}	
	return m_wWinVer;
}

UINT CPreferences::GetDefaultMaxConperFive(){
	switch (GetWindowsVersion()){
		case _WINVER_98_:
			return 5;
		case _WINVER_95_:	
		case _WINVER_ME_:
			return MAXCON5WIN9X;
		case _WINVER_2K_:
		case _WINVER_XP_:
			return MAXCONPER5SEC;
		default:
			return MAXCONPER5SEC;
	}
}

//////////////////////////////////////////////////////////
// category implementations
//////////////////////////////////////////////////////////

void CPreferences::SaveCats()
{
	CString strCatIniFilePath;
	strCatIniFilePath.Format(L"%sCategory.ini", GetMuleDirectory(EMULE_CONFIGDIR));
	(void)_tremove(strCatIniFilePath);
	CIni ini(strCatIniFilePath);
	ini.WriteInt(L"Count", catMap.GetCount() - 1, L"General");
//==> dlarge Smart Category Control 
	/*
	ini.WriteInt(_T("CategoryVersion"), 2, _T("General"));
	for (int i = 0; i < catMap.GetCount(); i++)
	{
		CString strSection;
		strSection.Format(L"Cat#%i", i);
		ini.SetSection(strSection);

		ini.WriteStringUTF8(L"Title", catMap.GetAt(i)->strTitle);
		ini.WriteStringUTF8(L"Incoming", catMap.GetAt(i)->strIncomingPath);
		ini.WriteStringUTF8(L"Comment", catMap.GetAt(i)->strComment);
		ini.WriteStringUTF8(L"RegularExpression", catMap.GetAt(i)->regexp);
		ini.WriteInt(L"Color", catMap.GetAt(i)->color);
		ini.WriteInt(L"a4afPriority", catMap.GetAt(i)->prio); // ZZ:DownloadManager
		ini.WriteStringUTF8(L"AutoCat", catMap.GetAt(i)->autocat);
		ini.WriteInt(L"Filter", catMap.GetAt(i)->filter);
		ini.WriteBool(L"FilterNegator", catMap.GetAt(i)->filterNeg);
		ini.WriteBool(L"AutoCatAsRegularExpression", catMap.GetAt(i)->ac_regexpeval);
        ini.WriteBool(L"downloadInAlphabeticalOrder", catMap.GetAt(i)->downloadInAlphabeticalOrder!=FALSE);
		ini.WriteBool(L"Care4All", catMap.GetAt(i)->care4all);
	*/
	ini.WriteInt(_T("CategoryVersion"), 2, _T("General"));
	for (int i = 0; i < catMap.GetCount(); i++)
	{
		CString strSection;
		strSection.Format(L"Cat#%i", i);
		ini.SetSection(strSection);
		ini.WriteStringUTF8(L"Title",catMap.GetAt(i)->strTitle);
		ini.WriteStringUTF8(L"Incoming",catMap.GetAt(i)->strIncomingPath);
		ini.WriteStringUTF8(L"Comment",catMap.GetAt(i)->strComment);
		ini.WriteInt(L"Color", catMap.GetAt(i)->color);
		ini.WriteInt(_T("a4afPriority"),catMap.GetAt(i)->prio);
		ini.WriteInt(_T("ResumeMode"), catMap.GetAt(i)->m_iDlMode);
//      ini.WriteBool(_T("downloadInAlphabeticalOrder"), catMap.GetAt(i)->downloadInAlphabeticalOrder!=FALSE, ixStr);

		// Save View Filters
		ini.WriteInt(_T("vfFromCats"), catMap.GetAt(i)->viewfilters.nFromCats);
		ini.WriteBool(_T("vfVideo"), catMap.GetAt(i)->viewfilters.bVideo!=FALSE);
		ini.WriteBool(_T("vfAudio"), catMap.GetAt(i)->viewfilters.bAudio!=FALSE);
		ini.WriteBool(_T("vfArchives"), catMap.GetAt(i)->viewfilters.bArchives!=FALSE);
		ini.WriteBool(_T("vfImages"), catMap.GetAt(i)->viewfilters.bImages!=FALSE);
		ini.WriteBool(_T("vfWaiting"), catMap.GetAt(i)->viewfilters.bWaiting!=FALSE);
		ini.WriteBool(_T("vfTransferring"), catMap.GetAt(i)->viewfilters.bTransferring!=FALSE);
		ini.WriteBool(_T("vfPaused"), catMap.GetAt(i)->viewfilters.bPaused!=FALSE);
		ini.WriteBool(_T("vfStopped"), catMap.GetAt(i)->viewfilters.bStopped!=FALSE);
		ini.WriteBool(_T("vfComplete"), catMap.GetAt(i)->viewfilters.bComplete!=FALSE);
		ini.WriteBool(_T("vfHashing"), catMap.GetAt(i)->viewfilters.bHashing!=FALSE);
		ini.WriteBool(_T("vfErrorUnknown"), catMap.GetAt(i)->viewfilters.bErrorUnknown!=FALSE);
		ini.WriteBool(_T("vfCompleting"), catMap.GetAt(i)->viewfilters.bCompleting!=FALSE);
		ini.WriteBool(_T("vfSeenComplet"), catMap.GetAt(i)->viewfilters.bSeenComplet!=FALSE); //MORPH - Added by SiRoB, Seen Complet filter
		ini.WriteUInt64(_T("vfFSizeMin"), catMap.GetAt(i)->viewfilters.nFSizeMin);
		ini.WriteUInt64(_T("vfFSizeMax"), catMap.GetAt(i)->viewfilters.nFSizeMax);
		ini.WriteUInt64(_T("vfRSizeMin"), catMap.GetAt(i)->viewfilters.nRSizeMin);
		ini.WriteUInt64(_T("vfRSizeMax"), catMap.GetAt(i)->viewfilters.nRSizeMax);
		ini.WriteInt(_T("vfTimeRemainingMin"), catMap.GetAt(i)->viewfilters.nTimeRemainingMin);
		ini.WriteInt(_T("vfTimeRemainingMax"), catMap.GetAt(i)->viewfilters.nTimeRemainingMax);
		ini.WriteInt(_T("vfSourceCountMin"), catMap.GetAt(i)->viewfilters.nSourceCountMin);
		ini.WriteInt(_T("vfSourceCountMax"), catMap.GetAt(i)->viewfilters.nSourceCountMax);
		ini.WriteInt(_T("vfAvailSourceCountMin"), catMap.GetAt(i)->viewfilters.nAvailSourceCountMin);
		ini.WriteInt(_T("vfAvailSourceCountMax"), catMap.GetAt(i)->viewfilters.nAvailSourceCountMax);
		ini.WriteString(_T("vfAdvancedFilterMask"), catMap.GetAt(i)->viewfilters.sAdvancedFilterMask);
		// Save Selection Criteria
		ini.WriteBool(_T("scFileSize"), catMap.GetAt(i)->selectioncriteria.bFileSize!=FALSE);
		ini.WriteBool(_T("scAdvancedFilterMask"), catMap.GetAt(i)->selectioncriteria.bAdvancedFilterMask!=FALSE);
		ini.WriteBool(_T("ResumeFileOnlyInSameCat"), catMap.GetAt(i)->bResumeFileOnlyInSameCat!=FALSE); //MORPH - Added by SiRoB, Resume file only in the same category
	}
//<== dlarge Smart Category Control 
}

//==> dlarge Smart Category Control 
void CPreferences::LoadCats() 
{
	CString strCatIniFilePath;
	strCatIniFilePath.Format(L"%sCategory.ini", GetMuleDirectory(EMULE_CONFIGDIR));
	CIni ini(strCatIniFilePath);
	
	bool bCreateDefault = false;
	bool bSkipLoad = false;
	if (!PathFileExists(strCatIniFilePath))
	{
		bCreateDefault = true;
		bSkipLoad = true;
	}
	else
	{
		//ini.SetFileName(strCatIniFilePath);
		if (ini.GetInt(_T("CategoryVersion"), 0, L"General") == 0)
			bCreateDefault = true;
	}

	if (bCreateDefault)
	{
		Category_Struct* defcat=new Category_Struct;

		defcat->strTitle = _T("Default");
    	defcat->prio=PR_NORMAL; // ZZ:DownloadManager
		defcat->m_iDlMode = 0;
		defcat->strIncomingPath = GetMuleDirectory(EMULE_INCOMINGDIR);
		defcat->strComment = _T("The default category.  It can't be merged or deleted.");
		defcat->color = 0;
		defcat->viewfilters.bArchives = true;
		defcat->viewfilters.bAudio = true;
		defcat->viewfilters.bComplete = true;
		defcat->viewfilters.bCompleting = true;
		defcat->viewfilters.bSeenComplet = true; //MORPH - Added by SiRoB, Seen Complet filter
		defcat->viewfilters.bErrorUnknown = true;
		defcat->viewfilters.bHashing = true;
		defcat->viewfilters.bImages = true;
		defcat->viewfilters.bPaused = true;
		defcat->viewfilters.bStopped = true;
		defcat->viewfilters.bSuspendFilters = false;
		defcat->viewfilters.bTransferring = true;
		defcat->viewfilters.bVideo = true;
		defcat->viewfilters.bWaiting = true;
		defcat->viewfilters.nAvailSourceCountMax = 0;
		defcat->viewfilters.nAvailSourceCountMin = 0;
		defcat->viewfilters.nFromCats = 2;
		defcat->viewfilters.nFSizeMax = 0;
		defcat->viewfilters.nFSizeMin = 0;
		defcat->viewfilters.nRSizeMax = 0;
		defcat->viewfilters.nRSizeMin = 0;
		defcat->viewfilters.nSourceCountMax = 0;
		defcat->viewfilters.nSourceCountMin = 0;
		defcat->viewfilters.nTimeRemainingMax = 0;
		defcat->viewfilters.nTimeRemainingMin = 0;
		defcat->viewfilters.sAdvancedFilterMask = "";
		defcat->selectioncriteria.bAdvancedFilterMask = true;
		defcat->selectioncriteria.bFileSize = true;
		defcat->bResumeFileOnlyInSameCat = false; //MORPH - Added by SiRoB, Resume file only in the same category
		AddCat(defcat);
		if (bSkipLoad)
		{
			SaveCats();
			return;
		}
	}

	int iNumCategories = ini.GetInt(L"Count", 0, L"General");
	for (int i = bCreateDefault ? 1 : 0; i <= iNumCategories; i++)
	{
		CString strSection;
		strSection.Format(L"Cat#%i", i);
		ini.SetSection(strSection);

		Category_Struct* newcat = new Category_Struct;
		newcat->strTitle = ini.GetStringUTF8(L"Title");
		newcat->strIncomingPath = ini.GetStringUTF8(L"Incoming");
		MakeFoldername(newcat->strIncomingPath);
		// SLUGFILLER: SafeHash remove - removed installation dir unsharing
		newcat->strComment = ini.GetStringUTF8(L"Comment");
		newcat->prio =ini.GetInt(_T("a4afPriority"),PR_NORMAL); // ZZ:DownloadManager
		newcat->color = ini.GetInt(L"Color", (DWORD)-1 );
		/*
		newcat->autocat=catini.GetString(_T("Autocat"),_T(""),ixStr);
		*/
//      newcat->downloadInAlphabeticalOrder = ini.GetBool(_T("downloadInAlphabeticalOrder"), FALSE, ixStr); // ZZ:DownloadManager

		newcat->m_iDlMode = ini.GetInt(_T("ResumeMode"), 0);
		//newcat->autocat = ini.GetString(_T("AutoCatString"),_T(""),ixStr);
		// Load View Filters
		newcat->viewfilters.nFromCats = ini.GetInt(_T("vfFromCats"), i==0?0:2);
		newcat->viewfilters.bSuspendFilters = false;
		newcat->viewfilters.bVideo = ini.GetBool(_T("vfVideo"), true);
		newcat->viewfilters.bAudio = ini.GetBool(_T("vfAudio"), true);
		newcat->viewfilters.bArchives = ini.GetBool(_T("vfArchives"), true);
		newcat->viewfilters.bImages = ini.GetBool(_T("vfImages"), true);
		newcat->viewfilters.bWaiting = ini.GetBool(_T("vfWaiting"), true);
		newcat->viewfilters.bTransferring = ini.GetBool(_T("vfTransferring"), true);
		newcat->viewfilters.bPaused = ini.GetBool(_T("vfPaused"), true);
		newcat->viewfilters.bStopped = ini.GetBool(_T("vfStopped"), true);
		newcat->viewfilters.bComplete = ini.GetBool(_T("vfComplete"), true);
		newcat->viewfilters.bHashing = ini.GetBool(_T("vfHashing"), true);
		newcat->viewfilters.bErrorUnknown = ini.GetBool(_T("vfErrorUnknown"), true);
		newcat->viewfilters.bCompleting = ini.GetBool(_T("vfCompleting"), true);
		newcat->viewfilters.bSeenComplet = ini.GetBool(_T("vfSeenComplet"), true); //MORPH - Added by SiRoB, Seen Complet filter
		newcat->viewfilters.nFSizeMin = ini.GetInt(_T("vfFSizeMin"), 0);
		newcat->viewfilters.nFSizeMax = ini.GetInt(_T("vfFSizeMax"), 0);
		newcat->viewfilters.nRSizeMin = ini.GetInt(_T("vfRSizeMin"), 0);
		newcat->viewfilters.nRSizeMax = ini.GetInt(_T("vfRSizeMax"), 0);
		newcat->viewfilters.nTimeRemainingMin = ini.GetInt(_T("vfTimeRemainingMin"), 0);
		newcat->viewfilters.nTimeRemainingMax = ini.GetInt(_T("vfTimeRemainingMax"), 0);
		newcat->viewfilters.nSourceCountMin = ini.GetInt(_T("vfSourceCountMin"), 0);
		newcat->viewfilters.nSourceCountMax = ini.GetInt(_T("vfSourceCountMax"), 0);
		newcat->viewfilters.nAvailSourceCountMin = ini.GetInt(_T("vfAvailSourceCountMin"), 0);
		newcat->viewfilters.nAvailSourceCountMax = ini.GetInt(_T("vfAvailSourceCountMax"), 0);
		newcat->viewfilters.sAdvancedFilterMask = ini.GetString(_T("vfAdvancedFilterMask"), _T(""));
		// Load Selection Criteria
		newcat->selectioncriteria.bFileSize = ini.GetBool(_T("scFileSize"), true);
		newcat->selectioncriteria.bAdvancedFilterMask = ini.GetBool(_T("scAdvancedFilterMask"), true);
		newcat->bResumeFileOnlyInSameCat = ini.GetBool(_T("ResumeFileOnlyInSameCat"), false); //MORPH - Added by SiRoB, Resume file only in the same category

		AddCat(newcat);
		if (!PathFileExists(newcat->strIncomingPath))
			::CreateDirectory(newcat->strIncomingPath, 0);
	}
}
//<== dlarge Smart Category Control 

void CPreferences::RemoveCat(int index)
{
	if (index >= 0 && index < catMap.GetCount())
	{
		Category_Struct* delcat = catMap.GetAt(index); 
		catMap.RemoveAt(index); 
		delete delcat;
	}
}

//==> dlarge Smart Category Control 
/*
bool CPreferences::SetCatFilter(int index, int filter)
{
	if (index >= 0 && index < catMap.GetCount())
	{
		catMap.GetAt(index)->filter = filter;
		return true;
	} 
	return false;
}

int CPreferences::GetCatFilter(int index)
{
	if (index >= 0 && index < catMap.GetCount())
		return catMap.GetAt(index)->filter;
    return 0;
}

bool CPreferences::GetCatFilterNeg(int index)
{
	if (index >= 0 && index < catMap.GetCount())
		return catMap.GetAt(index)->filterNeg;
    return false;
}

void CPreferences::SetCatFilterNeg(int index, bool val)
{
	if (index >= 0 && index < catMap.GetCount())
		catMap.GetAt(index)->filterNeg = val;
}
*/
//<== dlarge Smart Category Control 

bool CPreferences::MoveCat(UINT from, UINT to)
{
	if (from >= (UINT)catMap.GetCount() || to >= (UINT)catMap.GetCount() + 1 || from == to)
		return false;

	Category_Struct* tomove = catMap.GetAt(from);
	if (from < to) {
		catMap.RemoveAt(from);
		catMap.InsertAt(to - 1, tomove);
	} else {
		catMap.InsertAt(to, tomove);
		catMap.RemoveAt(from + 1);
	}
	SaveCats();
	return true;
}


DWORD CPreferences::GetCatColor(int index) {
	if (index>=0 && index<catMap.GetCount()) {
		DWORD c=catMap.GetAt(index)->color;
		if (c!=(DWORD)-1)
			return catMap.GetAt(index)->color; 
	}

	return GetSysColor(COLOR_WINDOWTEXT);
}


///////////////////////////////////////////////////////

bool CPreferences::IsInstallationDirectory(const CString& rstrDir)
{
	CString strFullPath;
	if (PathCanonicalize(strFullPath.GetBuffer(MAX_PATH), rstrDir))
		strFullPath.ReleaseBuffer();
	else
		strFullPath = rstrDir;
	
	// skip sharing of several special eMule folders
	if (!CompareDirectories(strFullPath, GetMuleDirectory(EMULE_EXECUTEABLEDIR)))
		return true;
	if (!CompareDirectories(strFullPath, GetMuleDirectory(EMULE_CONFIGDIR)))
		return true;
	if (!CompareDirectories(strFullPath, GetMuleDirectory(EMULE_WEBSERVERDIR)))
		return true;
	if (!CompareDirectories(strFullPath, GetMuleDirectory(EMULE_INSTLANGDIR)))
		return true;

	return false;
}

bool CPreferences::IsShareableDirectory(const CString& rstrDir)
{
	if (IsInstallationDirectory(rstrDir))
		return false;

	CString strFullPath;
	if (PathCanonicalize(strFullPath.GetBuffer(MAX_PATH), rstrDir))
		strFullPath.ReleaseBuffer();
	else
		strFullPath = rstrDir;
	
	// skip sharing of several special eMule folders
	for (int i=0;i<GetTempDirCount();i++)
		if (!CompareDirectories(strFullPath, GetTempDir(i)))			// ".\eMule\temp"
			return false;

	return true;
}

void CPreferences::UpdateLastVC()
{
	struct tm tmTemp;
	versioncheckLastAutomatic = safe_mktime(CTime::GetCurrentTime().GetLocalTm(&tmTemp));
}

void CPreferences::SetWSPass(CString strNewPass)
{
	m_strWebPassword = MD5Sum(strNewPass).GetHash();
}

void CPreferences::SetWSLowPass(CString strNewPass)
{
	m_strWebLowPassword = MD5Sum(strNewPass).GetHash();
}

void CPreferences::SetMMPass(CString strNewPass)
{
	m_strMMPassword = MD5Sum(strNewPass).GetHash();
}

void CPreferences::SetMaxUpload(UINT in)
{
	uint16 oldMaxUpload = (uint16)in;
	maxupload = (oldMaxUpload) ? oldMaxUpload : (uint16)UNLIMITED;
}

void CPreferences::SetMaxDownload(UINT in)
{
	uint16 oldMaxDownload = (uint16)in;
	maxdownload = (oldMaxDownload) ? oldMaxDownload : (uint16)UNLIMITED;
}

void CPreferences::SetNetworkKademlia(bool val)
{
	networkkademlia = val; 
}

CString CPreferences::GetHomepageBaseURLForLevel(int nLevel){
	CString tmp;
	if (nLevel == 0)
		tmp = L"http://emule-project.net";
	else if (nLevel == 1)
		tmp = L"http://www.emule-project.org";
	else if (nLevel == 2)
		tmp = L"http://www.emule-project.com";
	else if (nLevel < 100)
		tmp.Format(L"http://www%i.emule-project.net",nLevel-2);
	else if (nLevel < 150)
		tmp.Format(L"http://www%i.emule-project.org",nLevel);
	else if (nLevel < 200)
		tmp.Format(L"http://www%i.emule-project.com",nLevel);
	else if (nLevel == 200)
		tmp = L"http://emule.sf.net";
	else if (nLevel == 201)
		tmp = L"http://www.emuleproject.net";
	else if (nLevel == 202)
		tmp = L"http://sourceforge.net/projects/emule/";
	else
		tmp = L"http://www.emule-project.net";
	return tmp;
}

CString CPreferences::GetVersionCheckBaseURL(){
	CString tmp;
	UINT nWebMirrorAlertLevel = GetWebMirrorAlertLevel();
	if (nWebMirrorAlertLevel < 100)
		tmp = L"http://vcheck.emule-project.net";
	else if (nWebMirrorAlertLevel < 150)
		tmp.Format(L"http://vcheck%i.emule-project.org",nWebMirrorAlertLevel);
	else if (nWebMirrorAlertLevel < 200)
		tmp.Format(L"http://vcheck%i.emule-project.com",nWebMirrorAlertLevel);
	else if (nWebMirrorAlertLevel == 200)
		tmp = L"http://emule.sf.net";
	else if (nWebMirrorAlertLevel == 201)
		tmp = L"http://www.emuleproject.net";
	else
		tmp = L"http://vcheck.emule-project.net";
	return tmp;
}

bool CPreferences::IsDefaultNick(const CString strCheck){
	// not fast, but this function is called often
	for (int i = 0; i != 255; i++){
		if (GetHomepageBaseURLForLevel(i) == strCheck)
			return true;
	}
	return ( strCheck == L"http://emule-project.net" );
}

void CPreferences::SetUserNick(LPCTSTR pszNick)
{
	strNick = pszNick;
}

UINT CPreferences::GetWebMirrorAlertLevel(){
	// Known upcoming DDoS Attacks
	if (m_nWebMirrorAlertLevel == 0){
		// no threats known at this time
	}
	// end
	if (UpdateNotify())
		return m_nWebMirrorAlertLevel;
	else
		return 0;
}

bool CPreferences::IsRunAsUserEnabled(){
	return (GetWindowsVersion() == _WINVER_XP_ || GetWindowsVersion() == _WINVER_2K_ || GetWindowsVersion() == _WINVER_2003_) 
		&& m_bRunAsUser
		&& m_nCurrentUserDirMode == 2;
}

int	CPreferences::GetMaxGraphUploadRate(bool bEstimateIfUnlimited){
	if (maxGraphUploadRate != UNLIMITED || !bEstimateIfUnlimited){
		return maxGraphUploadRate;
	}
	else{
		if (maxGraphUploadRateEstimated != 0){
			return maxGraphUploadRateEstimated +4;
		}
		else
			return 16;
	}
}

void CPreferences::EstimateMaxUploadCap(uint32 nCurrentUpload){
	if (maxGraphUploadRateEstimated+1 < nCurrentUpload){
		maxGraphUploadRateEstimated = nCurrentUpload;
		if (maxGraphUploadRate == UNLIMITED && theApp.emuledlg && theApp.emuledlg->statisticswnd)
			theApp.emuledlg->statisticswnd->SetARange(false, thePrefs.GetMaxGraphUploadRate(true));
	}
}

void CPreferences::SetMaxGraphUploadRate(int in){
	maxGraphUploadRate	=(in) ? in : UNLIMITED;
}

bool CPreferences::IsDynUpEnabled()	{
	return m_bDynUpEnabled || maxGraphUploadRate == UNLIMITED;
}

bool CPreferences::CanFSHandleLargeFiles()	{
	bool bResult = false;
	for (int i = 0; i != tempdir.GetCount(); i++){
		if (!IsFileOnFATVolume(tempdir.GetAt(i))){
			bResult = true;
			break;
		}
	}
	return bResult && !IsFileOnFATVolume(GetMuleDirectory(EMULE_INCOMINGDIR));
}

//==> dlarge high process priority
void CPreferences::SetProcessPrio(int iProcessPrio) 	
{
	MINMAX(iProcessPrio, 0, 4);
	if(m_iProcessPrio != iProcessPrio)
	{
		m_iProcessPrio = (uint8)iProcessPrio;
		_SetPriorityClass();
	}
}

void CPreferences::_SetPriorityClass()
{
	switch(m_iProcessPrio)
	{
		case 0:
			SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
			theApp.QueueLogLine(false, GetResString(IDS_PRIO_PART1) + GetResString(IDS_LOW_PROCESS) + GetResString(IDS_PRIO_PART2));
			break;
		case 1:
		{
			WORD wWinVer = thePrefs.GetWindowsVersion();
			if(wWinVer == _WINVER_95_ || wWinVer == _WINVER_98_ || wWinVer == _WINVER_ME_ || wWinVer == _WINVER_NT4_) // not supported
				break;
			SetPriorityClass(GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS);
			theApp.QueueLogLine(false, GetResString(IDS_PRIO_PART1) + GetResString(IDS_LOWER_PROCESS) + GetResString(IDS_PRIO_PART2));
			break;
		}
		case 2:
			SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
			theApp.QueueLogLine(false, GetResString(IDS_PRIO_PART1) + GetResString(IDS_NORMAL_PROCESS) + GetResString(IDS_PRIO_PART2));
			break;
		case 3:
		{
			WORD wWinVer = thePrefs.GetWindowsVersion();
			if(wWinVer == _WINVER_95_ || wWinVer == _WINVER_98_ || wWinVer == _WINVER_ME_ || wWinVer == _WINVER_NT4_) // not supported
				break;
			SetPriorityClass(GetCurrentProcess(), ABOVE_NORMAL_PRIORITY_CLASS);
			theApp.QueueLogLine(false, GetResString(IDS_PRIO_PART1) + GetResString(IDS_HIGH_PROCESS) + GetResString(IDS_PRIO_PART2));
			break;
		}
		case 4:
			SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
			theApp.QueueLogLine(false, GetResString(IDS_PRIO_PART1) + GetResString(IDS_HIGHER_PROCESS) + GetResString(IDS_PRIO_PART2));
			break;
	}
}
//<== dlarge high process priority

uint16 CPreferences::GetRandomTCPPort()
{
	// Get table of currently used TCP ports.
	PMIB_TCPTABLE pTCPTab = NULL;
	// Couple of crash dmp files are showing that we may crash somewhere in 'iphlpapi.dll' when doing the 2nd call
	__try {
		HMODULE hIpHlpDll = LoadLibrary(_T("iphlpapi.dll"));
		if (hIpHlpDll)
		{
			DWORD (WINAPI *pfnGetTcpTable)(PMIB_TCPTABLE, PDWORD, BOOL);
			(FARPROC&)pfnGetTcpTable = GetProcAddress(hIpHlpDll, "GetTcpTable");
			if (pfnGetTcpTable)
			{
				DWORD dwSize = 0;
				if ((*pfnGetTcpTable)(NULL, &dwSize, FALSE) == ERROR_INSUFFICIENT_BUFFER)
				{
					// The nr. of TCP entries could change (increase) between
					// the two function calls, allocate some more memory.
					dwSize += sizeof(pTCPTab->table[0]) * 50;
					pTCPTab = (PMIB_TCPTABLE)malloc(dwSize);
					if (pTCPTab)
					{
						if ((*pfnGetTcpTable)(pTCPTab, &dwSize, TRUE) != ERROR_SUCCESS)
						{
							free(pTCPTab);
							pTCPTab = NULL;
						}
					}
				}
			}
			FreeLibrary(hIpHlpDll);
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER) {
		free(pTCPTab);
		pTCPTab = NULL;
	}

	const UINT uValidPortRange = 61000;
	int iMaxTests = uValidPortRange; // just in case, avoid endless loop
	uint16 nPort;
	bool bPortIsFree;
	do {
		// Get random port
		nPort = 4096 + (GetRandomUInt16() % uValidPortRange);

		// The port is by default assumed to be available. If we got a table of currently
		// used TCP ports, we verify that this port is currently not used in any way.
		bPortIsFree = true;
		if (pTCPTab)
		{
			uint16 nPortBE = htons(nPort);
			for (UINT e = 0; e < pTCPTab->dwNumEntries; e++)
			{
				// If there is a TCP entry in the table (regardless of its state), the port
				// is treated as not available.
				if (pTCPTab->table[e].dwLocalPort == nPortBE)
				{
					bPortIsFree = false;
					break;
				}
			}
		}
	}
	while (!bPortIsFree && --iMaxTests > 0);
	free(pTCPTab);
	return nPort;
}

uint16 CPreferences::GetRandomUDPPort()
{
	// Get table of currently used UDP ports.
	PMIB_UDPTABLE pUDPTab = NULL;
	// Couple of crash dmp files are showing that we may crash somewhere in 'iphlpapi.dll' when doing the 2nd call
	__try {
		HMODULE hIpHlpDll = LoadLibrary(_T("iphlpapi.dll"));
		if (hIpHlpDll)
		{
			DWORD (WINAPI *pfnGetUdpTable)(PMIB_UDPTABLE, PDWORD, BOOL);
			(FARPROC&)pfnGetUdpTable = GetProcAddress(hIpHlpDll, "GetUdpTable");
			if (pfnGetUdpTable)
			{
				DWORD dwSize = 0;
				if ((*pfnGetUdpTable)(NULL, &dwSize, FALSE) == ERROR_INSUFFICIENT_BUFFER)
				{
					// The nr. of UDP entries could change (increase) between
					// the two function calls, allocate some more memory.
					dwSize += sizeof(pUDPTab->table[0]) * 50;
					pUDPTab = (PMIB_UDPTABLE)malloc(dwSize);
					if (pUDPTab)
					{
						if ((*pfnGetUdpTable)(pUDPTab, &dwSize, TRUE) != ERROR_SUCCESS)
						{
							free(pUDPTab);
							pUDPTab = NULL;
						}
					}
				}
			}
			FreeLibrary(hIpHlpDll);
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER) {
		free(pUDPTab);
		pUDPTab = NULL;
	}

	const UINT uValidPortRange = 61000;
	int iMaxTests = uValidPortRange; // just in case, avoid endless loop
	uint16 nPort;
	bool bPortIsFree;
	do {
		// Get random port
		nPort = 4096 + (GetRandomUInt16() % uValidPortRange);

		// The port is by default assumed to be available. If we got a table of currently
		// used UDP ports, we verify that this port is currently not used in any way.
		bPortIsFree = true;
		if (pUDPTab)
		{
			uint16 nPortBE = htons(nPort);
			for (UINT e = 0; e < pUDPTab->dwNumEntries; e++)
			{
				if (pUDPTab->table[e].dwLocalPort == nPortBE)
				{
					bPortIsFree = false;
					break;
				}
			}
		}
	}
	while (!bPortIsFree && --iMaxTests > 0);
	free(pUDPTab);
	return nPort;
}

//==> dlarge InvisibleMode
void CPreferences::SetInvisibleMode(bool on, UINT keymodifier, char key) 
{ 
    m_bInvisibleMode = on; 
    m_iInvisibleModeHotKeyModifier = keymodifier; 
    m_cInvisibleModeHotKey = key; 
    if(theApp.emuledlg!=NULL){ 
        //Always unregister, the keys could be different. 
        theApp.emuledlg->UnRegisterInvisibleHotKey(); 
        if(m_bInvisibleMode)    theApp.emuledlg->RegisterInvisibleHotKey(); 
    } 
}     
//<== dlarge InvisibleMode

// General behavior:
// WinVer = 95/NT4
// Default: ApplicationDir
// Default _not_ overwritten by Registry value
//
// WinVer < Vista && WinVer > Win95:
// Default: ApplicationDir if preference.ini exists there. If not: user specific dirs if preferences.ini exits there. If not: again ApplicationDir
// Default overwritten by Registry value (see below)
// Fallback: ApplicationDir
//
// WinVer >= Vista:
// Default: User specific Dir if preferences.ini exists there. If not: All users dir, if preferences.ini exists there. If not user specific dirs again
// Default overwritten by Registry value (see below)
// Fallback: ApplicationDir
CString CPreferences::GetDefaultDirectory(EDefaultDirectory eDirectory, bool bCreate){
	
	if (m_astrDefaultDirs[0].IsEmpty()){ // already have all directories fetched and stored?	
		
		// Get out exectuable starting directory which was our default till Vista
		TCHAR tchBuffer[490];
		::GetModuleFileName(0,tchBuffer, 490);
		LPTSTR pszFileName = _tcsrchr(tchBuffer, L'\\') + 1;
		*pszFileName = L'\0';
		m_astrDefaultDirs[EMULE_EXECUTEABLEDIR] = tchBuffer;

		// set our results to old default / fallback values
		// those 3 dirs are the base for all others
		CString strSelectedDataBaseDirectory = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR];
		CString strSelectedConfigBaseDirectory = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR];
		CString strSelectedExpansionBaseDirectory = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR];
		m_nCurrentUserDirMode = 2; // To let us know which "mode" we are using in case we want to switch per options

		// For Win95, 98 and NT we only support our old defaults due to missing functions (no point for multiuser on those OSs anyway)
		if (GetWindowsVersion() != _WINVER_95_ && GetWindowsVersion() != _WINVER_NT4_){
			// check if preferences.ini exists already in our default / fallback dir
			CFileFind ff;
			bool bConfigAvailableExecuteable = ff.FindFile(strSelectedConfigBaseDirectory + CONFIGFOLDER + _T("preferences.ini"), 0) != 0;
			ff.Close();
			
			// check if our registry setting is present which forces the single or multiuser directories
			// and lets us ignore other defaults
			// 0 = Multiuser, 1 = Publicuser, 2 = ExecuteableDir. (on Winver < Vista 1 has the same effect as 2)
			DWORD nRegistrySetting = (DWORD)-1;
			CRegKey rkEMuleRegKey;
			if (rkEMuleRegKey.Open(HKEY_CURRENT_USER, _T("Software\\eMule"), KEY_READ) == ERROR_SUCCESS){
				rkEMuleRegKey.QueryDWORDValue(_T("UsePublicUserDirectories"), nRegistrySetting);
				rkEMuleRegKey.Close();
			}
			if (nRegistrySetting != -1 && nRegistrySetting != 0 && nRegistrySetting != 1 && nRegistrySetting != 2)
				nRegistrySetting = (DWORD)-1;

			// Do we need to get SystemFolders or do we use our old Default anyway? (Executable Dir)
			if (nRegistrySetting == 0 || (nRegistrySetting == 1 && GetWindowsVersion() == _WINVER_VISTA_)
				|| (nRegistrySetting == -1 && (!bConfigAvailableExecuteable || GetWindowsVersion() == _WINVER_VISTA_)))
			{
				HMODULE hShell32 = LoadLibrary(_T("shell32.dll"));
				if (hShell32){
					if (GetWindowsVersion() == _WINVER_VISTA_){
						
						PWSTR pszLocalAppData = NULL;
						PWSTR pszPersonalDownloads = NULL;
						PWSTR pszPublicDownloads = NULL;
						PWSTR pszProgrammData = NULL;

						// function not available on < WinVista
						HRESULT (WINAPI *pfnSHGetKnownFolderPath)(REFKNOWNFOLDERID, DWORD, HANDLE, PWSTR*);
						(FARPROC&)pfnSHGetKnownFolderPath = GetProcAddress(hShell32, "SHGetKnownFolderPath");
						
						if (pfnSHGetKnownFolderPath != NULL
							&& (*pfnSHGetKnownFolderPath)(FOLDERID_LocalAppData, 0, NULL, &pszLocalAppData) == S_OK
							&& (*pfnSHGetKnownFolderPath)(FOLDERID_Downloads, 0, NULL, &pszPersonalDownloads) == S_OK
							&& (*pfnSHGetKnownFolderPath)(FOLDERID_PublicDownloads, 0, NULL, &pszPublicDownloads) == S_OK
							&& (*pfnSHGetKnownFolderPath)(FOLDERID_ProgramData, 0, NULL, &pszProgrammData) == S_OK)
						{
							if (_tcsclen(pszLocalAppData) < MAX_PATH - 30 && _tcsclen(pszPersonalDownloads) < MAX_PATH - 40
								&& _tcsclen(pszProgrammData) < MAX_PATH - 30 && _tcsclen(pszPublicDownloads) < MAX_PATH - 40)
							{
								CString strLocalAppData  = pszLocalAppData;
								CString strPersonalDownloads = pszPersonalDownloads;
								CString strPublicDownloads = pszPublicDownloads;
								CString strProgrammData = pszProgrammData;
								if (strLocalAppData.Right(1) != _T("\\"))
									strLocalAppData += _T("\\");
								if (strPersonalDownloads.Right(1) != _T("\\"))
									strPersonalDownloads += _T("\\");
								if (strPublicDownloads.Right(1) != _T("\\"))
									strPublicDownloads += _T("\\");
								if (strProgrammData.Right(1) != _T("\\"))
									strProgrammData += _T("\\");

								if (nRegistrySetting == -1){
									// no registry default, check if we find a preferences.ini to use
									bool bRes =  ff.FindFile(strLocalAppData + _T("eMule\\") + CONFIGFOLDER + _T("preferences.ini"), 0) != 0;
									ff.Close();
									if (bRes)
										m_nCurrentUserDirMode = 0;
									else{
										bRes =  ff.FindFile(strProgrammData + _T("eMule\\") + CONFIGFOLDER + _T("preferences.ini"), 0) != 0;
										ff.Close();
										if (bRes)
											m_nCurrentUserDirMode = 1;
										else if (bConfigAvailableExecuteable)
											m_nCurrentUserDirMode = 2;
										else
											m_nCurrentUserDirMode = 0; // no preferences.ini found, use the default
									}
								}
								else
									m_nCurrentUserDirMode = nRegistrySetting;
								
								if (m_nCurrentUserDirMode == 0){
									// multiuser
									strSelectedDataBaseDirectory = strPersonalDownloads + _T("eMule\\");
									strSelectedConfigBaseDirectory = strLocalAppData + _T("eMule\\");
									strSelectedExpansionBaseDirectory = strProgrammData + _T("eMule\\");
									m_nCurrentUserDirMode = 0;
								}
								else if (m_nCurrentUserDirMode == 1){
									// public user
									strSelectedDataBaseDirectory = strPublicDownloads + _T("eMule\\");
									strSelectedConfigBaseDirectory = strProgrammData + _T("eMule\\");
									strSelectedExpansionBaseDirectory = strProgrammData + _T("eMule\\");
									m_nCurrentUserDirMode = 1;
								}
								else if (m_nCurrentUserDirMode == 2){
									// programm directory
									m_nCurrentUserDirMode = 2;
								}
								else
									ASSERT( false );
							}
							else
								ASSERT( false );
							}

							CoTaskMemFree(pszLocalAppData);
							CoTaskMemFree(pszPersonalDownloads);
							CoTaskMemFree(pszPublicDownloads);
							CoTaskMemFree(pszProgrammData);
					}
					else { // GetWindowsVersion() == _WINVER_VISTA_
						
						// function not available on < WinME (at least not the values we query, otherwise also on 98, 95 with IE5)
						WCHAR wchAppData[MAX_PATH];
						WCHAR wchPersonal[MAX_PATH];
						HRESULT (WINAPI* pfnSHGetFolderPathW)(HWND, int, HANDLE, DWORD, LPWSTR);
						(FARPROC&)pfnSHGetFolderPathW = GetProcAddress(hShell32, "SHGetFolderPathW");
						if (pfnSHGetFolderPathW != NULL
							&& (*pfnSHGetFolderPathW)(NULL, CSIDL_APPDATA, NULL, SHGFP_TYPE_CURRENT, wchAppData) == S_OK
							&& (*pfnSHGetFolderPathW)(NULL, CSIDL_PERSONAL, NULL, SHGFP_TYPE_CURRENT, wchPersonal) == S_OK)
						{
							if (_tcsclen(wchAppData) < MAX_PATH - 30 && _tcsclen(wchPersonal) < MAX_PATH - 40){
								CString strPersonal = wchPersonal;
								CString strAppData = wchAppData;
								if (strPersonal.Right(1) != _T("\\"))
									strPersonal += _T("\\");
								if (strAppData.Right(1) != _T("\\"))
									strAppData += _T("\\");
								if (nRegistrySetting == 0){
									// registry setting overwrites, use these folders
									strSelectedDataBaseDirectory = strPersonal + _T("eMule Downloads\\");
									strSelectedConfigBaseDirectory = strAppData + _T("eMule\\");
									m_nCurrentUserDirMode = 0;
									// strSelectedExpansionBaseDirectory stays default
								}
								else if (nRegistrySetting == -1 && !bConfigAvailableExecuteable){
									if (ff.FindFile(strAppData + _T("eMule\\") + CONFIGFOLDER + _T("preferences.ini"), 0)){
										// preferences.ini found, so we use this as default
										strSelectedDataBaseDirectory = strPersonal + _T("eMule Downloads\\");
										strSelectedConfigBaseDirectory = strAppData + _T("eMule\\");
										m_nCurrentUserDirMode = 0;
									}
									ff.Close();
								}
								else
									ASSERT( false );
							}
							else
								ASSERT( false );

						}	 
					}
					FreeLibrary(hShell32);
				}
				else{
					DebugLogError(_T("Unable to load shell32.dll to retrieve the systemfolder locations, using fallbacks"));
					ASSERT( false );
				}
			}
		}

		// the use of ending backslashes is inconsitent, would need a rework throughout the code to fix this
		m_astrDefaultDirs[EMULE_CONFIGDIR] = strSelectedConfigBaseDirectory + CONFIGFOLDER;
		m_astrDefaultDirs[EMULE_TEMPDIR] = strSelectedDataBaseDirectory + _T("Temp");
		m_astrDefaultDirs[EMULE_INCOMINGDIR] = strSelectedDataBaseDirectory + _T("Incoming");
		m_astrDefaultDirs[EMULE_LOGDIR] = strSelectedConfigBaseDirectory + _T("logs\\");
		m_astrDefaultDirs[EMULE_ADDLANGDIR] = strSelectedExpansionBaseDirectory + _T("lang\\");
		m_astrDefaultDirs[EMULE_INSTLANGDIR] = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR] + _T("lang\\");
		m_astrDefaultDirs[EMULE_WEBSERVERDIR] = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR] + _T("webserver\\");
		m_astrDefaultDirs[EMULE_DATABASEDIR] = strSelectedDataBaseDirectory; // has ending backslashes
		m_astrDefaultDirs[EMULE_CONFIGBASEDIR] = strSelectedConfigBaseDirectory; // has ending backslashes
		//                EMULE_EXECUTEABLEDIR
		m_astrDefaultDirs[EMULE_EXPANSIONDIR] = strSelectedExpansionBaseDirectory; // has ending backslashes
		m_astrDefaultDirs[EMULE_ADDONDIR] = m_astrDefaultDirs[EMULE_EXECUTEABLEDIR] + L"addons\\";	//>>> shadow2004::AddonDirectory

		/*CString strDebug;
		for (int i = 0; i < 12; i++)
			strDebug += m_astrDefaultDirs[i] + _T("\n");
		AfxMessageBox(strDebug, MB_ICONINFORMATION);*/
	}
	if (bCreate && !m_abDefaultDirsCreated[eDirectory]){
		switch (eDirectory){ // create the underlying directory first - be sure to adjust this if changing default directories
			case EMULE_CONFIGDIR:
			case EMULE_LOGDIR:
				::CreateDirectory(m_astrDefaultDirs[EMULE_CONFIGBASEDIR], NULL);
				break;
			case EMULE_TEMPDIR:
			case EMULE_INCOMINGDIR:
				::CreateDirectory(m_astrDefaultDirs[EMULE_DATABASEDIR], NULL);
				break;
			case EMULE_ADDLANGDIR:
				::CreateDirectory(m_astrDefaultDirs[EMULE_EXPANSIONDIR], NULL);
				break;
		}
		::CreateDirectory(m_astrDefaultDirs[eDirectory], NULL);
		m_abDefaultDirsCreated[eDirectory] = true;
	}
	return m_astrDefaultDirs[eDirectory];
}

CString	CPreferences::GetMuleDirectory(EDefaultDirectory eDirectory, bool bCreate){
	switch (eDirectory){
		case EMULE_INCOMINGDIR:
			return m_strIncomingDir;
		case EMULE_TEMPDIR:
			ASSERT( false ); // use GetTempDir() instead! This function can only return the first tempdirectory
			return GetTempDir(0);
		default:
			return GetDefaultDirectory(eDirectory, bCreate);
	}
}

void CPreferences::SetMuleDirectory(EDefaultDirectory eDirectory, CString strNewDir){
	switch (eDirectory){
		case EMULE_INCOMINGDIR:
			m_strIncomingDir = strNewDir;
			break;
		default:
			ASSERT( false );
	}
}

void CPreferences::ChangeUserDirMode(int nNewMode){
	if (m_nCurrentUserDirMode == nNewMode)
		return;
	if ((nNewMode == 1 && GetWindowsVersion() != _WINVER_VISTA_)
		|| (nNewMode == 0 &&
		(GetWindowsVersion() == _WINVER_95_ || GetWindowsVersion() == _WINVER_NT4_)))
	{
		ASSERT( false );
		return;
	}
	// check if our registry setting is present which forces the single or multiuser directories
	// and lets us ignore other defaults
	// 0 = Multiuser, 1 = Publicuser, 2 = ExecuteableDir.
	CRegKey rkEMuleRegKey;
	if (rkEMuleRegKey.Create(HKEY_CURRENT_USER, _T("Software\\eMule")) == ERROR_SUCCESS){
		if (rkEMuleRegKey.SetDWORDValue(_T("UsePublicUserDirectories"), nNewMode) != ERROR_SUCCESS)
			DebugLogError(_T("Failed to write registry key to switch UserDirMode"));
		else
			m_nCurrentUserDirMode = nNewMode;
		rkEMuleRegKey.Close();
	}	
}

bool CPreferences::GetSparsePartFiles()	{
	// Vistas Sparse File implemenation seems to be buggy as far as i can see
	// If a sparsefile exceeds a given limit of write io operations in a certain order (or i.e. end to beginning)
	// in its lifetime, it will at some point throw out a FILE_SYSTEM_LIMITATION error and deny any writing
	// to this file.
	// It was suggested that Vista might limits the dataruns, which would lead to such a behavior, but wouldn't
	// make much sense for a sparse file implementation nevertheless.
	// Due to the fact that eMule wirtes a lot small blocks into sparse files and flushs them every 6 seconds,
	// this problem pops up sooner or later for all big files. I don't see any way to walk arround this for now
	return m_bSparsePartFiles && (GetWindowsVersion() != _WINVER_VISTA_);
}

bool CPreferences::IsRunningAeroGlassTheme(){
	// This is important for all functions which need to draw in the NC-Area (glass style)
	// Aero by default does not allow this, any drawing will not be visible. This can be turned off,
	// but Vista will not deliver the Glass style then as background when calling the default draw function
	// in other words, its draw all or nothing yourself - eMule chooses currently nothing
	static bool bAeroAlreadyDetected = false;
	if (!bAeroAlreadyDetected){
		bAeroAlreadyDetected = true;
		m_bIsRunningAeroGlass = FALSE;
		if (GetWindowsVersion() == _WINVER_VISTA_){
			HMODULE hDWMAPI = LoadLibrary(_T("dwmapi.dll"));
			if (hDWMAPI){
				HRESULT (WINAPI *pfnDwmIsCompositionEnabled)(BOOL*);
				(FARPROC&)pfnDwmIsCompositionEnabled = GetProcAddress(hDWMAPI, "DwmIsCompositionEnabled");
				if (pfnDwmIsCompositionEnabled != NULL)
					pfnDwmIsCompositionEnabled(&m_bIsRunningAeroGlass);
				FreeLibrary(hDWMAPI);
			}
		}
	}
	return m_bIsRunningAeroGlass == TRUE ? true : false;
}

//==> dlarge SUC/USS
void	CPreferences::SetMinUpload(UINT in)
{
	minupload = (uint16)((in) ? in : UNLIMITED);
}

bool	CPreferences::IsSUCDoesWork()
{
	return minupload<maxupload && maxupload != UNLIMITED && m_bSUCEnabled;
}
//<== dlarge SUC/USS

//==> dlarge SafePrefsettings 
void CPreferences::CheckSilverPreferences()
{
//==> dlarge Argos System (Xanatos)
	MinMax(&m_iArgosTrustTime,TIM_ARGOS_TRUST_TIME_MIN,TIM_ARGOS_TRUST_TIME_MAX);
	MinMax(&m_iArgosProcessTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosTrackTime,TIM_ARGOS_TRACK_TIME_MIN,TIM_ARGOS_TRACK_TIME_MAX);
	MinMax(&m_iArgosGenericBanTime,TIM_ARGOS_GENERIC_BAN_TIME_MIN,TIM_ARGOS_GENERIC_BAN_TIME_MAX);
	MinMax(&m_iArgosAgressionBanTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosOpCodeTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosHashChangedTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosRankFlooderTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosGhostModeTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosCorruptedSenderTime,TIM_ARGOS_BAN_BAD_TIME_MIN,TIM_ARGOS_BAN_BAD_TIME_MAX);
	MinMax(&m_iArgosFileScannerTime,TIM_ARGOS_BAN_BAD_TIME_MIN,TIM_ARGOS_BAN_BAD_TIME_MAX);
	MinMax(&m_iArgosFileFakerTime,TIM_ARGOS_BAN_BAD_TIME_MIN,TIM_ARGOS_BAN_BAD_TIME_MAX);
	MinMax(&m_iArgosFailedTime,TIM_ARGOS_BAN_BAD_TIME_MIN,TIM_ARGOS_BAN_BAD_TIME_MAX);
	MinMax(&m_iArgosXSExploitTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosNickChangerTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosModChangerTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosNullNickTime, TIM_ARGOS_BAN_TIME_MIN, TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosSpamTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosBadHelloTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iArgosBadProtTime,TIM_ARGOS_BAN_TIME_MIN,TIM_ARGOS_BAN_TIME_MAX);
	MinMax(&m_iAgressionIntervals,TIM_ARGOS_AGRESSION_INTERVALS_MIN,TIM_ARGOS_AGRESSION_INTERVALS_MAX);
	MinMax(&m_iAgressionThreshold,VAL_ARGOS_AGRESSION_THRESHOLD_MIN,VAL_ARGOS_AGRESSION_THRESHOLD_MAX);
	MinMax(&m_iFailedTries,VAL_ARGOS_FAILED_TRIES_MIN,VAL_ARGOS_FAILED_TRIES_MAX);
	MinMax(&m_iFailedThreshold,VAL_ARGOS_FAILED_THRESHOLD_MIN,VAL_ARGOS_FAILED_THRESHOLD_MAX);
	MinMax(&m_iXSExploitIntervals,TIM_ARGOS_XS_EXPLOIT_INTERVALS_MIN,TIM_ARGOS_XS_EXPLOIT_INTERVALS_MAX);
	MinMax(&m_iXSExploitThreshold,VAL_ARGOS_XS_EXPLOIT_THRESHOLD_MIN,VAL_ARGOS_XS_EXPLOIT_THRESHOLD_MAX);
	MinMax(&m_iNickChangeIntervals,TIM_ARGOS_NICK_CHANGE_INTERVALS_MIN,TIM_ARGOS_NICK_CHANGE_INTERVALS_MAX);
	MinMax(&m_iNickChangeThreshold,VAL_ARGOS_NICK_CHANGE_THRESHOLD_MIN,VAL_ARGOS_NICK_CHANGE_THRESHOLD_MAX);
	MinMax(&m_iModChangeIntervals,TIM_ARGOS_MOD_CHANGE_INTERVALS_MIN,TIM_ARGOS_MOD_CHANGE_INTERVALS_MAX);
	MinMax(&m_iModChangeThreshold,VAL_ARGOS_MOD_CHANGE_THRESHOLD_MIN,VAL_ARGOS_MOD_CHANGE_THRESHOLD_MAX);
//==> dlarge Argos System (Xanatos)
}

//==> dlarge Design Settings 
void CPreferences::InitStyles()
{
	// client styles
	for (int i=0;i<style_c_count;i++)
	{
		nClientStyleFlags[i] = 0;
		nClientStyleFontColor[i]	= CLR_DEFAULT;
		nClientStyleBackColor[i]	= CLR_DEFAULT;
		nClientStyleOnOff[i] = 0;
	}

	// download styles
	for (int i=0;i<style_d_count;i++)
	{
		nDownloadStyleFlags[i] = 0;
		nDownloadStyleFontColor[i]	= CLR_DEFAULT;
		nDownloadStyleBackColor[i]	= CLR_DEFAULT;
		nDownloadStyleOnOff[i] = 0;
	}

	// share styles
	for (int i=0;i<style_s_count;i++)
	{
		nShareStyleFlags[i] = 0;
		nShareStyleFontColor[i]	= CLR_DEFAULT;
		nShareStyleBackColor[i]	= CLR_DEFAULT;
		nShareStyleOnOff[i] = 0;
	}

	// server styles
	for (int i=0;i<style_se_count;i++)
	{
		nServerStyleFlags[i] = 0;
		nServerStyleFontColor[i]	= CLR_DEFAULT;
		nServerStyleBackColor[i]	= CLR_DEFAULT;
		nServerStyleOnOff[i] = 0;
	}

	// background styles
	for (int i=0;i<style_b_count;i++)
	{
		nBackgroundStyleFlags[i] = 0;
		nBackgroundStyleFontColor[i]	= CLR_DEFAULT;
		nBackgroundStyleBackColor[i]	= CLR_DEFAULT;
		nBackgroundStyleOnOff[i] = 0;
	}

	// window styles
	for (int i=0;i<style_w_count;i++)
	{
		nWindowStyleFlags[i] = 0;
		nWindowStyleFontColor[i]	= CLR_DEFAULT;
		nWindowStyleBackColor[i]	= CLR_DEFAULT;
		nWindowStyleOnOff[i] = 0;
	}
}

DWORD CPreferences::GetStyleFlags(int nMaster, int nStyle)
{
	DWORD dwTemp = 0;
	switch(nMaster)
	{
		case client_styles:
			dwTemp = nClientStyleFlags[nStyle];
			break;
		case download_styles:
			dwTemp = nDownloadStyleFlags[nStyle];
			break;
		case share_styles:
			dwTemp = nShareStyleFlags[nStyle];
			break;
		case server_styles:
			dwTemp = nServerStyleFlags[nStyle];
			break;
		case background_styles:
			dwTemp = nBackgroundStyleFlags[nStyle];
			break;
		case window_styles:
			dwTemp = nWindowStyleFlags[nStyle];
			break;
		default:
			break;
	}
	return dwTemp;
}

COLORREF CPreferences::GetStyleFontColor(int nMaster, int nStyle)
{
	COLORREF crTemp = 0;
	switch(nMaster)
	{
		case client_styles:
			crTemp = nClientStyleFontColor[nStyle];
			break;
		case download_styles:
			crTemp = nDownloadStyleFontColor[nStyle];
			break;
		case share_styles:
			crTemp = nShareStyleFontColor[nStyle];
			break;
		case server_styles:
			crTemp = nServerStyleFontColor[nStyle];
			break;
		case background_styles:
			crTemp = nBackgroundStyleFontColor[nStyle];
			break;
		case window_styles:
			crTemp = nWindowStyleFontColor[nStyle];
			break;
		default:
			break;
	}
	return crTemp;
}

COLORREF CPreferences::GetStyleBackColor(int nMaster, int nStyle)
{
	COLORREF crTemp = 0;
	switch(nMaster)
	{
		case client_styles:
			crTemp = nClientStyleBackColor[nStyle];
			break;
		case download_styles:
			crTemp = nDownloadStyleBackColor[nStyle];
			break;
		case share_styles:
			crTemp = nShareStyleBackColor[nStyle];
			break;
		case server_styles:
			crTemp = nServerStyleBackColor[nStyle];
			break;
		case background_styles:
			crTemp = nBackgroundStyleBackColor[nStyle];
			break;
		case window_styles:
			crTemp = nWindowStyleBackColor[nStyle];
			break;
		default:
			break;
	}
	return crTemp;
}

short CPreferences::GetStyleOnOff(int nMaster, int nStyle)
{
	short sTemp = 0;
	switch(nMaster)
	{
		case client_styles:
			sTemp = nClientStyleOnOff[nStyle];
			break;
		case download_styles:
			sTemp = nDownloadStyleOnOff[nStyle];
			break;
		case share_styles:
			sTemp = nShareStyleOnOff[nStyle];
			break;
		case server_styles:
			sTemp = nServerStyleOnOff[nStyle];
			break;
		case background_styles:
			sTemp = nBackgroundStyleOnOff[nStyle];
			break;
		case window_styles:
			sTemp = nWindowStyleOnOff[nStyle];
			break;
		default:
			break;
	}
	return sTemp;
}

bool CPreferences::GetStyle(int nMaster, int nStyle, StylesStruct *style)
{
	if (!style)
		return false;
	if (nMaster < master_count)
	{
		style->nFlags = GetStyleFlags(nMaster,nStyle);
		style->nFontColor = GetStyleFontColor(nMaster,nStyle);
		style->nBackColor = GetStyleBackColor(nMaster,nStyle);
		style->nOnOff = GetStyleOnOff(nMaster,nStyle);
	}
	else		
	{
		style->nFlags = 0;
		style->nFontColor = CLR_DEFAULT;
		style->nBackColor = CLR_DEFAULT;
		style->nOnOff = 0;
	}
	return true;
}

void CPreferences::SetStyleFlags(int nMaster, int nStyle, DWORD dwNew)
{
	switch(nMaster)
	{
		case client_styles:
			nClientStyleFlags[nStyle] = dwNew;
			break;
		case download_styles:
			nDownloadStyleFlags[nStyle] = dwNew;
			break;
		case share_styles:
			nShareStyleFlags[nStyle] = dwNew;
			break;
		case server_styles:
			nServerStyleFlags[nStyle] = dwNew;
			break;
		case background_styles:
			nBackgroundStyleFlags[nStyle] = dwNew;
			break;
		case window_styles:
			nWindowStyleFlags[nStyle] = dwNew;
			break;
		default:
			break;
	}
}

void CPreferences::SetStyleFontColor(int nMaster, int nStyle, COLORREF crNew)
{
	switch(nMaster)
	{
		case client_styles:
			nClientStyleFontColor[nStyle] = crNew;
			break;
		case download_styles:
			nDownloadStyleFontColor[nStyle] = crNew;
			break;
		case share_styles:
			nShareStyleFontColor[nStyle] = crNew;
			break;
		case server_styles:
			nServerStyleFontColor[nStyle] = crNew;
			break;
		case background_styles:
			nBackgroundStyleFontColor[nStyle] = crNew;
			break;
		case window_styles:
			nWindowStyleFontColor[nStyle] = crNew;
			break;
		default:
			break;
	}
}

void CPreferences::SetStyleBackColor(int nMaster, int nStyle, COLORREF crNew)
{
	switch(nMaster)
	{
		case client_styles:
			nClientStyleBackColor[nStyle] = crNew;
			break;
		case download_styles:
			nDownloadStyleBackColor[nStyle] = crNew;
			break;
		case share_styles:
			nShareStyleBackColor[nStyle] = crNew;
			break;
		case server_styles:
			nServerStyleBackColor[nStyle] = crNew;
			break;
		case background_styles:
			nBackgroundStyleBackColor[nStyle] = crNew;
			break;
		case window_styles:
			nWindowStyleBackColor[nStyle] = crNew;
			break;
		default:
			break;
	}
}

void CPreferences::SetStyleOnOff(int nMaster, int nStyle, short sNew)
{
	switch(nMaster)
	{
		case client_styles:
			nClientStyleOnOff[nStyle] = sNew;
			break;
		case download_styles:
			nDownloadStyleOnOff[nStyle] = sNew;
			break;
		case share_styles:
			nShareStyleOnOff[nStyle] = sNew;
			break;
		case server_styles:
			nServerStyleOnOff[nStyle] = sNew;
			break;
		case background_styles:
			nBackgroundStyleOnOff[nStyle] = sNew;
			break;
		case window_styles:
			nWindowStyleOnOff[nStyle] = sNew;
			break;
		default:
			break;
	}
}

bool CPreferences::SetStyle(int nMaster, int nStyle, StylesStruct *style)
{
	if (nMaster < master_count)
	{
		if (style == NULL)
		{
			SetStyleFlags(nMaster, nStyle, STYLE_USED);
			SetStyleFontColor(nMaster, nStyle, CLR_DEFAULT);
			SetStyleBackColor(nMaster, nStyle, CLR_DEFAULT);
			SetStyleOnOff(nMaster, nStyle, 0);
		}
		else
		{
			SetStyleFlags(nMaster, nStyle, style->nFlags|STYLE_USED);
			SetStyleFontColor(nMaster, nStyle, style->nFontColor);
			SetStyleBackColor(nMaster, nStyle, style->nBackColor);
			SetStyleOnOff(nMaster, nStyle, style->nOnOff);
		}
		return true;
	}
	return false;
}

void CPreferences::SaveStylePrefs(CIni &ini)
{
	ini.SetSection(L"STYLES");
	ini.WriteInt(L"Version",STYLE_VERSION);

	// client styles
	ini.SerGet(false, nClientStyleFlags,		ELEMENT_COUNT(nClientStyleFlags), L"ClientStyleFlags");
	ini.SerGet(false, nClientStyleFontColor,	ELEMENT_COUNT(nClientStyleFontColor), L"ClientStyleFontColor");
	ini.SerGet(false, nClientStyleBackColor,	ELEMENT_COUNT(nClientStyleBackColor), L"ClientStyleBackColor");
	ini.SerGet(false, nClientStyleOnOff,		ELEMENT_COUNT(nClientStyleOnOff), L"ClientStyleOnOff");

	// download styles
	ini.SerGet(false, nDownloadStyleFlags,		ELEMENT_COUNT(nDownloadStyleFlags), L"DownloadStyleFlags");
	ini.SerGet(false, nDownloadStyleFontColor,	ELEMENT_COUNT(nDownloadStyleFontColor), L"DownloadStyleFontColor");
	ini.SerGet(false, nDownloadStyleBackColor,	ELEMENT_COUNT(nDownloadStyleBackColor), L"DownloadStyleBackColor");
	ini.SerGet(false, nDownloadStyleOnOff,		ELEMENT_COUNT(nDownloadStyleOnOff), L"DownloadStyleOnOff");

	// share styles
	ini.SerGet(false, nShareStyleFlags,		ELEMENT_COUNT(nShareStyleFlags), L"ShareStyleFlags");
	ini.SerGet(false, nShareStyleFontColor,	ELEMENT_COUNT(nShareStyleFontColor), L"ShareStyleFontColor");
	ini.SerGet(false, nShareStyleBackColor,	ELEMENT_COUNT(nShareStyleBackColor), L"ShareStyleBackColor");
	ini.SerGet(false, nShareStyleOnOff,		ELEMENT_COUNT(nShareStyleOnOff), L"ShareStyleOnOff");

	// server styles
	ini.SerGet(false, nServerStyleFlags,		ELEMENT_COUNT(nServerStyleFlags), L"ServerStyleFlags");
	ini.SerGet(false, nServerStyleFontColor,	ELEMENT_COUNT(nServerStyleFontColor), L"ServerStyleFontColor");
	ini.SerGet(false, nServerStyleBackColor,	ELEMENT_COUNT(nServerStyleBackColor), L"ServerStyleBackColor");
	ini.SerGet(false, nServerStyleOnOff,		ELEMENT_COUNT(nServerStyleOnOff), L"ServerStyleOnOff");

	// background styles
	ini.SerGet(false, nBackgroundStyleFlags,		ELEMENT_COUNT(nBackgroundStyleFlags), L"BackgroundStyleFlags");
	ini.SerGet(false, nBackgroundStyleBackColor,	ELEMENT_COUNT(nBackgroundStyleBackColor), L"BackgroundStyleBackColor");

	// window styles
	ini.SerGet(false, nWindowStyleFlags,		ELEMENT_COUNT(nWindowStyleFlags), L"WindowStyleFlags");
	ini.SerGet(false, nWindowStyleBackColor,	ELEMENT_COUNT(nWindowStyleBackColor), L"WindowStyleBackColor");
}
void CPreferences::LoadStylePrefs(CIni &ini)
{
	ini.SetSection(L"STYLES");
	int iVersion = ini.GetInt(L"Version");

	// client styles
	ini.SerGet(true, nClientStyleFlags,		ELEMENT_COUNT(nClientStyleFlags), L"ClientStyleFlags");
	ini.SerGet(true, nClientStyleFontColor,	ELEMENT_COUNT(nClientStyleFontColor), L"ClientStyleFontColor");
	ini.SerGet(true, nClientStyleBackColor,	ELEMENT_COUNT(nClientStyleBackColor), L"ClientStyleBackColor");
	ini.SerGet(true, nClientStyleOnOff,		ELEMENT_COUNT(nClientStyleOnOff), L"ClientStyleOnOff");

	for (int i=0;i<style_c_count;i++)
	{
		if ((nClientStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
			switch(i)
			{
				case style_c_downloading:
					nClientStyleFlags[i] = STYLE_BOLD|STYLE_USED;
		            nClientStyleFontColor[i]	= COLORREF(RGB(50,205,50));
					nClientStyleBackColor[i]	= CLR_DEFAULT;
					nClientStyleOnOff[i] = 1;
					break;
				case style_c_leecher:
					nClientStyleFlags[i] = STYLE_USED;
					nClientStyleFontColor[i]	= COLORREF(RGB(255,0,0));
		            nClientStyleBackColor[i]	= CLR_DEFAULT;
					nClientStyleOnOff[i] = 1;
					break;
				case style_c_lowid:
					nClientStyleFlags[i] = STYLE_USED;
		            nClientStyleFontColor[i]	= CLR_DEFAULT;
					nClientStyleBackColor[i]	= COLORREF(RGB(255,250,200));
					nClientStyleOnOff[i] = 1;
					break;
				default:
		            nClientStyleFontColor[i]	= CLR_DEFAULT;
		            nClientStyleBackColor[i]	= CLR_DEFAULT;
					break;
			}
		}
	}

	// download styles
	ini.SerGet(true, nDownloadStyleFlags,		ELEMENT_COUNT(nDownloadStyleFlags), L"DownloadStyleFlags");
	ini.SerGet(true, nDownloadStyleFontColor,	ELEMENT_COUNT(nDownloadStyleFontColor), L"DownloadStyleFontColor");
	ini.SerGet(true, nDownloadStyleBackColor,	ELEMENT_COUNT(nDownloadStyleBackColor), L"DownloadStyleBackColor");
	ini.SerGet(true, nDownloadStyleOnOff,		ELEMENT_COUNT(nDownloadStyleOnOff), L"DownloadStyleOnOff");

	for (int i=0;i<style_d_count;i++)
	{
		if ((nDownloadStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
			switch(i)
			{
				case style_d_downloading:
					nDownloadStyleFlags[i] = STYLE_BOLD|STYLE_USED;
					nDownloadStyleFontColor[i]	= COLORREF(RGB(50,205,50));
		            nDownloadStyleBackColor[i]	= CLR_DEFAULT;
					nDownloadStyleOnOff[i] = 1;
					break;
				default:
		            nDownloadStyleFontColor[i]	= CLR_DEFAULT;
		            nDownloadStyleBackColor[i]	= CLR_DEFAULT;
					break;
			}
		}
	}

	// share styles
	ini.SerGet(true, nShareStyleFlags,		ELEMENT_COUNT(nShareStyleFlags), L"ShareStyleFlags");
	ini.SerGet(true, nShareStyleFontColor,	ELEMENT_COUNT(nShareStyleFontColor), L"ShareStyleFontColor");
	ini.SerGet(true, nShareStyleBackColor,	ELEMENT_COUNT(nShareStyleBackColor), L"ShareStyleBackColor");
	ini.SerGet(true, nShareStyleOnOff,		ELEMENT_COUNT(nShareStyleOnOff), L"ShareStyleOnOff");

	for (int i=0;i<style_s_count;i++)
	{
		if ((nShareStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
			switch(i)
			{
				case style_s_incomplete:
					nShareStyleFlags[i] = STYLE_ITALIC|STYLE_USED;
					nShareStyleFontColor[i]	= COLORREF(RGB(0,0,255));
		            nShareStyleBackColor[i]	= CLR_DEFAULT;
					nShareStyleOnOff[i] = 1;
					break;
				case style_s_powershare:
					nShareStyleFlags[i] = STYLE_USED;
					nShareStyleFontColor[i]	= COLORREF(RGB(255,0,0));
		            nShareStyleBackColor[i]	= CLR_DEFAULT;
					nShareStyleOnOff[i] = 1;
					break;
				default:
		            nShareStyleFontColor[i]	= CLR_DEFAULT;
		            nShareStyleBackColor[i]	= CLR_DEFAULT;
					break;
			}
		}
	}

	// server styles
	ini.SerGet(true, nServerStyleFlags,		ELEMENT_COUNT(nServerStyleFlags), L"ServerStyleFlags");
	ini.SerGet(true, nServerStyleFontColor,	ELEMENT_COUNT(nServerStyleFontColor), L"ServerStyleFontColor");
	ini.SerGet(true, nServerStyleBackColor,	ELEMENT_COUNT(nServerStyleBackColor), L"ServerStyleBackColor");
	ini.SerGet(true, nServerStyleOnOff,		ELEMENT_COUNT(nServerStyleOnOff), L"ServerStyleOnOff");

	for (int i=0;i<style_se_count;i++)
	{
		if ((nServerStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
			switch(i)
			{
				case style_se_connected:
					nServerStyleFlags[i] = STYLE_BOLD|STYLE_USED;
		            nServerStyleFontColor[i]	= COLORREF(RGB(0,0,192));
					nServerStyleBackColor[i]	= CLR_DEFAULT;
					nServerStyleOnOff[i] = 1;
					break;
				case style_se_filtered:
					nServerStyleFlags[i] = STYLE_USED;
		            nServerStyleFontColor[i]	= COLORREF(RGB(192,192,192));
					nServerStyleBackColor[i]	= CLR_DEFAULT;
					nServerStyleOnOff[i] = 1;
					break;
				case style_se_dead:
					nServerStyleFlags[i] = STYLE_USED;
		            nServerStyleFontColor[i]	= COLORREF(RGB(192,192,192));
					nServerStyleBackColor[i]	= CLR_DEFAULT;
					nServerStyleOnOff[i] = 1;
					break;
				case style_se_unreliable:
					nServerStyleFlags[i] = STYLE_USED;
		            nServerStyleFontColor[i]	= COLORREF(RGB(128,128,128));
					nServerStyleBackColor[i]	= CLR_DEFAULT;
					nServerStyleOnOff[i] = 1;
					break;
				default:
		            nServerStyleFontColor[i]	= CLR_DEFAULT;
		            nServerStyleBackColor[i]	= CLR_DEFAULT;
					break;
			}
		}
	}

	// background styles
	ini.SerGet(true, nBackgroundStyleFlags,		ELEMENT_COUNT(nBackgroundStyleFlags), L"BackgroundStyleFlags");
	ini.SerGet(true, nBackgroundStyleBackColor,	ELEMENT_COUNT(nBackgroundStyleBackColor), L"BackgroundStyleBackColor");

	for (int i=0;i<style_b_count;i++)
	{
		if ((nBackgroundStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
//			switch(i)
			{
//				default:
		            nBackgroundStyleBackColor[i]	= CLR_DEFAULT;
//					break;
			}
		}
	}

	// window styles
	ini.SerGet(true, nWindowStyleFlags,	ELEMENT_COUNT(nWindowStyleFlags), L"WindowStyleFlags");
	ini.SerGet(true, nWindowStyleBackColor,	ELEMENT_COUNT(nWindowStyleBackColor), L"WindowStyleBackColor");

	for (int i=0;i<style_w_count;i++)
	{
		if ((nWindowStyleFlags[i] & STYLE_USED) != STYLE_USED)
		{
//			switch(i)
			{
//				default:
		            nWindowStyleBackColor[i]	= CLR_DEFAULT;
//					break;
			}
		}
	}

	// import v1 settings
	if(iVersion == 0)
	{
		DWORD nStyleFlags[33];
		COLORREF nStyleFontColor[33];
		COLORREF nStyleBackColor[33];
		short nStyleOnOff[33];

		ini.SerGet(true, nStyleFlags,		ELEMENT_COUNT(nStyleFlags), L"StyleFlags");
		ini.SerGet(true, nStyleFontColor,	ELEMENT_COUNT(nStyleFontColor), L"StyleFontColor");
		ini.SerGet(true, nStyleBackColor,	ELEMENT_COUNT(nStyleBackColor), L"StyleBackColor");
		ini.SerGet(true, nStyleOnOff,		ELEMENT_COUNT(nStyleOnOff), L"StyleOnOff");

		int iMaster = client_styles;
		int iSub = style_c_default;
		for (int i=0;i<33;i++)
		{
			if((nStyleFlags[i] & STYLE_USED) == STYLE_USED)
			{
				SetStyleFlags(iMaster, iSub, nStyleFlags[i]);
				SetStyleFontColor(iMaster, iSub, nStyleFontColor[i]);
				SetStyleOnOff(iMaster, iSub, nStyleOnOff[i]);
				SetStyleBackColor(iMaster, iSub, nStyleBackColor[i]);
			}

			iSub++;
			if(i == 7)
			{
				iSub = style_d_default;
				iMaster = download_styles;
			}
			else if(i == 15)
			{
				iSub = style_s_default;
				iMaster = share_styles;
			}
			else if(i == 26)
			{
				iSub = style_b_clientlist;
				iMaster = background_styles;
			}
		}
	}
}
//<== dlarge Design Settings 